Updated on Sep 23, 2026

Modern jQuery scheduler with configurable daily & weekly time grid

Use it in responsive mobile & desktop web apps with jQuery

Recurring events
Multi-day events
Popover with full event list
Drag & drop
Templating
Resource support
Customizable times
Drag & drop
Manage multiple resources
Daily, weekly or monthly timeline
Drag & drop
Customizable range
Scroll to date
Recurring events
Templating
Daily, weekly or monthly agenda

The scheduler features a time grid - vertically scrollable daily, weekly, monthly and custom views with built in resource support, templating and drag & drop.
The four views - scheduler, calendar, timeline, agenda - can be combined to create the perfect user experience on mobile, desktop and on everything in-between.

The capabilities like recurring events, all-day, multi-day events, responsiveness, multiple timezones are supported by all views.

As part of Event calendar and scheduler it can be picked up with the Scheduling & calendaring and Complete licenses.

jQuery Scheduler Scheduler for jQuery and jQuery Mobile

Scheduler - Mobile Day View

Change demo

View daily schedules with a fixed week view at the top and a scrollable schedule for the day. The week view is optional and can be turned off.

All-day events are fixed at the top below the header and calendar.

The dates can be quickly navigated by clicking on the month & year indicator.

Interested in weekly schedule?  Explore this example →
Copy code
View code on GitHub

Scheduler - Daily View

Change demo

Daily schedules can be displayed on large screens as well as small screens.

All-day events are fixed at the top below the header and calendar, while the schedule view is scrollable.

The dates can be quickly navigated by clicking on the month & year indicator.

Interested in weekly schedule?  Explore this example →
Copy code
View code on GitHub

Scheduler - Week View on Mobile

Change demo

A full week can be rendered on small screens if needed. The header with the days of the week fixed at the top while the schedule is scrollable.

The screen can easily become crowded so it might be a good idea to think in a responsive implementation - daily schedule on small screens and weekly schedule on bigger screens.

Interested in daily schedule?  Explore this example →
Copy code
View code on GitHub
mobiscroll.setOptions({
  locale:  ,
  theme: ' ',
  themeVariant: ' '
});

$(function () {
  var inst = $('#demo-mobile-week-view')
    .mobiscroll()
    .eventcalendar({
      clickToCreate:  ,
      dragToCreate:  ,
      dragToMove:  ,
      dragToResize:  ,
      eventDelete:  ,
      view: {
        scheduler: { type: 'week' },
      },
      onEventClick: function (args) {
        mobiscroll.toast({
          message: args.event.title,
        });
      },
    })
    .mobiscroll('getInst');

  $.getJSON(
    'https://trial.mobiscroll.com/events/?vers=5&callback=?',
    function (events) {
      inst.setEvents(events);
    },
    'jsonp',
  );
});
  
<div id="demo-mobile-week-view" style="height:100%;"></div>
  
Show a full week on mobile with the Scheduler — weekly schedule with all-day and timed events, scrollable time grid, and fixed header.

Scheduler - Week View

Change demo

Render a full weeks worth of schedule on the screen. The header with days of the week remains planted at the top while the grid with the hours of the week and scheduled events is scrollable.

The current hour is displayed so that upcoming events can be spotted easily.

Interested in daily schedule?  Explore this example →
Copy code
View code on GitHub

Scheduler - Responsive Day and Week Views

Change demo

The scheduler is fully responsive, it adapts to the available space and fills the screen to look good everywhere.

Use the responsive option to configure how the scheduler behaves on different sized screens. You can set it up as a daily schedule view on small screens and a weekly schedule on bigger screens.

The responsive option is equipped with five breakpoints - xsmall, small, medium, large, xlarge - and custom values can be added for a perfect fine-tune.

Change the viewport

Scheduler - Custom Column Widths

Change demo

Customize the width of scheduler columns using the .mbsc-schedule-col-width CSS class. This allows you to define fixed or dynamic column widths to fit your layout needs.

When using resources, the defined width is applied to resource columns. If no resources are present, it applies to day columns instead.

Interested in individually adjusting resource widths?  Discover how →

Scheduler - Print and PDF Export

Change demo

The scheduler includes print optimized styling through the print add-on. This needs to be added to the download package or installed separately from a dedicated NPM package.

Print styling is applied when someone prints the page that contains the scheduler. In addition to that, you can call the print method on the instance which grabs only the markup of the scheduler, places it onto a temporary page and calls the browsers printing function. This is especially useful when you want to add a button to only print the scheduler rather than the whole page.

Besides printing, PDF export is possible through the print dialog of the browser.

The print module is not available in the trial. You can try the live demo to see how it looks.

Scheduler - Work Week

Change demo

Customize the scheduler by not only disabling certain hours but hide them through setting the startTime and endTime properties of the view.schedule option. Quikcly set up a work calendar that goes from Monday through Friday with the startDay and endDay properties and renders the schedule from 8AM to 6PM.

You can easily add breaks - like a "Lunch break" - or disable times with the invalid option.

Copy code
View code on GitHub

Scheduler - Appointment Booking Demo

Change demo

The scheduler can be set up for scheduling/unscheduling booked appointments. Simply set up a daily schedule view with multiple resources representing dentists or doctors. Next to the calendar you can render a list of unscheduled appointments.

Enabling advanced validation and combining that with the drag & drop between the calendar and external list on a resource to resource basis you got a pretty nice working base for appointment scheduling that can be further customized.

Copy code
View code on GitHub

Scheduler - Doctors Availability

Change demo

You can tailor the scheduler to show availability per doctor using visual indicators in each column. Availability is marked with a green status track on the left side of each doctor's column, making open slots easy to spot and supporting quick scheduling decisions.

To create the visual indicator, we added extra resource columns with a narrow width, styled using a custom CSS class set via the cssClass property in the resource data. The availability track is shown using events placed on these columns, with their content hidden via renderSchedulerEvent option and resized responsively based on the narrow resource column width. Time ranges outside each doctor's working hours are disabled to reflect their actual schedule.

Copy code
View code on GitHub

Scheduler - 24-Hour Rotating Crew Shift Rota

Change demo
24-Hour Rotating Crew Shift Rota
Download and try example View code on GitHub

The scheduler can be configured for industrial or service environments requiring 24/7 coverage, such as manufacturing lines or critical infrastructure maintenance. This setup uses three resources (Crew A, Crew B, Crew C) to demonstrate a cyclical, rotating roster, like the 3-Crew, 3-Shift Rota.

To visualize the continuous operation and manage shifts that span midnight, the scheduler view is configured with a custom, 24-hour cycle, starting at 06:00 and ending at 06:00 the following day. This is achieved using the custom day-offset feature added to the startTime (e.g., '20:00-1') and endTime (e.g., '08:00+1') properties under the view option, which initiates the view relative to the previous or next calendar day. Furthermore, to ensure compliance with 8-hour shift lengths and prevent invalid scheduling, the drag-and-drop functionality is constrained by setting the dragTimeStep to 8 hours, requiring all events to be moved only in 8-hour increments and anchoring the alignment with the dragTimeStepBase: 'viewStart' option. The drag-and-drop logic is implemented for automatic conflict resolution: when an event is dragged to a different time or resource column within the same day, it automatically updates and shifts any conflicting events (those sharing the same time slot or resource column) to maintain scheduling integrity and prevent overlaps.

Copy code
View code on GitHub

Scheduler - Drop Assignee on Event

Change demo

Assigning people to meetings that are already booked across multiple rooms is a common scheduling challenge. Instead of dropping external items onto the calendar grid to create new events, the goal here is to drop them onto existing events, turning each meeting into an individual drop target where attendees can be assigned directly.

This is where the dropcontainer comes in. Each event rendered through the renderSchedulerEvent function is initialized as a drop container, turning every meeting card into a valid drop zone. The external list of team members is set up using the draggable component, so each person can be grabbed and dropped onto any event on the scheduler. The onItemDrop event handles the assignment, while onItemDragEnter and onItemDragLeave provide real-time visual feedback.

Beyond simple assignment, the demo includes practical validation. Before accepting a drop, it checks whether the person is already assigned to the target meeting and whether they have a time conflict with another meeting in the same slot. Assignments can also be removed by clicking on an attendee chip, with an undo option.

Looking for dropping external items onto the calendar grid instead?  Check out the external drag & drop example →
Copy code
View code on GitHub

Scheduler - Custom Range View

Change demo

The scheduler comes with built-in support for day, week and month views. For those situations where a custom range makes more sense, it is possible to override the calendar navigation component with a range picker.

The calendar header can be easily customized and a two-way synchronization needs to be kept between the scheduler and range picker.

Copy code
View code on GitHub

Scheduler - Limit Overlapping Events

Change demo

The scheduler renders all concurrent (overlapping) events by default, and the available horizontal space will be divided between them. When there are a lot of concurrent events, displaying all of them isn't always helpful.

A maximum number of concurrent events can be set by passing a number to the maxEventStack property of the view.scheduler option.

Alternatively maxEventStack: 'auto' can also be set, in this case the value will be determined automatically, based on the available horizontal space. It's poosible to also set a minimum event width, using the minEvenWidth property of the view.scheduler option. If not specified, it defaults to 50px;

Scheduler - Custom Date Range View

Change demo

The scheduler has three types: day, week and month. Use the size property of the configuration object to set the length of the range.

Multiples of days, weeks and months are supported. The reference date, controlled through the refDate option, is today by default, but it can be set to any date, like the first day of the month, or the first day of the year. The refDate serves as the start of the reference range. From that point on you can navigate forward and backward.

A couple of examples:

  • Rolling two weeks - use type: 'day' and size: 14
  • Rolling ten days - use type: 'day' and size: 10
  • Two weeks (starting with Sun/Mon) - use type: 'week' and size: 2
  • Quarter view, starting from January - use type: 'month' and size: 3 with refDate: '2021-01-01'
  • Rolling three months - use type: 'month' and size: 3
  • Year view - use type: 'month' and size: 12 with refDate: '2021-01-01'

Scheduler - Hide All-Day Section

Change demo

Hide the all-day events section of the scheduler by setting the allDay property under the view.scheduler option.

Scheduler - Color-Coded Time Blocks

Change demo

Color the background of entire days or time ranges with the colors option. You can specify backgrounds as exact dates, ranges or set up recurring rules. The recurring object works the same way as for the events. Optionally, you can specify a title as well, which will be displayed on the colored block.

Use the onPageLoading lifecycle event to color backgrounds runtime. You can learn about lifecycle events and places where to drop logic to customize the experience.

Want to use patterns as backgrounds and customize how the invalid cells look?  Learn how to do it →
Copy code
View code on GitHub

Scheduler - Switch Between Calendar and Scheduler Views

Change demo
Switch Between Calendar and Scheduler Views
Download and try example View code on GitHub

Dynamically switch views within one instance. Use a UI control to let users do the switching or do it programmatically.

The example features a month view with events as labels, a weekly schedule view, a daily schedule and a weekly agenda. Use the setOptions method to dynamically change the settings.

Copy code
View code on GitHub

Scheduler - Visible hours and days

Change demo

Customize the visible days and hours along with the scale of the time grid through the scheduler object under the view option. You can control the days to display (eg. Weekdays), the visible time range (eg. 8AM to 6PM), set the time scale (eg. 30 minutes) and set the labels shown (eg. every 15 minutes).

  • Specify the first and last day - Use the startDay and endDay properties
  • Set the visible time range - Use the startTime and endTime properties
  • Shift the visible time window - Use the startTime and endTime properties to include ranges that extend into the previous or next day
  • Control the visibility of empty columns - Use the hideEmptyColumns property
  • Control the visibility of fully invalid columns - Use the hideInvalidColumns property
  • Control the granularity of the time grid - Use the timeCellStep and timeLabelStep properties
Building a work calendar?  Check out this example →

Scheduler - Timezone Support

Change demo

The event calendar works with local times by default, but ships with support for changing the timezone. The conversions and correct output relies on either of these three external libraries: luxon, moment-timezone and day.js. For installing and using these libraries check out this guide.

There are two angles regarding timezones:

  • dataTimezone - the calendar expects this format and returns this format. It is 'local' by default if the date-times don't contain any timezone information.

It can be set globally on the calendar using the dataTimezone option, or specifically for the event using the timezone property of the event data.

  • displayTimezone - the calendar displays the events in this timezone. The date-times will be converted from the dataTimezone and displayed accordingly. It is 'local' by default
Enable switching the timezone in the UI?  Learn how to dynamically change timezones →

Scheduler - Event Buffer

Change demo

Use the bufferBefore and bufferAfter to add buffer times that will be rendered before and after the event.

These areas can help you visualize delays or added minutes for tasks. Here are some examples:

  • Travel time for meetings, appointments, work orders
  • Check in and check out times around flights
  • Loading/unloading for bus/truck
  • Cleaning, inspection, maintenance work that happen on a recurring basis
Looking to customize event buffers?  Check out the templating capabilities →

Scheduler - Multiple Timezone Support

Change demo

If the context requires users being able to change the timezone on the fly, you can add a custom dropdown with the desired timezones to the event calendar header. This can be of course placed externally to the calendar as well, eg. setting page.

Set the timezone of the incoming data through the dataTimezone - eg. 'utc', and set the display timezone through the displayTimezone - eg. 'America/Los_Angeles'

Wanna show multiple timezone tracks?  Check out the next example →
Copy code
View code on GitHub

Scheduler - Custom Event Order

Change demo

The rendering engine uses the following two concepts to determine how the events are rendered:

  1. Event data order
  2. Event layout

The data order is determined by the following logic:

  • All-day events are placed at the top
  • Non-all-day events follow, sorted by their start times
  • Events with the same start time are ordered alphabetically by their title

The event layout process determines the visual positioning and dimensions of events. This is a built-in functionality and cannot be altered externally. The layout algorithm processes the sorted event list and calculates each event's position and size. The algorithm follows these steps:

  1. The first event is placed in the first position of the event column
  2. If two or more events overlap in their start/end times, the later event is placed in the next event column, positioned after to the previous event
  3. If a subsequent event does not overlap with any already added events, it is placed back in the first event column
  4. This process continues until all events are positioned within their respective columns

The order property of the event data can be used to override the default ordering. The order property takes precedence over the default rules. If two events have the same order value, the default rules apply. For a more advanced order logic, the eventOrder option can be used which expects a function that compares two events and returns an order (-1 or 1).

Do you want to learn about the event ordering?  Learn more about it in the documentation →
Copy code
View code on GitHub

Scheduler - Multi-Timezone

Change demo

When operating across multiple timezones, coordinating resources and getting people on the same page is a challenge. It helps if events can be seen across these timezones.

Use the timezones property of the view.scheduler option and set the timezone tracks with custom labels. The order of the tracks is determined by the order they are added to the array.

Copy code
View code on GitHub

Scheduler - Event Search Sidebar

Change demo

Inline search can be easily implemented with the help of a separate agenda instance. This example is relying on a single API endpoint for getting the data onto the primary schedule view and also for getting the filtered data based on the search terms.

Events can be filtered in real time so using an agenda view for the search results is an easy choice. It provides all the necessary styling and advanced features that you might need to customize the experience.

Alternatively, search can be implemented in the header using a similar search box with an agenda listed in a popup instead of rendered inline.

Copy code
View code on GitHub

Scheduler - External Date Navigation

Change demo

This example demonstrates how can the Scheduler navigated externally. Here we have a two-pane layout with a Datepicker on the left and a Scheduler on the right. Changing date on the Datepicker will trigger the date change on the Scheduler.

The Datepicker calls the navigate method of the Scheduler in its onChange event, while the Scheduler sets the datepicker value with the setVal method from its onSelectedDateChange event.

Copy code
View code on GitHub

Scheduler - Custom Event Tooltip

Change demo

There are several approaches to showing a tooltip when hovering events.

The native tooltip

By default, the calendar shows the browser native tooltip when hovering over the event. This includes the times and title of the event, which does the job most of the times. For showing a custom text use the tooltip property of the data object. This tooltip is specific to every event. If you want to hide the native tooltip, you can set the showEventTooltip to false.

Fully custom tooltip

Setting the showEventTooltip to false gives room for a fully custom tooltip that can be implemented by using the onEventHoverIn and onEventHoverOut lifecycle events. With the help of the Mobiscroll popup you can show a custom tooltip that holds details, actions applicable to the event it is anchored to.

Showing a third party popup

There are cases when you are using a third party library, something like md-boostrap. For those cases, turn the browser native tooltip off with the showEventTooltip option and use the third-party tooltip accordingly. In case of md-boostrap, you can add the tooltip directive to the custom event template so that the library knows where and when to show the tooltip.

Copy code
View code on GitHub

Scheduler - Custom Event Rendering

Change demo

Above the built in rendering mode you can either customize the full event or just the content of the event. If we break up the event into pieces there are six fields that we are interested in:

  • The event start and end time
  • Whether it is an allDay event or not
  • The event color
  • The event title
  • bufferBefore
  • bufferAfter

The scheduler takes care of positioning the event container and everything else is your responsibility. You will have to place and provide styling to all event fields. Beside the ones mentioned above you'll be able to render other custom fields, like description, location, participants ... and add buttons, custom interactions.

Pass a custom rendering function to the renderSchedulerEvent option. All original event fields along with computed fields like isMultiDay, lastDay can be reached inside the function.

The before/after buffers can help you visualise delays or added minutes for tasks. For example travel time for meetings/appointments, check in/check out for flights.

The buffers can be customized through the renderBufferBefore and renderBufferAfter options.

Copy code
View code on GitHub

Scheduler - Custom Date Header

Change demo

Customize the date headers of the scheduler by adding relevant content, labels or completely change how they look. Use the renderSchedulerDay option for rendering a custom date header.

Copy code
View code on GitHub

Scheduler - Custom Resource Headers

Change demo

Use the renderResource option for rendering a custom resource header. Customize how the resource headers look and what they show. Utilize properties passed in the resources array.

Interested in displaying resource information on hover?  Show details on hover →
Copy code
View code on GitHub

Scheduler - Custom Cell Content Template

Change demo

Events appear over scheduler cells, which provide a great background layer for information. They can be disabled, styled with colored backgrounds, or used to present rich content.

Cell content in the scheduler can be customized using the renderCell option. The callback receives cell data such as the date, resource, and overlapping events in the cell. This lets you add custom content like icons or badges to cells based on their data. It's useful for showing holidays, availability, or statuses.

Cells can be hourly, 30 minute long, or however it is setup using the timeCellStep option.

Copy code
View code on GitHub

Scheduler - Custom Header

Change demo

You can customize how the header of the scheduler looks and how the components are arranged. Besides that you can also add custom functionality, like a segmented control that lets people switch between scheduler and calendar.

Use the renderHeader option for passing a custom header layout. There are predefined components - shorthands if you will - that can be used to assemble the header:

  • Navigation component - <div mbsc-calendar-nav></div>. Use the .md-header-filter-controls CSS class for custom overrides.
  • Today button - <button mbsc-calendar-today></button>. Use the .md-header-filter-today CSS class for custom overrides.
  • Previous month button - <button mbsc-calendar-prev></button>. Use the .md-header-filter-prev CSS class for custom overrides.
  • Next month button - <button mbsc-calendar-next></button>. Use the .md-header-filter-next CSS class for custom overrides.

For changing the order the controls are laid out, you only need to set up the renderHeader. This example sets a consistent order and layout across all themes and shows a custom control at the far right end.

Overriding the order for specific themes

For a custom order on a theme to theme basis, you will need to use a little CSS. Flex layout makes reordering easy. It's just a matter of setting the order in CSS. For material use the .mbsc-material, for windows the .mbsc-windows prefix and for iOS it is .mbsc-ios class. Eg.:

.mbsc-material .md-header-filter-prev { order: 1; }
            .mbsc-material .md-header-filter-next { order: 2; }
            .mbsc-material .md-header-filter-controls { order: 3; }
            .mbsc-material .md-header-filter-today { order: 4; }
Want to add a filter to the header?  Check out the next example →
Copy code
View code on GitHub

Scheduler - Drag, Resize and Create Events

Change demo

Drag & drop is a core feature of the event calendar and it is composed of four sub-features:

  • Click to create events - double click to create events. This can be turned off or set to single click
  • Drag to create events - tap/click to start creating an event and drag to the desired length
  • Move events - grab an event and move it wherever needed
  • Resize events - change the length of an event, grab it from either end and resize it
  • Delete events - pressing the Delete or Backspace keys on the keyboard will delete the focused event

You have granular control over features through the clickToCreate, dragToCreate, dragToMove, dragToResize and eventDelete options, which are false by default.

Use the dragTimeStep option (defaults to 15 minutes) to set the snap resolution of all drag actions.

Events can be marked as fixed by setting their editable property to false. This turns delete, drag & drop move and resize off for the event. The mbsc-event-readonly CSS class will be added to the events. This means if you would like to add opacity, override the mouse cursor or apply any other CSS override, you can add it to this class.

Scheduler - Drag, Resize & Move Restrictions

Change demo
Drag, Resize & Move Restrictions
Download and try example View code on GitHub

The drag & drop interactions can be fine-tuned depending on the requirements and situations. Maybe controlled by roles, event types, resources the move and resize can be turned on/off on an event basis, per resource or globally on the instance.

  • Events can be fixed in length (cannot be resized) - by setting dragToResize option to false the events cannot be resized.
  • Events can be fixed in time (cannot be moved) - by setting dragInTime option to false the events cannot be moved in time. Take in consideration that dragToMove must be set to true
  • Events can be fixed to resource (cannot be moved to another resource) - by setting dragBetweenResources option to false the events cannot be moved between resources. Take in consideration that dragToMove must be set to true

To control this on a resource an event basis, use the appropriate properties which have precedence over global calendar options.

Scheduler - Instance Event Transfer

Change demo

There are certain cases when moving the events between calendars can come in handy.

Dragging and dropping events between two scheduler instances can be enabled by turning on the externalDrag and externalDrop options.

Copy code
View code on GitHub

Scheduler - Blocked Time Ranges

Change demo

Entire days and time ranges can be blocked out to manage event creation and editing more efficiently.

To disable specific times, ranges, days or recurring days and times you can pass an array to the invalid option. A couple of examples:

  • To disable weekends, use the recurring object - recurring: { repeat: 'weekly', weekDays: 'SA,SU' }
  • Lunch break between 12 PM and 1 PM with title - { start: "12:00", end: "13:00", title: 'Lunch break', recurring: { repeat: 'weekly', weekDays: 'MO,TU,WE,TH,FR' }

When dragging events onto disabled days or time-slots, they will automatically be denied and onEventCreateFailed / onEventUpdateFailed events will be triggered, from which custom logic can be executed to show a toast or maybe a modal for data correction. The built-in logic of how the calendar handles validation on user interaction can be controlled through the invalidateEvent option:

  • 'strict' - Strict being the default, no event overlap is allowed with invalid ranges.
  • 'start-end' - With start-end validation the calendar checks if the start or end of the event coincides with any invalid range. Other overlaps are allowed.

If you're interested in invalids for a given range (including recurring occurrences), you can use the getInvalids function.

Want to prevent double booking?  Learn how to manage event overlaps →

Scheduler - Prevent Double Booking

Change demo

Sometimes it is necessary to guarantee that events don't overlap - eg. when scheduling workorders, interacting with a work calendar. You can reject the updates or additions and let the user know about it.

The event overlap can be turned on/off on an event basis, per resource or globally on the instance.

  • On an event basis - by setting the overlap property to false the specified event cannot overlap.
  • Per resource - by setting the eventOverlap property to false the events in the specified resource cannot overlap.
  • Globally on the instance - by setting eventOverlap option to false overlap is disbled globally.

If set to false, the resource and the event settings have precedence over the global calendar eventOverlap option.

Give feedback to the user - optionally, a toast can be displayed to explain why an event cannot be dropped, moved or created. For this we can use the onEventCreateFailed and onEventUpdateFailed lifecycle events.

Looking to implement time off or block out ranges?  Learn how to add lunch breaks, working hours and disable weekends →

Scheduler - External Drag and Drop

Change demo
Dragging events on the Mobiscroll event calendar

Events can be scheduled by dragging and dropping an external item onto the scheduler with Mobiscroll draggable. In order for that to work you will need to have two things set up:

  • Enable the scheduler to receive external events by setting externalDrop to true.
  • Initialize the external events (containers) as draggable components.

Set up a container as draggable with the mbsc-draggable attribute. Pass a skeleton event definition through the data-drag-data attribute as a stringified json object. This will be added to the event calendar on drop. If omitted, a default event will be created. For a more programmatic approach you might want to use the component initialization where the draggable is initialized in js code and the dragData can be passed as an object.

Working together with SortableJS and Dragula lists

Mobiscroll provides built-in support for two widely used reorderable drag-and-drop list libraries: SortableJS and Dragula. If you are already using any of these libraries to reorder list items, they can be seamlessly integrated with the scheduler. This integration enables a smooth workflow where items can be dragged from external lists and scheduled directly onto the calendar.

Events can be created and scheduled by dragging items from third-party lists into the event calendar. To enable this behavior you will need to:

  • Allow the scheduler to receive external drops by setting externalDrop.
  • Use the sortableJsDraggable or dragulaDraggable plugins to connect the third-party list with the scheduler.

The event data will be read from the dragged element's data-drag-data attribute, or the plugin's options expose an eventData function where the event definition (title, start, end, resource, etc.) can be specified.

You can then handle the calendars lifecycle events such as onEventCreate, onEventCreated or onEventCreateFailed to run custom logic (e.g. showing a toast) when a drop succeeds or fails.

Unscheduling events (or dragging them off a calendar)

Additionally events can be unscheduled by dragging them out from the scheduler and dropping them onto an external drop container. To activate this, you will need to:

  • Enable the scheduler to allow dragging events out by setting externalDrag to true.
  • Initialize the

dropcontainer.

Events can also be dropped on another event calendar with externalDrop enabled.

When an event is dropped into an external drop container or another calendar, it will be deleted from the original calendar and the onEventDelete will be fired.

You can also use the onEventDragLeave and onEventDragEnter, and the drop container's onItemDragEnter and onItemDragLeave events to provide visual feedback or running custom logic during drag.

Learn more from the external drag & drop documentation.

Unscheduling events to SortableJS and Dragula lists

Dropping events from the Eventcalendar to SortableJS and Dragula lists is also possible with the sortableJsDraggable and dragulaDraggable plugins. To enable this behavior you will need to set the following under the options configuration:

  • Allow the list to receive external drops by setting exteralDrop to true
  • Use the onExternalDrop callback to update the content of the third-party list. The function arguments return the afterElement - the list element before which the clone is dropped,

container - the list container, dragData - the dragged event data, position - the index where the clone is dropped on the list.

For details, and option lists see the externalDrop section in the documentation

Looking for external drag into a calendar?  Check out this example →
Copy code
View code on GitHub

Scheduler - External Preset Task Scheduling

Change demo

Use external draggable events to create preset tasks that people can quickly copy and spawn events from. A great example is an auto repair shop where among others, mechanics have to perform the same predefined tasks.

Print a list of predefined tasks and initialize them as draggable elements. Enable externalDrop for the scheduler and set up the predefined event skeletons for the draggable component.

Whenever there is more information to be captured, like detailed task notes, customer information, the name of the technician... you can trigger a popup with the task form in the onEventCreate lifecycle event. For failed drops (trying to schedule a task during lunch breaks or weekends) the event-create-failed onEventCreateFailed event will be triggered.

Want to see how external presets look & feel for a calendar?  Check out this example →
Copy code
View code on GitHub

Scheduler - Multi-Resource View

Change demo

The scheduler can handle multiple resources inside a single instance. Pass the resource list to the resources option with an id, name, color and eventCreation.

  • id - This is an id that can be referenced in the event data
  • name - The name of the resource that will be printed at the top of the respective column
  • color - The color controls the default event color of the resource. Event colors can be specific above this. If the color is omitted the underlying events will inherit the default calendar color
  • eventCreation - This controls if events can be created or dropped onto this resource

The resources in which the resources appear follows the order of the array passed to the component.

Events can be shared between resources and it is possible to move events between resources. The move is handled automatically however you can block it if moving an event from one resource to the other is prohibited. Learn about lifecycle event hooks.

Copy code
View code on GitHub

Scheduler - Group by Resource or Date

Change demo

Resources show up in the header of the calendar as the primary group and below them are the days. This can be switched up through the groupBy option that expects 'resource' or 'day'.

Combined with the day and week-view you can help people quickly find what they are looking for. Learn how to add an integrated segmented control to the header.

Scheduler - Shared Events Across Resources

Change demo

Events can be shared among resources. This can easily be the same resource type, like people in a shared work calendar scenario or different resource types, like aircraft and instructor in a flight training scenario where you'll have to schedule an instructor and an aircraft for a class which is the event.

Shared events will render correctly in the appropriate resource columns with drag & drop, validation across invalid dates and times will work out of the box. All you need to do is to add both resourceIDs to the event.

Copy code
View code on GitHub

Scheduler - Dynamic Resource Filtering

Change demo

Resources can be dynamically turned on and off. This will show or hide the resource and can be done runtime the same way as for any other calendar option.

Copy code
View code on GitHub

Scheduler - Dynamic Resource Widths

Change demo

When resource content varies, fixed widths might not work well. To handle this, you can define a few preset width classes in CSS, and assign them conditionally using the cssClass property in the resource data based on the content.

This approach lets you adapt the layout dynamically and ensure each resource column has the right width for its content.

Copy code
View code on GitHub

Scheduler - Resource Data Structure

Change demo

The resource data structure for the scheduler is straightforward with a couple of base properties that the component understands and uses to render the UI. Besides the base properties you can add any custom property, like title, job ...

  • id - This is an id that can be referenced in the event data
  • name - The name of the resource that will be printed at the top of the respective column
  • color - The color controls the default event color of the resource. Event colors can be specific above this. If the color is omitted the underlying events will inherit the default calendar color
  • eventCreation - This controls if events can be created or dropped onto this resource
  • eventDragBetweenResources - Specifies whether the events in the specified resource are movable across resources. If set to false has precedence over dragBetweenResources option of the calendar.
  • eventDragInTime - Specifies whether the events in the specified resource are movable in time. If set to false has precedence over dragInTime option of the calendar.
  • eventResize - Specifies whether the events in the specified resource are resizable. If set to false has precedence over dragToResize option of the calendar.
  • eventOverlap - Specifies whether the events in the specified resource are allowed to overlap. If set to false has precedence over eventOverlap option of the calendar.

Scheduler - Hide Resources

Change demo

The scheduler can automatically hide non-working resource columns using the hideInvalidColumns property of view option.

The calendar is set to a weekly view (Monday to Friday, 8:00–20:00) and displays multiple doctors as resources, each with unique working days. Recurring invalids are used to mark specific weekdays when a doctor is unavailable, while static invalids indicate individual days off. As a result, only the columns for resources who are working on a given day are shown, making the schedule cleaner and easier to read. This approach is ideal for managing staff with varying shifts and availability.

Copy code
View code on GitHub

Scheduler - Event Data Structure

Change demo

The event data structure for the scheduler is straightforward with a couple of base properties that the component understands and uses to render the UI. Besides the base properties you can add any custom property, like location, description ...

  • id - A unique ID for the event. If not specified a unique id will be generated
  • title - Defines the event text. This can be plaintext or HTML
  • tooltip - Defines the text for the tooltip which appears on mouse hover. If not specified, it will show the title and the start/end times of the event.
  • color - Defines the event color
  • start - Sets the start date and time for the event. It can be a js date object, ISO date string or moment.js object. Learn about date formats
  • end - Sets the end date and time for the event. The same formats are supported as for start
  • allDay - Configures the event as a full-day event
  • recurring - Configures the recurring rules for the event. Learn about recurring events
  • recurringException - Represents the exceptions of a recurring event, when specific dates need to be skipped from the rule.
  • recurringExceptionRule - Represents the exception rule of a recurring event, when recurring dates need to be skipped from the rule.
  • resource - Links the event to one or more resources. Expects a list of IDs from the resources array
  • timezone - The timezone where the event takes place. If specified, it takes precedence over the calendar's specified dataTimezone.
  • dragBetweenResources - Specifies whether the event is movable across resources. If set to false has precedence over eventDragBetweenResources property in resources and the dragBetweenResources option of the calendar.
  • dragInTime - Specifies whether the event is movable in time. If set to false has precedence over eventDragInTime property in resources and the dragInTime option of the calendar.
  • resize - Specifies whether the event is resizable. If set to false has precedence over eventResize property in resources and the dragToResize option of the calendar.
  • overlap - Specifies whether overlap is allowed on the event. If set to false has precedence over eventOverlap property in resources and the eventOverlap option of the calendar.
  • editable - Denotes if the event is editable. If set false, the event cannot be dragged, resized or deleted even if globally enabled
  • cssClass - A custom css class for the event. Useful for quick styling adjustments of the event container.
  • bufferBefore - Defines a buffer time in minutes that will be rendered before the start of the event. This buffer area can help you visualise delays or added minutes for tasks.

For example travel time for meetings/appointments, check in before a flight.

  • bufferAfter - Defines a buffer time in minutes that will be rendered after the end of the event. This buffer area can help you visualise delays or added minutes for tasks.

For example travel time after meetings/appointments, check out after flights, inspection, cleaning after certain tasks.

  • order - Specifies the order of the event in the event array. Has precedence over the default ordering rules.

Scheduler - Date Input Formats

Change demo

Understanding how to work with dates inside the scheduler is essential. You can pass to the data, marked, colors and labels in four different formats. The scheduler can work with Javascript date objects, ISO strings and Moment.js objects.

Scheduler - Recurring Events

Change demo

Configure daily, weekly, monthly and yearly recurring events. On top of setting up recurrence, you can exclude specific and recurring days. This is especially useful in cases when a single occurrence of an event is deleted or is moved to a different time.

You can pass the recurrence rule in the recurring property of the event as an object or a string in RRULE format. Learn about the event data structure and where to place the recurring rules.

Use the configurator to experiment, build strings and objects that you can grab and use.

Interested in adding recurrence configuration to your UI?  Take a look at this add/edit dialog →

Scheduler - Inline Data

Change demo

What is a scheduler without any events in it? To populate it with events all you have to do is pass the event array to the data option.

In a real-world scenario you would probably load the events from a remote resource or event better, load them on demand. However the point of this example is to understand how easy it is to add events to the scheduler.

Do you want to learn about the event data sctructure?  See how the event object is built →
Copy code
View code on GitHub

Scheduler - Load Events from Remote API

Change demo

The scheduler can be populated by passing an array to the data option, that you can construct either inline or by getting it from a remote API. The important thing to remember is that events need to be in a format that the scheduler understands.

Interested in load on demand?  Dynamically load events on month change →
Copy code
View code on GitHub

Scheduler - Load Events on Demand

Change demo

The scheduler supports remote and local data sources. Besides that, events can be populated on initialization or loaded on demand.

Getting the events in real time as the user navigates improves load performance and always serves the most recent data.

Use the onPageLoading lifecycle event to load the data runtime. You can learn about lifecycle events and places where to drop logic to customize the experience.

Interested in loading events from Google Calendar?  Show events from Google Calendar →
Copy code
View code on GitHub

Scheduler - Lazy Load Events on Scroll

Change demo

The scheduler view is virtualized which means that the markup is being generated and maintained on the fly. Navigating both vertically and horizontally through scrolling fires the onVirtualLoading lifecycle event which can be used to load the data on scroll rather than load everything on initial page rendering.

This dramatically improves performance in case of a large event count since not all data is loaded in memory from start.

Copy code
View code on GitHub

Scheduler - Large Dataset Performance

Change demo

The scheduler supports virtual horizontal and vertical scrolling. The view virtualization makes it possible to work with many resources across long date ranges.

The following examples shows that navigating 20 resources across a whole month with 2000 events won't pose any problems for the browser neither on mobile or desktop.

View virtualization is always enabled and doesn't need to be turned on explicitly.

Copy code
View code on GitHub

Scheduler - Google Calendar Integration

Change demo

The event calendar comes with third party calendar integration support through the integration plugin. This needs to be added to the download package or installed separately from a dedicated NPM package.

It includes everything you need to authenticate your users, get their Google calendars and provides functions for CRUD operations. It takes care of loading the events and converts them to the required format so that they can be displayed on the Mobiscroll calendar separately or mixed with other calendars and events.

Customizing the interaction, event workflows, whether the events are read-only is up to you. In this live demo, newly created events will land in the primary calendar of the authenticated user.

This example uses the integration plugin to connect to and load events from Google Calendar and it is not available in the trial. Give the live demo a try and see how it can be configured.
Copy code
View code on GitHub

Scheduler - Outlook Calendar Integration

Change demo

The event calendar comes with third party calendar integration support through the integration plugin. This needs to be added to the download package or installed separately from a dedicated NPM package.

It includes everything you need to authenticate your users, get their Outlook calendars and provides functions for CRUD operations. It takes care of loading the events and converts them to the required format so that they can be displayed on the Mobiscroll calendar separately or mixed with other calendars and events.

Customizing the interaction, event workflows, whether the events are read-only is up to you. In this live demo, newly created events will land in the primary calendar of the authenticated user.

This example uses the integration plugin to connect to and load events from Outlook Calendars and it is not available in the trial. Give the live demo a try and see how it can be configured.
Copy code
View code on GitHub

Scheduler - Google Calendar Integration

Change demo

Event data can be loaded from remote sources, like public google calendars. Through the integration plugin you can easily show events that are available in a public calendar. The integration plugin needs to be added to the download package or installed separately from a dedicated NPM package.

You will just need the CALENDAR_ID and an apiKey from google and you should be ready to roll.

Public calendars are read-only. If you are interested in syncing private google calendars with read/write/delete access, check out this example.

This example uses the integration plugin to connect to and load events from Google Calendar and it is not available in the trial. Give the live demo a try and see how it can be configured.
Copy code
View code on GitHub

Scheduler - Add, Edit and Delete Events

Change demo
Create new events

Drag to create and click to create is enabled. Events can be created by dragging or with double clicks. As soon as the initial position is confirmed, a temporary event is created and a custom edit dialog is shown for refinement. On cancel the temporary event will be removed and on confirmation the event will stay in the calendar.

Edit existing events

Drag to resize and drag to move is enabled. Events can be reordered and resized. In addition to that, clicking on the event will open a custom dialog that enables editing the various properties.

Delete events

Delete can be implemented inside the edit dialog with a button. It's just a matter of removing it from the data object. If a dialog is not shown on click, focused events can be deleted with the backspace and delete keys.

Interested in adding recurrence configuration?  Check out this example →
Copy code
View code on GitHub

Scheduler - Bulk Event Actions

Change demo

Multiple event selection can be turned on with the selectMultipleEvents option. Selecting multiple events can be done through user interaction with CTRL/SHIFT/CMD + click or programmatically eg. click of a button or 'select all' checkbox.

Bulk operations like delete, update can be applied the selected events. Things like deleting with the backspace or delete buttons work out of the box but custom actions can be also applied. The selection can be easily retrieved and updated with the getSelectedEvents and setSelectedEvents method.

Custom actions can be performed with external buttons or with context menu activated on right-click.

Copy code
View code on GitHub

Scheduler - Recurring Event Add & Edit

Change demo

As seen in the previous example, an add/edit form can be created with custom and base event fields. While the CRUD example features delete with undo, this example shows off how to build a fully customizable recurrence editor right in the add/edit screen.

Above some common presets, like Daily, Weekly on X day, Monthly on Xth, Annually on the same day, Every Weekday a fully custom recurrence editor is implemented.

Copy & paste or delve into the code and understand how to generate recurrence objects or RRULES as seen in this live rule builder.

Copy code
View code on GitHub

Scheduler - Prevent Past Event Creation

Change demo

Sometimes we don't want users to be able to create events in the past or to alter past events. This might be role based in some cases or applied in general to the calendar.

To disable past event creation and manipulation, a couple of things need to be handled:

  • Invalidate past dates & times - this takes care of validating event drop and event creation on past dates and times that are before the past hour
  • Mark past events as fixed - to do this, set the editable property of the event object to false for the events that should remain fixed
  • Handle past occurrences of recurring events - recurring events are loaded as a single event and the occurrences are generated by the scheduler.

Moving the past occurrences need to be handled in the onEventUpdate and onEventCreate lifecycle events

  • Give feedback to the user - optionally, a toast can be displayed to give feedback to the user why an event cannot be dropped, moved and created in the past. For this we can use the

onEventCreateFailed and onEventUpdateFailed lifecycle events

Copy code
View code on GitHub

Scheduler - CSS Classes for Cell Colors and Blocked Times

Change demo
CSS Classes for Cell Colors and Blocked Times
Download and try example View code on GitHub

Besides customizing the background color of cells and setting up invalid/blocked out times you can customize how these blocks and disabled times look by passing a cssClass to the colors and invalid array elements.

The output could be a custom pattern, custom styling for the labels or anything that you'd like to render as the background. This a great way for adding special meaning to certain days and time ranges.

Copy code
View code on GitHub

Scheduler - Resource Filtering in Header

Change demo

The header of the scheduler is a canvas and an opportunity for customization. You can add custom components and enable new interaction in context.

Such an example would be a custom filter block created with the help of a segmented control and placed between the standard UI components, which are:

  • Navigation component - <div mbsc-calendar-nav></div>. Use the .md-header-filter-controls CSS class for custom overrides.
  • Today button - <button mbsc-calendar-today></button>. Use the .md-header-filter-today CSS class for custom overrides.
  • Previous month button - <button mbsc-calendar-prev></button>. Use the .md-header-filter-prev CSS class for custom overrides.
  • Next month button - <button mbsc-calendar-next></button>. Use the .md-header-filter-next CSS class for custom overrides.

For changing the order the controls are laid out, you only need to set up the renderHeader.

Overriding the order for specific themes

For a custom order on a theme to theme basis, you will need to use a little CSS. Flex layout makes reordering easy. It's just a matter of setting the order in CSS. For material use the .mbsc-material, for windows the .mbsc-windows prefix and for iOS it is .mbsc-ios class. Eg.:

.mbsc-material .mds-header-filter-prev { order: 1; }
            .mbsc-material .mds-header-filter-next { order: 2; }
            .mbsc-material .mds-header-filter { order: 3; }
            .mbsc-material .mds-header-filter-today { order: 4; }
Want to style and reorder the header?  Take a look at the previous example →
Copy code
View code on GitHub

Scheduler - Themes — iOS, Material & Windows

Change demo
Themes — iOS, Material & Windows
Download and try example View code on GitHub

The look and feel of the scheduler can be deeply customized. There are four levels of customization:

  • Base themes: Choose between iOS, Material and Windows.
  • Light or dark: Every theme has a light and dark variant. Setting the themeVariant to 'auto' will switch based on system settings.
  • Custom themes: Use the theme builder to customize the colors and make it match your brand.
  • Custom CSS: If you need further customization, the sky is the limit with CSS overrides.

You can also see how every example looks by changing the theme from the header.

Scheduler - Resource Background Styling

Change demo

Easily highlight resources or columns by adding a simple background color or craft a more specific look with the cssClass property of the resources data.

The output could be a custom background to individual resources or columns and it can be used for multiple purposes. For example:

  • Different styling for certain columns, like thicker border acting as separator.
  • Resource selection, where the selected resource has a different background.
  • Setting different backgrounds for the resource titles and grid columns.
Interested in highlighting date ranges only?  Explore this example →
Copy code
View code on GitHub

Scheduler - Cell Hover Summary Tooltip

Change demo

This demo demonstrates how to surface detailed cell summaries through tooltips when hovering over schedule cells.

Using onCellHoverIn and onCellHoverOut events, each tooltip dynamically displays the total number of events, invalid and colors in the hovered cell.

Copy code
View code on GitHub

Scheduler - Gregorian, Jalali & Hijri

Change demo

The scheduler supports multiple calendar systems. You can control it with the calendarSystem setting, and it supports the following options:

  • Gregorian - it is included by default
  • Jalali - it is the default system of the Persian calendar and is included within the Farsi language pack
  • Hijri - it is included in the Arabic language pack
Interested in localization?  Explore this example →

Scheduler - Event Hooks

Change demo

The scheduler ships with different hooks for deep customization. Events are triggered through the lifecycle of the component where you can tie in custom functionality and code.

While users interact with the UI events like onEventClick, onInit, onSelectedDateChange ... will be triggered.

For a complete list of events go to the documentation  See available lifecycle events →

Scheduler - Localization

Change demo

The components are fully localized. In case of the scheduler this covers date and time format, button copy, rtl and more. You can see how each example shows up by clicking on the small flag icon or checking the examples below.

All settings can be manually overridden  See what options the localization impacts →
Copy code
View code on GitHub

Looking for something you didn't see or have a sales question?
Ask us about it, we're here to help.

Get started with Mobiscroll for Angular

Give the components a try locally and see how they look in your project.

Get started with Mobiscroll for React

Give the components a try locally and see how they look in your project.

Get started with Mobiscroll for Javascript

Give the components a try in a starter app or see how they look in your project.

Get started with Mobiscroll for Vue

Give the components a try locally and see how they look in your project.

Get started with Mobiscroll for jQuery

Give the components a try in a starter app or see how they look in your project.

Already have an account?
Get started with Mobiscroll for Angular

Give the components a try locally and see how they look in your project.

Get started with Mobiscroll for React

Give the components a try locally and see how they look in your project.

Get started with Mobiscroll for Javascript

Give the components a try in a starter app or see how they look in your project.

Get started with Mobiscroll for jQuery

Give the components a try in a starter app or see how they look in your project.

Get started with Mobiscroll for Vue

Give the components a try locally and see how they look in your project.

Already have an account?
Simple two minute install guide for jQuery
Step 1.
Copy resources
Step 2.
Add references
Step 3.
Copy the code
Step 4.
Refresh browser
Copy the downloaded JS and CSS folder into your project

Extract the downloaded zip (download again) and grab the two folders. Make sure to place it where it can be reached from your html file.

Alternatively you can run the example using our demo app.

file-copy-arrows

Or you can just simply try and play with the examples right from the folder you just unpacked. You don't find the downloaded example? Download it again.

Include the mobiscroll CSS and JS resources in your files

Add this script before the closing </head> tag of your file. Make sure to have jQuery loaded before this.

Copy code <link href="css/mobiscroll.jquery.min.css" rel="stylesheet" />
<script src="js/mobiscroll.jquery.min.js"></script>

Make sure to have the CSS and JS files copied over as explained in Step 1.

Copy the code into your app

Grab the relevant parts and drop them into your JS, HTML and CSS files.

Copy JS
Copy HTML
Copy CSS
Take a look at what you've accomplished

Reload your application in your favorite browser

arrow-browser-reload@2x

And voilà, everything should be running smoothly.

If something is not running correctly or if there is trouble

Check out these common errors and solutions or reach out and let us help you.

Keep things running smoothly

We have sent an email with verification instructions to you. Please make sure to follow the steps and verify it's you.

In case you fail to verify the account, the trial will be interrupted.

If you have any trouble

Don't hesitate to let us know.

install-help-bck
Simple two minute install guide for Javascript
Step 1.
Copy resources
Step 2.
Add references
Step 3.
Copy the code
Step 4.
Refresh browser
Copy the downloaded JS and CSS folders into your project

Extract the downloaded zip (download again) and grab the two folders. Make sure to place it where it can be reached from your html file.

Alternatively you can run the example using our demo app.

file-copy-arrows

Or you can just simply try and play with the examples right from the folder you just unpacked. You don't find the downloaded example? Download it again.

Include the mobiscroll CSS and JS resources in your files

Add this script before the closing </head> tag of your file

Copy code <link href="css/mobiscroll.javascript.min.css" rel="stylesheet" />
<script src="js/mobiscroll.javascript.min.js"></script>

Make sure to have the CSS and JS files copied over as explained in Step 1.

Copy the code into your app

Grab the relevant parts and drop them into your JS, HTML and CSS files.

Copy JS
Copy HTML
Copy CSS
Take a look at what you've accomplished

Reload your application in your favorite browser

arrow-browser-reload@2x

And voilà, everything should be running smoothly.

If something is not running correctly or if there is trouble

Check out these common errors and solutions or reach out and let us help you.

Keep things running smoothly

We have sent an email with verification instructions to you. Please make sure to follow the steps and verify it's you.

In case you fail to verify the account, the trial will be interrupted.

If you have any trouble

Don't hesitate to let us know.

install-help-bck
Simple two minute install guide
Step 1.
Install the CLI
Step 2.
Install Mobiscroll
Step 3.
Copy the code
Step 4.
Run the app
Install the Mobiscroll CLI from npm

You will be able to configure Mobiscroll with ease in your app with the CLI

Copy command $ npm install -g @mobiscroll/cli
Install Mobiscroll in your React project

Run the following command in the root folder of your React project.

Don't have a project? Try it with our demo app.

Copy command $ mobiscroll config react

You will be prompted to log in with your mobiscroll account. Set your password here.

Working behind a proxy?

If you're working behind a proxy server, additional configuration might be needed. Please check the proxy configuration options in the documentation.

Using a CI/CD workflow?

The package will be installed from a private npm registry, which requires authentication. If your project uses a CI/CD workflow, read this guide on how to make it work.

Copy the code into your app

Grab the relevant parts and drop them into your JSX and CSS files.

Copy JSX
Copy TSX
Copy CSS
Take a look at what you've accomplished

Run $ npm start in the root folder of your app

Copy command $ npm start

And voilà, everything should be running smoothly.

If something is not running correctly or if there is trouble

Check out these common errors and solutions or reach out and let us help you.

Keep things running smoothly

We have sent an email with verification instructions to you. Please make sure to follow the steps and verify it's you.

In case you fail to verify the account, the trial will be interrupted.

If you have any trouble

Don't hesitate to let us know.

install-help-bck
Simple two minute install guide
Step 1.
Install the CLI
Step 2.
Install Mobiscroll
Step 3.
Copy the code
Step 4.
Run the app
Install the Mobiscroll CLI from npm

You will be able to configure Mobiscroll with ease in your app with the CLI

Copy command $ npm install -g @mobiscroll/cli
Install Mobiscroll in your Angular project

Run the following command in the root folder of your Angular project.

Don't have a project? Try it with our demo app.

Copy command $ mobiscroll config angular

You will be prompted to log in with your mobiscroll account. Set your password here.

Working behind a proxy?

If you're working behind a proxy server, additional configuration might be needed. Please check the proxy configuration options in the documentation.

Using a CI/CD workflow?

The package will be installed from a private npm registry, which requires authentication. If your project uses a CI/CD workflow, read this guide on how to make it work.

Copy the code into your app

Grab the relevant parts and drop them into your Component and Template files. For quick testing copy the css to into your project's style.css or style.scss.

Copy TS
Copy HTML
Copy CSS
Take a look at what you've accomplished

Run $ ng serve in the root folder of your app

Copy command $ ng serve

And voilà, everything should be running smoothly.

If something is not running correctly or if there is trouble

Check out these common errors and solutions or reach out and let us help you.

Keep things running smoothly

We have sent an email with verification instructions to you. Please make sure to follow the steps and verify it's you.

In case you fail to verify the account, the trial will be interrupted.

If you have any trouble

Don't hesitate to let us know.

install-help-bck
Simple two minute install guide
Step 1.
Install the CLI
Step 2.
Install Mobiscroll
Step 3.
Copy the code
Step 4.
Run the app
Install the Mobiscroll CLI from npm

You will be able to configure Mobiscroll with ease in your app with the CLI

Copy command $ npm install -g @mobiscroll/cli
Install Mobiscroll in your Vue project

Run the following command in the root folder of your Vue project.

Don't have a project? Try it with our demo app.

Copy command $ mobiscroll config vue

You will be prompted to log in with your mobiscroll account. Set your password here.

Working behind a proxy?

If you're working behind a proxy server, additional configuration might be needed. Please check the proxy configuration options in the documentation.

Using a CI/CD workflow?

The package will be installed from a private npm registry, which requires authentication. If your project uses a CI/CD workflow, read this guide on how to make it work.

Copy the code into your app

Grab the relevant parts and drop them into your Vue page.

Copy
Copy
Take a look at what you've accomplished

Run $ npm run dev in the root folder of your app

Copy command $ npm run dev

And voilà, everything should be running smoothly.

If something is not running correctly or if there is trouble

Check out these common errors and solutions or reach out and let us help you.

Keep things running smoothly

We have sent an email with verification instructions to you. Please make sure to follow the steps and verify it's you.

In case you fail to verify the account, the trial will be interrupted.

If you have any trouble

Don't hesitate to let us know.

install-help-bck
Customize & try this demo locally
Sign in or start your free trial

We have to set you up with a trial for this to run 👍

Demos
Scheduler Mobile Day View Daily View Week View on Mobile Week View Responsive Day and Week Views Custom Column Widths Print and PDF Export Work Week Appointment Booking Demo Doctors Availability 24-Hour Rotating Crew Shift Rota Drop Assignee on Event Custom Range View Limit Overlapping Events Custom Date Range View Hide All-Day Section Color-Coded Time Blocks Switch Between Calendar and Scheduler Views Visible hours and days Timezone Support Event Buffer Multiple Timezone Support Custom Event Order Multi-Timezone Event Search Sidebar External Date Navigation Custom Event Tooltip Custom Event Rendering Custom Date Header Custom Resource Headers Custom Cell Content Template Custom Header Drag, Resize and Create Events Drag, Resize & Move Restrictions Instance Event Transfer Blocked Time Ranges Prevent Double Booking External Drag and Drop External Preset Task Scheduling Multi-Resource View Group by Resource or Date Shared Events Across Resources Dynamic Resource Filtering Dynamic Resource Widths Resource Data Structure Hide Resources Event Data Structure Date Input Formats Recurring Events Inline Data Load Events from Remote API Load Events on Demand Lazy Load Events on Scroll Large Dataset Performance Google Calendar Integration Outlook Calendar Integration Google Calendar Integration Add, Edit and Delete Events Bulk Event Actions Recurring Event Add & Edit Prevent Past Event Creation CSS Classes for Cell Colors and Blocked Times Resource Filtering in Header Themes — iOS, Material & Windows Resource Background Styling Cell Hover Summary Tooltip Gregorian, Jalali & Hijri Event Hooks Localization
Theme Select
Material
Material Dark
iOS
iOS Dark
Windows
Windows Dark
Language Locale
See other demos and change options
Theme
Locale
See other demos

Updated on Sep 23, 2026

Serious Vue scheduler with configurable daily, weekly & monthly views

Flexible, configurable for mobile & desktop web apps and Ionic Vue projects

Recurring events
Multi-day events
Popover with full event list
Drag & drop
Templating
Resource support
Customizable times
Drag & drop
Manage multiple resources
Daily, weekly or monthly timeline
Drag & drop
Customizable range
Scroll to date
Recurring events
Templating
Daily, weekly or monthly agenda

The scheduler features a time grid - vertically scrollable daily, weekly, monthly and custom views with built in resource support, templating and drag & drop.
The four views - scheduler, calendar, timeline, agenda - can be combined to create the perfect user experience on mobile, desktop and on everything in-between.

The capabilities like recurring events, all-day, multi-day events, responsiveness, multiple timezones are supported by all views.

As part of Event calendar and scheduler it can be picked up with the Scheduling & calendaring and Complete licenses.

Vue Scheduler Scheduler for Vue JS

Scheduler - Mobile Day View

Change demo

View daily schedules with a fixed week view at the top and a scrollable schedule for the day. The week view is optional and can be turned off.

All-day events are fixed at the top below the header and calendar.

The dates can be quickly navigated by clicking on the month & year indicator.

Interested in weekly schedule?  Explore this example →

Scheduler - Daily View

Change demo

Daily schedules can be displayed on large screens as well as small screens.

All-day events are fixed at the top below the header and calendar, while the schedule view is scrollable.

The dates can be quickly navigated by clicking on the month & year indicator.

Interested in weekly schedule?  Explore this example →

Scheduler - Week View on Mobile

Change demo

A full week can be rendered on small screens if needed. The header with the days of the week fixed at the top while the schedule is scrollable.

The screen can easily become crowded so it might be a good idea to think in a responsive implementation - daily schedule on small screens and weekly schedule on bigger screens.

Interested in daily schedule?  Explore this example →
Copy code
<script setup>
import {
  getJson,
  MbscEventcalendar,
  MbscToast,
  setOptions 
} from '@mobiscroll/vue'
import { onMounted, ref } from 'vue'

setOptions({
  locale:  ,
  theme: ' ',
  themeVariant: ' '
})

const myEvents = ref([])
const toastMessage = ref('')
const isToastOpen = ref(false)

const myView = {
  scheduler: { type: 'week' }
}

function handleEventClick(args) {
  toastMessage.value = args.event.title
  isToastOpen.value = true
}

function handleToastClose() {
  isToastOpen.value = false
}

onMounted(() => {
  getJson(
    'https://trial.mobiscroll.com/events/?vers=5',
    (events) => {
      myEvents.value = events
    },
    'jsonp'
  )
})
</script>

<template>
  <MbscEventcalendar :clickToCreate="" :dragToCreate="" :dragToMove="" :dragToResize="" :eventDelete="" :view="myView" :data="myEvents" @event-click="handleEventClick" />
  <MbscToast :message="toastMessage" :isOpen="isToastOpen" @close="handleToastClose" />
</template>

  <MbscEventcalendar :clickToCreate="" :dragToCreate="" :dragToMove="" :dragToResize="" :eventDelete="" :view="myView" :data="myEvents" @event-click="handleEventClick" />
  <MbscToast :message="toastMessage" :isOpen="isToastOpen" @close="handleToastClose" />
<script setup lang="ts">
import {
  getJson,
  MbscEventcalendar,
  MbscToast,
  setOptions 
} from '@mobiscroll/vue'
import type { MbscCalendarEvent, MbscEventcalendarView, MbscEventClickEvent } from '@mobiscroll/vue'
import { onMounted, ref } from 'vue'

setOptions({
  locale:  ,
  theme: ' ',
  themeVariant: ' '
})

const myEvents = ref<MbscCalendarEvent[]>([])
const toastMessage = ref<string>('')
const isToastOpen = ref<boolean>(false)

const myView: MbscEventcalendarView = {
  scheduler: { type: 'week' }
}

function handleEventClick(args: MbscEventClickEvent) {
  toastMessage.value = args.event.title || ''
  isToastOpen.value = true
}

function handleToastClose() {
  isToastOpen.value = false
}

onMounted(() => {
  getJson(
    'https://trial.mobiscroll.com/events/?vers=5',
    (events: MbscCalendarEvent[]) => {
      myEvents.value = events
    },
    'jsonp'
  )
})
</script>

<template>
  <MbscEventcalendar :clickToCreate="" :dragToCreate="" :dragToMove="" :dragToResize="" :eventDelete="" :view="myView" :data="myEvents" @event-click="handleEventClick" />
  <MbscToast :message="toastMessage" :isOpen="isToastOpen" @close="handleToastClose" />
</template>

Show a full week on mobile with the Scheduler — weekly schedule with all-day and timed events, scrollable time grid, and fixed header.

Scheduler - Week View

Change demo

Render a full weeks worth of schedule on the screen. The header with days of the week remains planted at the top while the grid with the hours of the week and scheduled events is scrollable.

The current hour is displayed so that upcoming events can be spotted easily.

Interested in daily schedule?  Explore this example →

Scheduler - Responsive Day and Week Views

Change demo

The scheduler is fully responsive, it adapts to the available space and fills the screen to look good everywhere.

Use the responsive option to configure how the scheduler behaves on different sized screens. You can set it up as a daily schedule view on small screens and a weekly schedule on bigger screens.

The responsive option is equipped with five breakpoints - xsmall, small, medium, large, xlarge - and custom values can be added for a perfect fine-tune.

Change the viewport

Scheduler - Custom Column Widths

Change demo

Customize the width of scheduler columns using the .mbsc-schedule-col-width CSS class. This allows you to define fixed or dynamic column widths to fit your layout needs.

When using resources, the defined width is applied to resource columns. If no resources are present, it applies to day columns instead.

Interested in individually adjusting resource widths?  Discover how →

Scheduler - Print and PDF Export

Change demo

The scheduler includes print optimized styling through the print add-on. This needs to be added to the download package or installed separately from a dedicated NPM package.

Print styling is applied when someone prints the page that contains the scheduler. In addition to that, you can call the print method on the instance which grabs only the markup of the scheduler, places it onto a temporary page and calls the browsers printing function. This is especially useful when you want to add a button to only print the scheduler rather than the whole page.

Besides printing, PDF export is possible through the print dialog of the browser.

The print module is not available in the trial. You can try the live demo to see how it looks.

Scheduler - Work Week

Change demo

Customize the scheduler by not only disabling certain hours but hide them through setting the startTime and endTime properties of the view.schedule option. Quikcly set up a work calendar that goes from Monday through Friday with the startDay and endDay properties and renders the schedule from 8AM to 6PM.

You can easily add breaks - like a "Lunch break" - or disable times with the invalid option.

Scheduler - Appointment Booking Demo

Change demo

The scheduler can be set up for scheduling/unscheduling booked appointments. Simply set up a daily schedule view with multiple resources representing dentists or doctors. Next to the calendar you can render a list of unscheduled appointments.

Enabling advanced validation and combining that with the drag & drop between the calendar and external list on a resource to resource basis you got a pretty nice working base for appointment scheduling that can be further customized.

Scheduler - Doctors Availability

Change demo

You can tailor the scheduler to show availability per doctor using visual indicators in each column. Availability is marked with a green status track on the left side of each doctor's column, making open slots easy to spot and supporting quick scheduling decisions.

To create the visual indicator, we added extra resource columns with a narrow width, styled using a custom CSS class set via the cssClass property in the resource data. The availability track is shown using events placed on these columns, with their content hidden via schedulerEvent option and resized responsively based on the narrow resource column width. Time ranges outside each doctor's working hours are disabled to reflect their actual schedule.

Scheduler - 24-Hour Rotating Crew Shift Rota

Change demo

The scheduler can be configured for industrial or service environments requiring 24/7 coverage, such as manufacturing lines or critical infrastructure maintenance. This setup uses three resources (Crew A, Crew B, Crew C) to demonstrate a cyclical, rotating roster, like the 3-Crew, 3-Shift Rota.

To visualize the continuous operation and manage shifts that span midnight, the scheduler view is configured with a custom, 24-hour cycle, starting at 06:00 and ending at 06:00 the following day. This is achieved using the custom day-offset feature added to the startTime (e.g., '20:00-1') and endTime (e.g., '08:00+1') properties under the view option, which initiates the view relative to the previous or next calendar day. Furthermore, to ensure compliance with 8-hour shift lengths and prevent invalid scheduling, the drag-and-drop functionality is constrained by setting the dragTimeStep to 8 hours, requiring all events to be moved only in 8-hour increments and anchoring the alignment with the dragTimeStepBase: 'viewStart' option. The drag-and-drop logic is implemented for automatic conflict resolution: when an event is dragged to a different time or resource column within the same day, it automatically updates and shifts any conflicting events (those sharing the same time slot or resource column) to maintain scheduling integrity and prevent overlaps.

Scheduler - Drop Assignee on Event

Change demo

Assigning people to meetings that are already booked across multiple rooms is a common scheduling challenge. Instead of dropping external items onto the calendar grid to create new events, the goal here is to drop them onto existing events, turning each meeting into an individual drop target where attendees can be assigned directly.

This is where the MbscDropcontainer comes in. Each event rendered through the schedulerEvent function is initialized as a drop container, turning every meeting card into a valid drop zone. The external list of team members is set up using the draggable component, so each person can be grabbed and dropped onto any event on the scheduler. The item-drop event handles the assignment, while item-drag-enter and item-drag-leave provide real-time visual feedback.

Beyond simple assignment, the demo includes practical validation. Before accepting a drop, it checks whether the person is already assigned to the target meeting and whether they have a time conflict with another meeting in the same slot. Assignments can also be removed by clicking on an attendee chip, with an undo option.

Looking for dropping external items onto the calendar grid instead?  Check out the external drag & drop example →

Scheduler - Custom Range View

Change demo

The scheduler comes with built-in support for day, week and month views. For those situations where a custom range makes more sense, it is possible to override the calendar navigation component with a range picker.

The calendar header can be easily customized and a two-way synchronization needs to be kept between the scheduler and range picker.

Scheduler - Limit Overlapping Events

Change demo

The scheduler renders all concurrent (overlapping) events by default, and the available horizontal space will be divided between them. When there are a lot of concurrent events, displaying all of them isn't always helpful.

A maximum number of concurrent events can be set by passing a number to the maxEventStack property of the view.scheduler option.

Alternatively maxEventStack: 'auto' can also be set, in this case the value will be determined automatically, based on the available horizontal space. It's poosible to also set a minimum event width, using the minEvenWidth property of the view.scheduler option. If not specified, it defaults to 50px;

Scheduler - Custom Date Range View

Change demo

The scheduler has three types: day, week and month. Use the size property of the configuration object to set the length of the range.

Multiples of days, weeks and months are supported. The reference date, controlled through the refDate option, is today by default, but it can be set to any date, like the first day of the month, or the first day of the year. The refDate serves as the start of the reference range. From that point on you can navigate forward and backward.

A couple of examples:

  • Rolling two weeks - use type: 'day' and size: 14
  • Rolling ten days - use type: 'day' and size: 10
  • Two weeks (starting with Sun/Mon) - use type: 'week' and size: 2
  • Quarter view, starting from January - use type: 'month' and size: 3 with refDate: '2021-01-01'
  • Rolling three months - use type: 'month' and size: 3
  • Year view - use type: 'month' and size: 12 with refDate: '2021-01-01'

Scheduler - Hide All-Day Section

Change demo

Hide the all-day events section of the scheduler by setting the allDay property under the view.scheduler option.

Scheduler - Color-Coded Time Blocks

Change demo

Color the background of entire days or time ranges with the colors option. You can specify backgrounds as exact dates, ranges or set up recurring rules. The recurring object works the same way as for the events. Optionally, you can specify a title as well, which will be displayed on the colored block.

Use the page-loading lifecycle event to color backgrounds runtime. You can learn about lifecycle events and places where to drop logic to customize the experience.

Want to use patterns as backgrounds and customize how the invalid cells look?  Learn how to do it →

Scheduler - Switch Between Calendar and Scheduler Views

Change demo
Switch Between Calendar and Scheduler Views
Get started with this example

Dynamically switch views within one instance. Use a UI control to let users do the switching or do it programmatically.

The example features a month view with events as labels, a weekly schedule view, a daily schedule and a weekly agenda. Use property binding and when the value of the property changes the settings propagate.

Scheduler - Visible hours and days

Change demo

Customize the visible days and hours along with the scale of the time grid through the scheduler object under the view option. You can control the days to display (eg. Weekdays), the visible time range (eg. 8AM to 6PM), set the time scale (eg. 30 minutes) and set the labels shown (eg. every 15 minutes).

  • Specify the first and last day - Use the startDay and endDay properties
  • Set the visible time range - Use the startTime and endTime properties
  • Shift the visible time window - Use the startTime and endTime properties to include ranges that extend into the previous or next day
  • Control the visibility of empty columns - Use the hideEmptyColumns property
  • Control the visibility of fully invalid columns - Use the hideInvalidColumns property
  • Control the granularity of the time grid - Use the timeCellStep and timeLabelStep properties
Building a work calendar?  Check out this example →

Scheduler - Timezone Support

Change demo

The event calendar works with local times by default, but ships with support for changing the timezone. The conversions and correct output relies on either of these three external libraries: luxon, moment-timezone and day.js. For installing and using these libraries check out this guide.

There are two angles regarding timezones:

  • dataTimezone - the calendar expects this format and returns this format. It is 'local' by default if the date-times don't contain any timezone information.

It can be set globally on the calendar using the dataTimezone option, or specifically for the event using the timezone property of the event data.

  • displayTimezone - the calendar displays the events in this timezone. The date-times will be converted from the dataTimezone and displayed accordingly. It is 'local' by default
Enable switching the timezone in the UI?  Learn how to dynamically change timezones →

Scheduler - Event Buffer

Change demo

Use the bufferBefore and bufferAfter to add buffer times that will be rendered before and after the event.

These areas can help you visualize delays or added minutes for tasks. Here are some examples:

  • Travel time for meetings, appointments, work orders
  • Check in and check out times around flights
  • Loading/unloading for bus/truck
  • Cleaning, inspection, maintenance work that happen on a recurring basis
Looking to customize event buffers?  Check out the templating capabilities →

Scheduler - Multiple Timezone Support

Change demo

If the context requires users being able to change the timezone on the fly, you can add a custom dropdown with the desired timezones to the event calendar header. This can be of course placed externally to the calendar as well, eg. setting page.

Set the timezone of the incoming data through the dataTimezone - eg. 'utc', and set the display timezone through the displayTimezone - eg. 'America/Los_Angeles'

Wanna show multiple timezone tracks?  Check out the next example →

Scheduler - Custom Event Order

Change demo

The rendering engine uses the following two concepts to determine how the events are rendered:

  1. Event data order
  2. Event layout

The data order is determined by the following logic:

  • All-day events are placed at the top
  • Non-all-day events follow, sorted by their start times
  • Events with the same start time are ordered alphabetically by their title

The event layout process determines the visual positioning and dimensions of events. This is a built-in functionality and cannot be altered externally. The layout algorithm processes the sorted event list and calculates each event's position and size. The algorithm follows these steps:

  1. The first event is placed in the first position of the event column
  2. If two or more events overlap in their start/end times, the later event is placed in the next event column, positioned after to the previous event
  3. If a subsequent event does not overlap with any already added events, it is placed back in the first event column
  4. This process continues until all events are positioned within their respective columns

The order property of the event data can be used to override the default ordering. The order property takes precedence over the default rules. If two events have the same order value, the default rules apply. For a more advanced order logic, the eventOrder option can be used which expects a function that compares two events and returns an order (-1 or 1).

Do you want to learn about the event ordering?  Learn more about it in the documentation →

Scheduler - Multi-Timezone

Change demo

When operating across multiple timezones, coordinating resources and getting people on the same page is a challenge. It helps if events can be seen across these timezones.

Use the timezones property of the view.scheduler option and set the timezone tracks with custom labels. The order of the tracks is determined by the order they are added to the array.

Scheduler - Event Search Sidebar

Change demo

Inline search can be easily implemented with the help of a separate agenda instance. This example is relying on a single API endpoint for getting the data onto the primary schedule view and also for getting the filtered data based on the search terms.

Events can be filtered in real time so using an agenda view for the search results is an easy choice. It provides all the necessary styling and advanced features that you might need to customize the experience.

Alternatively, search can be implemented in the header using a similar search box with an agenda listed in a popup instead of rendered inline.

Scheduler - External Date Navigation

Change demo

This example demonstrates how can the Scheduler navigated externally. Here we have a two-pane layout with a Datepicker on the left and a Scheduler on the right. Changing date on the Datepicker will trigger the date change on the Scheduler.

The Datepicker updates the selectedDate option of the Scheduler in its @change event, while the Scheduler updates the datepicker value from its @selected-date-change event.

Scheduler - Custom Event Tooltip

Change demo

There are several approaches to showing a tooltip when hovering events.

The native tooltip

By default, the calendar shows the browser native tooltip when hovering over the event. This includes the times and title of the event, which does the job most of the times. For showing a custom text use the tooltip property of the data object. This tooltip is specific to every event. If you want to hide the native tooltip, you can set the showEventTooltip to false.

Fully custom tooltip

Setting the showEventTooltip to false gives room for a fully custom tooltip that can be implemented by using the event-hover-in and event-hover-out lifecycle events. With the help of the Mobiscroll popup you can show a custom tooltip that holds details, actions applicable to the event it is anchored to.

Showing a third party popup

There are cases when you are using a third party library, something like md-boostrap. For those cases, turn the browser native tooltip off with the showEventTooltip option and use the third-party tooltip accordingly. In case of md-boostrap, you can add the tooltip directive to the custom event template so that the library knows where and when to show the tooltip.

Scheduler - Custom Event Rendering

Change demo

Above the built in rendering mode you can either customize the full event or just the content of the event. If we break up the event into pieces there are six fields that we are interested in:

  • The event start and end time
  • Whether it is an allDay event or not
  • The event color
  • The event title
  • bufferBefore
  • bufferAfter

The scheduler takes care of positioning the event container and everything else is your responsibility. You will have to place and provide styling to all event fields. Beside the ones mentioned above you'll be able to render other custom fields, like description, location, participants ... and add buttons, custom interactions.

Pass the event template to the schedulerEvent template. All original event fields along with computed fields like isMultiDay, lastDay will be available inside the template.

The before/after buffers can help you visualise delays or added minutes for tasks. For example travel time for meetings/appointments, check in/check out for flights.

Templating the buffers can be done through the bufferBefore and bufferAfter options.

Scheduler - Custom Date Header

Change demo

Customize the date headers of the scheduler by adding relevant content, labels or completely change how they look. Use the schedulerDayTemplate template for setting up a custom date header template.

Scheduler - Custom Resource Headers

Change demo

Use the resource template for setting up a custom resource header. Customize how the resource headers look and what they show. Utilize properties passed in the resources array.

Interested in displaying resource information on hover?  Show details on hover →

Scheduler - Custom Cell Content Template

Change demo

Events appear over scheduler cells, which provide a great background layer for information. They can be disabled, styled with colored backgrounds, or used to present rich content.

Cell content in the scheduler can be customized using the cell template. The callback receives cell data such as the date, resource, and overlapping events in the cell. This lets you add custom content like icons or badges to cells based on their data. It's useful for showing holidays, availability, or statuses.

Cells can be hourly, 30 minute long, or however it is setup using the timeCellStep option.

Scheduler - Custom Header

Change demo

You can customize how the header of the scheduler looks and how the components are arranged. Besides that you can also add custom functionality, like a segmented control that lets people switch between scheduler and calendar.

Use the header template for passing a custom header layout. There are predefined components - shorthands if you will - that can be used to assemble the header:

  • Navigation component - <MbscCalendarNav />. Use the .md-header-filter-controls CSS class for custom overrides.
  • Today button - <MbscCalendarToday />. Use the .md-header-filter-today CSS class for custom overrides.
  • Previous month button - <MbscCalendarPrev />. Use the .md-header-filter-prev CSS class for custom overrides.
  • Next month button - <MbscCalendarNext />. Use the .md-header-filter-next CSS class for custom overrides.

For changing the order the controls are laid out, you only need to set up the header template. This example sets a consistent order and layout across all themes and shows a custom control at the far right end.

Overriding the order for specific themes

For a custom order on a theme to theme basis, you will need to use a little CSS. Flex layout makes reordering easy. It's just a matter of setting the order in CSS. For material use the .mbsc-material, for windows the .mbsc-windows prefix and for iOS it is .mbsc-ios class. Eg.:

.mbsc-material .md-header-filter-prev { order: 1; }
            .mbsc-material .md-header-filter-next { order: 2; }
            .mbsc-material .md-header-filter-controls { order: 3; }
            .mbsc-material .md-header-filter-today { order: 4; }
Want to add a filter to the header?  Check out the next example →

Scheduler - Drag, Resize and Create Events

Change demo

Drag & drop is a core feature of the event calendar and it is composed of four sub-features:

  • Click to create events - double click to create events. This can be turned off or set to single click
  • Drag to create events - tap/click to start creating an event and drag to the desired length
  • Move events - grab an event and move it wherever needed
  • Resize events - change the length of an event, grab it from either end and resize it
  • Delete events - pressing the Delete or Backspace keys on the keyboard will delete the focused event

You have granular control over features through the clickToCreate, dragToCreate, dragToMove, dragToResize and eventDelete options, which are false by default.

Use the dragTimeStep option (defaults to 15 minutes) to set the snap resolution of all drag actions.

Events can be marked as fixed by setting their editable property to false. This turns delete, drag & drop move and resize off for the event. The mbsc-event-readonly CSS class will be added to the events. This means if you would like to add opacity, override the mouse cursor or apply any other CSS override, you can add it to this class.

Scheduler - Drag, Resize & Move Restrictions

Change demo

The drag & drop interactions can be fine-tuned depending on the requirements and situations. Maybe controlled by roles, event types, resources the move and resize can be turned on/off on an event basis, per resource or globally on the instance.

  • Events can be fixed in length (cannot be resized) - by setting dragToResize option to false the events cannot be resized.
  • Events can be fixed in time (cannot be moved) - by setting dragInTime option to false the events cannot be moved in time. Take in consideration that dragToMove must be set to true
  • Events can be fixed to resource (cannot be moved to another resource) - by setting dragBetweenResources option to false the events cannot be moved between resources. Take in consideration that dragToMove must be set to true

To control this on a resource an event basis, use the appropriate properties which have precedence over global calendar options.

Scheduler - Instance Event Transfer

Change demo

There are certain cases when moving the events between calendars can come in handy.

Dragging and dropping events between two scheduler instances can be enabled by turning on the externalDrag and externalDrop options.

Scheduler - Blocked Time Ranges

Change demo

Entire days and time ranges can be blocked out to manage event creation and editing more efficiently.

To disable specific times, ranges, days or recurring days and times you can pass an array to the invalid option. A couple of examples:

  • To disable weekends, use the recurring object - recurring: { repeat: 'weekly', weekDays: 'SA,SU' }
  • Lunch break between 12 PM and 1 PM with title - { start: "12:00", end: "13:00", title: 'Lunch break', recurring: { repeat: 'weekly', weekDays: 'MO,TU,WE,TH,FR' }

When dragging events onto disabled days or time-slots, they will automatically be denied and event-create-failed / event-update-failed events will be triggered, from which custom logic can be executed to show a toast or maybe a modal for data correction. The built-in logic of how the calendar handles validation on user interaction can be controlled through the invalidateEvent option:

  • 'strict' - Strict being the default, no event overlap is allowed with invalid ranges.
  • 'start-end' - With start-end validation the calendar checks if the start or end of the event coincides with any invalid range. Other overlaps are allowed.

If you're interested in invalids for a given range (including recurring occurrences), you can use the getInvalids function.

Want to prevent double booking?  Learn how to manage event overlaps →

Scheduler - Prevent Double Booking

Change demo

Sometimes it is necessary to guarantee that events don't overlap - eg. when scheduling workorders, interacting with a work calendar. You can reject the updates or additions and let the user know about it.

The event overlap can be turned on/off on an event basis, per resource or globally on the instance.

  • On an event basis - by setting the overlap property to false the specified event cannot overlap.
  • Per resource - by setting the eventOverlap property to false the events in the specified resource cannot overlap.
  • Globally on the instance - by setting eventOverlap option to false overlap is disbled globally.

If set to false, the resource and the event settings have precedence over the global calendar eventOverlap option.

Give feedback to the user - optionally, a toast can be displayed to explain why an event cannot be dropped, moved or created. For this we can use the onEventCreateFailed and onEventUpdateFailed lifecycle events.

Looking to implement time off or block out ranges?  Learn how to add lunch breaks, working hours and disable weekends →

Scheduler - External Drag and Drop

Change demo
Dragging events on the Mobiscroll event calendar

Events can be scheduled by dragging and dropping an external item onto the scheduler with Mobiscroll draggable. In order for that to work you will need to have two things set up:

  • Enable the scheduler to receive external events by setting externalDrop to true.
  • Initialize the external events (containers) as draggable components.

Use the MbscDraggable component to specify a skeleton event through its dragData option and reference the draggable container in the element option. The dragData accepts a full event definition that will be added to the event calendar on drop. If omitted, a default event will be created.

Working together with SortableJS and Dragula lists

Mobiscroll provides built-in support for two widely used reorderable drag-and-drop list libraries: SortableJS and Dragula. If you are already using any of these libraries to reorder list items, they can be seamlessly integrated with the scheduler. This integration enables a smooth workflow where items can be dragged from external lists and scheduled directly onto the calendar.

Events can be created and scheduled by dragging items from third-party lists into the event calendar. To enable this behavior you will need to:

  • Allow the scheduler to receive external drops by setting externalDrop.
  • Use the sortableJsDraggable or dragulaDraggable plugins to connect the third-party list with the scheduler.

The event data will be read from the dragged element's data-drag-data attribute, or the plugin's options expose an eventData function where the event definition (title, start, end, resource, etc.) can be specified.

You can then handle the calendars lifecycle events such as event-create, event-created or event-create-failed to run custom logic (e.g. showing a toast) when a drop succeeds or fails.

Unscheduling events (or dragging them off a calendar)

Additionally events can be unscheduled by dragging them out from the scheduler and dropping them onto an external drop container. To activate this, you will need to:

  • Enable the scheduler to allow dragging events out by setting externalDrag to true.
  • Initialize the

dropcontainer

Events can also be dropped on another event calendar with externalDrop enabled.

When an event is dropped into an external drop container or another calendar, it will be deleted from the original calendar and the event-delete will be fired.

You can also use the event-drag-leave and event-drag-enter, and the drop container's item-drag-enter and item-drag-leave events to provide visual feedback or running custom logic during drag.

Learn more from the external drag & drop documentation.

Unscheduling events to SortableJS and Dragula lists

Dropping events from the Eventcalendar to SortableJS and Dragula lists is also possible with the sortableJsDraggable and dragulaDraggable plugins. To enable this behavior you will need to set the following under the options configuration:

  • Allow the list to receive external drops by setting exteralDrop to true
  • Use the onExternalDrop callback to update the content of the third-party list. The function arguments return the afterElement - the list element before which the clone is dropped,

container - the list container, dragData - the dragged event data, position - the index where the clone is dropped on the list.

For details, and option lists see the externalDrop section in the documentation

Looking for external drag into a calendar?  Check out this example →

Scheduler - External Preset Task Scheduling

Change demo

Use external draggable events to create preset tasks that people can quickly copy and spawn events from. A great example is an auto repair shop where among others, mechanics have to perform the same predefined tasks.

Print a list of predefined tasks and initialize them as draggable elements. Enable externalDrop for the scheduler and set up the predefined event skeletons for the draggable component.

Whenever there is more information to be captured, like detailed task notes, customer information, the name of the technician... you can trigger a popup with the task form in the event-create lifecycle event. For failed drops (trying to schedule a task during lunch breaks or weekends) the event-create-failed onEventCreateFailed event will be triggered.

Want to see how external presets look & feel for a calendar?  Check out this example →

Scheduler - Multi-Resource View

Change demo

The scheduler can handle multiple resources inside a single instance. Pass the resource list to the resources option with an id, name, color and eventCreation.

  • id - This is an id that can be referenced in the event data
  • name - The name of the resource that will be printed at the top of the respective column
  • color - The color controls the default event color of the resource. Event colors can be specific above this. If the color is omitted the underlying events will inherit the default calendar color
  • eventCreation - This controls if events can be created or dropped onto this resource

The resources in which the resources appear follows the order of the array passed to the component.

Events can be shared between resources and it is possible to move events between resources. The move is handled automatically however you can block it if moving an event from one resource to the other is prohibited. Learn about lifecycle event hooks.

Scheduler - Group by Resource or Date

Change demo

Resources show up in the header of the calendar as the primary group and below them are the days. This can be switched up through the groupBy option that expects 'resource' or 'day'.

Combined with the day and week-view you can help people quickly find what they are looking for. Learn how to add an integrated segmented control to the header.

Scheduler - Shared Events Across Resources

Change demo

Events can be shared among resources. This can easily be the same resource type, like people in a shared work calendar scenario or different resource types, like aircraft and instructor in a flight training scenario where you'll have to schedule an instructor and an aircraft for a class which is the event.

Shared events will render correctly in the appropriate resource columns with drag & drop, validation across invalid dates and times will work out of the box. All you need to do is to add both resourceIDs to the event.

Scheduler - Dynamic Resource Filtering

Change demo

Resources can be dynamically turned on and off. This will show or hide the resource and can be done runtime the same way as for any other calendar option.

Scheduler - Dynamic Resource Widths

Change demo

When resource content varies, fixed widths might not work well. To handle this, you can define a few preset width classes in CSS, and assign them conditionally using the cssClass property in the resource data based on the content.

This approach lets you adapt the layout dynamically and ensure each resource column has the right width for its content.

Scheduler - Resource Data Structure

Change demo

The resource data structure for the scheduler is straightforward with a couple of base properties that the component understands and uses to render the UI. Besides the base properties you can add any custom property, like title, job ...

  • id - This is an id that can be referenced in the event data
  • name - The name of the resource that will be printed at the top of the respective column
  • color - The color controls the default event color of the resource. Event colors can be specific above this. If the color is omitted the underlying events will inherit the default calendar color
  • eventCreation - This controls if events can be created or dropped onto this resource
  • eventDragBetweenResources - Specifies whether the events in the specified resource are movable across resources. If set to false has precedence over dragBetweenResources option of the calendar.
  • eventDragInTime - Specifies whether the events in the specified resource are movable in time. If set to false has precedence over dragInTime option of the calendar.
  • eventResize - Specifies whether the events in the specified resource are resizable. If set to false has precedence over dragToResize option of the calendar.
  • eventOverlap - Specifies whether the events in the specified resource are allowed to overlap. If set to false has precedence over eventOverlap option of the calendar.

Scheduler - Hide Resources

Change demo

The scheduler can automatically hide non-working resource columns using the hideInvalidColumns property of view option.

The calendar is set to a weekly view (Monday to Friday, 8:00–20:00) and displays multiple doctors as resources, each with unique working days. Recurring invalids are used to mark specific weekdays when a doctor is unavailable, while static invalids indicate individual days off. As a result, only the columns for resources who are working on a given day are shown, making the schedule cleaner and easier to read. This approach is ideal for managing staff with varying shifts and availability.

Scheduler - Event Data Structure

Change demo

The event data structure for the scheduler is straightforward with a couple of base properties that the component understands and uses to render the UI. Besides the base properties you can add any custom property, like location, description ...

  • id - A unique ID for the event. If not specified a unique id will be generated
  • title - Defines the event text. This can be plaintext or HTML
  • tooltip - Defines the text for the tooltip which appears on mouse hover. If not specified, it will show the title and the start/end times of the event.
  • color - Defines the event color
  • start - Sets the start date and time for the event. It can be a js date object, ISO date string or moment.js object. Learn about date formats
  • end - Sets the end date and time for the event. The same formats are supported as for start
  • allDay - Configures the event as a full-day event
  • recurring - Configures the recurring rules for the event. Learn about recurring events
  • recurringException - Represents the exceptions of a recurring event, when specific dates need to be skipped from the rule.
  • recurringExceptionRule - Represents the exception rule of a recurring event, when recurring dates need to be skipped from the rule.
  • resource - Links the event to one or more resources. Expects a list of IDs from the resources array
  • timezone - The timezone where the event takes place. If specified, it takes precedence over the calendar's specified dataTimezone.
  • dragBetweenResources - Specifies whether the event is movable across resources. If set to false has precedence over eventDragBetweenResources property in resources and the dragBetweenResources option of the calendar.
  • dragInTime - Specifies whether the event is movable in time. If set to false has precedence over eventDragInTime property in resources and the dragInTime option of the calendar.
  • resize - Specifies whether the event is resizable. If set to false has precedence over eventResize property in resources and the dragToResize option of the calendar.
  • overlap - Specifies whether overlap is allowed on the event. If set to false has precedence over eventOverlap property in resources and the eventOverlap option of the calendar.
  • editable - Denotes if the event is editable. If set false, the event cannot be dragged, resized or deleted even if globally enabled
  • cssClass - A custom css class for the event. Useful for quick styling adjustments of the event container.
  • bufferBefore - Defines a buffer time in minutes that will be rendered before the start of the event. This buffer area can help you visualise delays or added minutes for tasks.

For example travel time for meetings/appointments, check in before a flight.

  • bufferAfter - Defines a buffer time in minutes that will be rendered after the end of the event. This buffer area can help you visualise delays or added minutes for tasks.

For example travel time after meetings/appointments, check out after flights, inspection, cleaning after certain tasks.

  • order - Specifies the order of the event in the event array. Has precedence over the default ordering rules.

Scheduler - Date Input Formats

Change demo

Understanding how to work with dates inside the scheduler is essential. You can pass to the data, marked, colors and labels in four different formats. The scheduler can work with Javascript date objects, ISO strings and Moment.js objects.

Scheduler - Recurring Events

Change demo

Configure daily, weekly, monthly and yearly recurring events. On top of setting up recurrence, you can exclude specific and recurring days. This is especially useful in cases when a single occurrence of an event is deleted or is moved to a different time.

You can pass the recurrence rule in the recurring property of the event as an object or a string in RRULE format. Learn about the event data structure and where to place the recurring rules.

Use the configurator to experiment, build strings and objects that you can grab and use.

Interested in adding recurrence configuration to your UI?  Take a look at this add/edit dialog →

Scheduler - Inline Data

Change demo

What is a scheduler without any events in it? To populate it with events all you have to do is pass the event array to the data option.

In a real-world scenario you would probably load the events from a remote resource or event better, load them on demand. However the point of this example is to understand how easy it is to add events to the scheduler.

Do you want to learn about the event data sctructure?  See how the event object is built →

Scheduler - Load Events from Remote API

Change demo

The scheduler can be populated by passing an array to the data option, that you can construct either inline or by getting it from a remote API. The important thing to remember is that events need to be in a format that the scheduler understands.

Interested in load on demand?  Dynamically load events on month change →

Scheduler - Load Events on Demand

Change demo

The scheduler supports remote and local data sources. Besides that, events can be populated on initialization or loaded on demand.

Getting the events in real time as the user navigates improves load performance and always serves the most recent data.

Use the page-loading lifecycle event to load the data runtime. You can learn about lifecycle events and places where to drop logic to customize the experience.

Interested in loading events from Google Calendar?  Show events from Google Calendar →

Scheduler - Lazy Load Events on Scroll

Change demo

The scheduler view is virtualized which means that the markup is being generated and maintained on the fly. Navigating both vertically and horizontally through scrolling fires the @virtual-loading lifecycle event which can be used to load the data on scroll rather than load everything on initial page rendering.

This dramatically improves performance in case of a large event count since not all data is loaded in memory from start.

Scheduler - Large Dataset Performance

Change demo

The scheduler supports virtual horizontal and vertical scrolling. The view virtualization makes it possible to work with many resources across long date ranges.

The following examples shows that navigating 20 resources across a whole month with 2000 events won't pose any problems for the browser neither on mobile or desktop.

View virtualization is always enabled and doesn't need to be turned on explicitly.

Scheduler - Google Calendar Integration

Change demo

The event calendar comes with third party calendar integration support through the integration plugin. This needs to be added to the download package or installed separately from a dedicated NPM package.

It includes everything you need to authenticate your users, get their Google calendars and provides functions for CRUD operations. It takes care of loading the events and converts them to the required format so that they can be displayed on the Mobiscroll calendar separately or mixed with other calendars and events.

Customizing the interaction, event workflows, whether the events are read-only is up to you. In this live demo, newly created events will land in the primary calendar of the authenticated user.

This example uses the integration plugin to connect to and load events from Google Calendar and it is not available in the trial. Give the live demo a try and see how it can be configured.

Scheduler - Outlook Calendar Integration

Change demo

The event calendar comes with third party calendar integration support through the integration plugin. This needs to be added to the download package or installed separately from a dedicated NPM package.

It includes everything you need to authenticate your users, get their Outlook calendars and provides functions for CRUD operations. It takes care of loading the events and converts them to the required format so that they can be displayed on the Mobiscroll calendar separately or mixed with other calendars and events.

Customizing the interaction, event workflows, whether the events are read-only is up to you. In this live demo, newly created events will land in the primary calendar of the authenticated user.

This example uses the integration plugin to connect to and load events from Outlook Calendars and it is not available in the trial. Give the live demo a try and see how it can be configured.

Scheduler - Google Calendar Integration

Change demo

Event data can be loaded from remote sources, like public google calendars. Through the integration plugin you can easily show events that are available in a public calendar. The integration plugin needs to be added to the download package or installed separately from a dedicated NPM package.

You will just need the CALENDAR_ID and an apiKey from google and you should be ready to roll.

Public calendars are read-only. If you are interested in syncing private google calendars with read/write/delete access, check out this example.

This example uses the integration plugin to connect to and load events from Google Calendar and it is not available in the trial. Give the live demo a try and see how it can be configured.

Scheduler - Add, Edit and Delete Events

Change demo
Create new events

Drag to create and click to create is enabled. Events can be created by dragging or with double clicks. As soon as the initial position is confirmed, a temporary event is created and a custom edit dialog is shown for refinement. On cancel the temporary event will be removed and on confirmation the event will stay in the calendar.

Edit existing events

Drag to resize and drag to move is enabled. Events can be reordered and resized. In addition to that, clicking on the event will open a custom dialog that enables editing the various properties.

Delete events

Delete can be implemented inside the edit dialog with a button. It's just a matter of removing it from the data object. If a dialog is not shown on click, focused events can be deleted with the backspace and delete keys.

Interested in adding recurrence configuration?  Check out this example →

Scheduler - Bulk Event Actions

Change demo

Multiple event selection can be turned on with the selectMultipleEvents option. Selecting multiple events can be done through user interaction with CTRL/SHIFT/CMD + click or programmatically eg. click of a button or 'select all' checkbox.

Bulk operations like delete, update can be applied the selected events. Things like deleting with the backspace or delete buttons work out of the box but custom actions can be also applied. The selection can be easily retrieved and updated with the getSelectedEvents and setSelectedEvents method.

Custom actions can be performed with external buttons or with context menu activated on right-click.

Scheduler - Recurring Event Add & Edit

Change demo

As seen in the previous example, an add/edit form can be created with custom and base event fields. While the CRUD example features delete with undo, this example shows off how to build a fully customizable recurrence editor right in the add/edit screen.

Above some common presets, like Daily, Weekly on X day, Monthly on Xth, Annually on the same day, Every Weekday a fully custom recurrence editor is implemented.

Copy & paste or delve into the code and understand how to generate recurrence objects or RRULES as seen in this live rule builder.

Scheduler - Prevent Past Event Creation

Change demo

Sometimes we don't want users to be able to create events in the past or to alter past events. This might be role based in some cases or applied in general to the calendar.

To disable past event creation and manipulation, a couple of things need to be handled:

  • Invalidate past dates & times - this takes care of validating event drop and event creation on past dates and times that are before the past hour
  • Mark past events as fixed - to do this, set the editable property of the event object to false for the events that should remain fixed
  • Handle past occurrences of recurring events - recurring events are loaded as a single event and the occurrences are generated by the scheduler.

Moving the past occurrences need to be handled in the event-update and event-create lifecycle events

  • Give feedback to the user - optionally, a toast can be displayed to give feedback to the user why an event cannot be dropped, moved and created in the past. For this we can use the

event-update-failed and event-create-failed lifecycle events

Scheduler - CSS Classes for Cell Colors and Blocked Times

Change demo
CSS Classes for Cell Colors and Blocked Times
Get started with this example

Besides customizing the background color of cells and setting up invalid/blocked out times you can customize how these blocks and disabled times look by passing a cssClass to the colors and invalid array elements.

The output could be a custom pattern, custom styling for the labels or anything that you'd like to render as the background. This a great way for adding special meaning to certain days and time ranges.

Scheduler - Resource Filtering in Header

Change demo

The header of the scheduler is a canvas and an opportunity for customization. You can add custom components and enable new interaction in context.

Such an example would be a custom filter block created with the help of a segmented control and placed between the standard UI components, which are:

  • Navigation component - <MbscCalendarNav />. Use the .md-header-filter-controls CSS class for custom overrides.
  • Today button - <MbscCalendarToday />. Use the .md-header-filter-today CSS class for custom overrides.
  • Previous month button - <MbscCalendarPrev />. Use the .md-header-filter-prev CSS class for custom overrides.
  • Next month button - <MbscCalendarNext />. Use the .md-header-filter-next CSS class for custom overrides.

For changing the order the controls are laid out, you only need to set up the header template.

Overriding the order for specific themes

For a custom order on a theme to theme basis, you will need to use a little CSS. Flex layout makes reordering easy. It's just a matter of setting the order in CSS. For material use the .mbsc-material, for windows the .mbsc-windows prefix and for iOS it is .mbsc-ios class. Eg.:

.mbsc-material .mds-header-filter-prev { order: 1; }
            .mbsc-material .mds-header-filter-next { order: 2; }
            .mbsc-material .mds-header-filter { order: 3; }
            .mbsc-material .mds-header-filter-today { order: 4; }
Want to style and reorder the header?  Take a look at the previous example →

Scheduler - Themes — iOS, Material & Windows

Change demo

The look and feel of the scheduler can be deeply customized. There are four levels of customization:

  • Base themes: Choose between iOS, Material and Windows.
  • Light or dark: Every theme has a light and dark variant. Setting the themeVariant to 'auto' will switch based on system settings.
  • Custom themes: Use the theme builder to customize the colors and make it match your brand.
  • Custom CSS: If you need further customization, the sky is the limit with CSS overrides.

You can also see how every example looks by changing the theme from the header.

Scheduler - Resource Background Styling

Change demo

Easily highlight resources or columns by adding a simple background color or craft a more specific look with the cssClass property of the resources data.

The output could be a custom background to individual resources or columns and it can be used for multiple purposes. For example:

  • Different styling for certain columns, like thicker border acting as separator.
  • Resource selection, where the selected resource has a different background.
  • Setting different backgrounds for the resource titles and grid columns.
Interested in highlighting date ranges only?  Explore this example →

Scheduler - Cell Hover Summary Tooltip

Change demo

This demo demonstrates how to surface detailed cell summaries through tooltips when hovering over schedule cells.

Using cell-hover-in and cell-hover-out events, each tooltip dynamically displays the total number of events, invalid and colors in the hovered cell.

Scheduler - Gregorian, Jalali & Hijri

Change demo

The scheduler supports multiple calendar systems. You can control it with the calendarSystem setting, and it supports the following options:

  • Gregorian - it is included by default
  • Jalali - it is the default system of the Persian calendar and is included within the Farsi language pack
  • Hijri - it is included in the Arabic language pack
Interested in localization?  Explore this example →

Scheduler - Event Hooks

Change demo

The scheduler ships with different hooks for deep customization. Events are triggered through the lifecycle of the component where you can tie in custom functionality and code.

While users interact with the UI events like event-click, init, selected-date-change ... will be triggered.

For a complete list of events go to the documentation  See available lifecycle events →

Scheduler - Localization

Change demo

The components are fully localized. In case of the scheduler this covers date and time format, button copy, rtl and more. You can see how each example shows up by clicking on the small flag icon or checking the examples below.

All settings can be manually overridden  See what options the localization impacts →

Looking for something you didn't see or have a sales question?
Ask us about it, we're here to help.

Get started with Mobiscroll for Angular

Give the components a try locally and see how they look in your project.

Get started with Mobiscroll for React

Give the components a try locally and see how they look in your project.

Get started with Mobiscroll for Javascript

Give the components a try in a starter app or see how they look in your project.

Get started with Mobiscroll for Vue

Give the components a try locally and see how they look in your project.

Get started with Mobiscroll for jQuery

Give the components a try in a starter app or see how they look in your project.

Already have an account?
Get started with Mobiscroll for Angular

Give the components a try locally and see how they look in your project.

Get started with Mobiscroll for React

Give the components a try locally and see how they look in your project.

Get started with Mobiscroll for Javascript

Give the components a try in a starter app or see how they look in your project.

Get started with Mobiscroll for jQuery

Give the components a try in a starter app or see how they look in your project.

Get started with Mobiscroll for Vue

Give the components a try locally and see how they look in your project.

Already have an account?
Simple two minute install guide for jQuery
Step 1.
Copy resources
Step 2.
Add references
Step 3.
Copy the code
Step 4.
Refresh browser
Copy the downloaded JS and CSS folder into your project

Extract the downloaded zip (download again) and grab the two folders. Make sure to place it where it can be reached from your html file.

Alternatively you can run the example using our demo app.

file-copy-arrows

Or you can just simply try and play with the examples right from the folder you just unpacked. You don't find the downloaded example? Download it again.

Include the mobiscroll CSS and JS resources in your files

Add this script before the closing </head> tag of your file. Make sure to have jQuery loaded before this.

Copy code <link href="css/mobiscroll.jquery.min.css" rel="stylesheet" />
<script src="js/mobiscroll.jquery.min.js"></script>

Make sure to have the CSS and JS files copied over as explained in Step 1.

Copy the code into your app

Grab the relevant parts and drop them into your JS, HTML and CSS files.

Copy JS
Copy HTML
Copy CSS
Take a look at what you've accomplished

Reload your application in your favorite browser

arrow-browser-reload@2x

And voilà, everything should be running smoothly.

If something is not running correctly or if there is trouble

Check out these common errors and solutions or reach out and let us help you.

Keep things running smoothly

We have sent an email with verification instructions to you. Please make sure to follow the steps and verify it's you.

In case you fail to verify the account, the trial will be interrupted.

If you have any trouble

Don't hesitate to let us know.

install-help-bck
Simple two minute install guide for Javascript
Step 1.
Copy resources
Step 2.
Add references
Step 3.
Copy the code
Step 4.
Refresh browser
Copy the downloaded JS and CSS folders into your project

Extract the downloaded zip (download again) and grab the two folders. Make sure to place it where it can be reached from your html file.

Alternatively you can run the example using our demo app.

file-copy-arrows

Or you can just simply try and play with the examples right from the folder you just unpacked. You don't find the downloaded example? Download it again.

Include the mobiscroll CSS and JS resources in your files

Add this script before the closing </head> tag of your file

Copy code <link href="css/mobiscroll.javascript.min.css" rel="stylesheet" />
<script src="js/mobiscroll.javascript.min.js"></script>

Make sure to have the CSS and JS files copied over as explained in Step 1.

Copy the code into your app

Grab the relevant parts and drop them into your JS, HTML and CSS files.

Copy JS
Copy HTML
Copy CSS
Take a look at what you've accomplished

Reload your application in your favorite browser

arrow-browser-reload@2x

And voilà, everything should be running smoothly.

If something is not running correctly or if there is trouble

Check out these common errors and solutions or reach out and let us help you.

Keep things running smoothly

We have sent an email with verification instructions to you. Please make sure to follow the steps and verify it's you.

In case you fail to verify the account, the trial will be interrupted.

If you have any trouble

Don't hesitate to let us know.

install-help-bck
Simple two minute install guide
Step 1.
Install the CLI
Step 2.
Install Mobiscroll
Step 3.
Copy the code
Step 4.
Run the app
Install the Mobiscroll CLI from npm

You will be able to configure Mobiscroll with ease in your app with the CLI

Copy command $ npm install -g @mobiscroll/cli
Install Mobiscroll in your React project

Run the following command in the root folder of your React project.

Don't have a project? Try it with our demo app.

Copy command $ mobiscroll config react

You will be prompted to log in with your mobiscroll account. Set your password here.

Working behind a proxy?

If you're working behind a proxy server, additional configuration might be needed. Please check the proxy configuration options in the documentation.

Using a CI/CD workflow?

The package will be installed from a private npm registry, which requires authentication. If your project uses a CI/CD workflow, read this guide on how to make it work.

Copy the code into your app

Grab the relevant parts and drop them into your JSX and CSS files.

Copy JSX
Copy TSX
Copy CSS
Take a look at what you've accomplished

Run $ npm start in the root folder of your app

Copy command $ npm start

And voilà, everything should be running smoothly.

If something is not running correctly or if there is trouble

Check out these common errors and solutions or reach out and let us help you.

Keep things running smoothly

We have sent an email with verification instructions to you. Please make sure to follow the steps and verify it's you.

In case you fail to verify the account, the trial will be interrupted.

If you have any trouble

Don't hesitate to let us know.

install-help-bck
Simple two minute install guide
Step 1.
Install the CLI
Step 2.
Install Mobiscroll
Step 3.
Copy the code
Step 4.
Run the app
Install the Mobiscroll CLI from npm

You will be able to configure Mobiscroll with ease in your app with the CLI

Copy command $ npm install -g @mobiscroll/cli
Install Mobiscroll in your Angular project

Run the following command in the root folder of your Angular project.

Don't have a project? Try it with our demo app.

Copy command $ mobiscroll config angular

You will be prompted to log in with your mobiscroll account. Set your password here.

Working behind a proxy?

If you're working behind a proxy server, additional configuration might be needed. Please check the proxy configuration options in the documentation.

Using a CI/CD workflow?

The package will be installed from a private npm registry, which requires authentication. If your project uses a CI/CD workflow, read this guide on how to make it work.

Copy the code into your app

Grab the relevant parts and drop them into your Component and Template files. For quick testing copy the css to into your project's style.css or style.scss.

Copy TS
Copy HTML
Copy CSS
Take a look at what you've accomplished

Run $ ng serve in the root folder of your app

Copy command $ ng serve

And voilà, everything should be running smoothly.

If something is not running correctly or if there is trouble

Check out these common errors and solutions or reach out and let us help you.

Keep things running smoothly

We have sent an email with verification instructions to you. Please make sure to follow the steps and verify it's you.

In case you fail to verify the account, the trial will be interrupted.

If you have any trouble

Don't hesitate to let us know.

install-help-bck
Simple two minute install guide
Step 1.
Install the CLI
Step 2.
Install Mobiscroll
Step 3.
Copy the code
Step 4.
Run the app
Install the Mobiscroll CLI from npm

You will be able to configure Mobiscroll with ease in your app with the CLI

Copy command $ npm install -g @mobiscroll/cli
Install Mobiscroll in your Vue project

Run the following command in the root folder of your Vue project.

Don't have a project? Try it with our demo app.

Copy command $ mobiscroll config vue

You will be prompted to log in with your mobiscroll account. Set your password here.

Working behind a proxy?

If you're working behind a proxy server, additional configuration might be needed. Please check the proxy configuration options in the documentation.

Using a CI/CD workflow?

The package will be installed from a private npm registry, which requires authentication. If your project uses a CI/CD workflow, read this guide on how to make it work.

Copy the code into your app

Grab the relevant parts and drop them into your Vue page.

Copy
Copy
Take a look at what you've accomplished

Run $ npm run dev in the root folder of your app

Copy command $ npm run dev

And voilà, everything should be running smoothly.

If something is not running correctly or if there is trouble

Check out these common errors and solutions or reach out and let us help you.

Keep things running smoothly

We have sent an email with verification instructions to you. Please make sure to follow the steps and verify it's you.

In case you fail to verify the account, the trial will be interrupted.

If you have any trouble

Don't hesitate to let us know.

install-help-bck
Customize & try this demo locally
Sign in or start your free trial

We have to set you up with a trial for this to run 👍

Demos
Scheduler Mobile Day View Daily View Week View on Mobile Week View Responsive Day and Week Views Custom Column Widths Print and PDF Export Work Week Appointment Booking Demo Doctors Availability 24-Hour Rotating Crew Shift Rota Drop Assignee on Event Custom Range View Limit Overlapping Events Custom Date Range View Hide All-Day Section Color-Coded Time Blocks Switch Between Calendar and Scheduler Views Visible hours and days Timezone Support Event Buffer Multiple Timezone Support Custom Event Order Multi-Timezone Event Search Sidebar External Date Navigation Custom Event Tooltip Custom Event Rendering Custom Date Header Custom Resource Headers Custom Cell Content Template Custom Header Drag, Resize and Create Events Drag, Resize & Move Restrictions Instance Event Transfer Blocked Time Ranges Prevent Double Booking External Drag and Drop External Preset Task Scheduling Multi-Resource View Group by Resource or Date Shared Events Across Resources Dynamic Resource Filtering Dynamic Resource Widths Resource Data Structure Hide Resources Event Data Structure Date Input Formats Recurring Events Inline Data Load Events from Remote API Load Events on Demand Lazy Load Events on Scroll Large Dataset Performance Google Calendar Integration Outlook Calendar Integration Google Calendar Integration Add, Edit and Delete Events Bulk Event Actions Recurring Event Add & Edit Prevent Past Event Creation CSS Classes for Cell Colors and Blocked Times Resource Filtering in Header Themes — iOS, Material & Windows Resource Background Styling Cell Hover Summary Tooltip Gregorian, Jalali & Hijri Event Hooks Localization
Theme Select
Material
Material Dark
iOS
iOS Dark
Windows
Windows Dark
Language Locale
See other demos and change options
Theme
Locale
See other demos

Updated on Sep 23, 2026

Serious React scheduler with configurable daily, weekly & monthly views

Flexible, configurable for mobile & desktop web apps and Ionic React projects

Recurring events
Multi-day events
Popover with full event list
Drag & drop
Templating
Resource support
Customizable times
Drag & drop
Manage multiple resources
Daily, weekly or monthly timeline
Drag & drop
Customizable range
Scroll to date
Recurring events
Templating
Daily, weekly or monthly agenda

The scheduler features a time grid - vertically scrollable daily, weekly, monthly and custom views with built in resource support, templating and drag & drop.
The four views - scheduler, calendar, timeline, agenda - can be combined to create the perfect user experience on mobile, desktop and on everything in-between.

The capabilities like recurring events, all-day, multi-day events, responsiveness, multiple timezones are supported by all views.

As part of Event calendar and scheduler it can be picked up with the Scheduling & calendaring and Complete licenses.

React Scheduler Scheduler for React

Scheduler - Mobile Day View

Change demo

View daily schedules with a fixed week view at the top and a scrollable schedule for the day. The week view is optional and can be turned off.

All-day events are fixed at the top below the header and calendar.

The dates can be quickly navigated by clicking on the month & year indicator.

Interested in weekly schedule?  Explore this example →

Scheduler - Daily View

Change demo

Daily schedules can be displayed on large screens as well as small screens.

All-day events are fixed at the top below the header and calendar, while the schedule view is scrollable.

The dates can be quickly navigated by clicking on the month & year indicator.

Interested in weekly schedule?  Explore this example →

Scheduler - Week View on Mobile

Change demo

A full week can be rendered on small screens if needed. The header with the days of the week fixed at the top while the schedule is scrollable.

The screen can easily become crowded so it might be a good idea to think in a responsive implementation - daily schedule on small screens and weekly schedule on bigger screens.

Interested in daily schedule?  Explore this example →
Copy code
import { Eventcalendar, getJson, setOptions, Toast  } from '@mobiscroll/react';
import { useCallback, useEffect, useMemo, useState } from 'react';

setOptions({
  locale:  ,
  theme: ' ',
  themeVariant: ' '
});

function App() {
  const [myEvents, setEvents] = useState([]);
  const [isToastOpen, setToastOpen] = useState(false);
  const [toastText, setToastText] = useState();

  const myView = useMemo(
    () => ({
      scheduler: { type: 'week' },
    }),
    [],
  );

  const handleCloseToast = useCallback(() => {
    setToastOpen(false);
  }, []);

  const handleEventClick = useCallback((args) => {
    setToastText(args.event.title);
    setToastOpen(true);
  }, []);

  useEffect(() => {
    getJson(
      'https://trial.mobiscroll.com/events/?vers=5',
      (events) => {
        setEvents(events);
      },
      'jsonp',
    );
  }, []);

  return (
    <>
      <Eventcalendar
        clickToCreate={ }
        dragToCreate={ }
        dragToMove={ }
        dragToResize={ }
        eventDelete={ }
        data={myEvents}
        view={myView}
        onEventClick={handleEventClick}
      />
      <Toast message={toastText} isOpen={isToastOpen} onClose={handleCloseToast} />
    </>
  );
}

export default App;
import {
  Eventcalendar,
  getJson,
  MbscCalendarEvent,
  MbscEventcalendarView,
  MbscEventClickEvent,
  setOptions,
  Toast ,
} from '@mobiscroll/react';
import { FC, useCallback, useEffect, useMemo, useState } from 'react';

setOptions({
  locale:  ,
  theme: ' ',
  themeVariant: ' '
});

const App: FC = () => {
  const [myEvents, setEvents] = useState<MbscCalendarEvent[]>([]);
  const [isToastOpen, setToastOpen] = useState<boolean>(false);
  const [toastText, setToastText] = useState<string>();

  const myView = useMemo<MbscEventcalendarView>(
    () => ({
      scheduler: { type: 'week' },
    }),
    [],
  );

  const handleCloseToast = useCallback(() => {
    setToastOpen(false);
  }, []);

  const handleEventClick = useCallback((args: MbscEventClickEvent) => {
    setToastText(args.event.title);
    setToastOpen(true);
  }, []);

  useEffect(() => {
    getJson(
      'https://trial.mobiscroll.com/events/?vers=5',
      (events: MbscCalendarEvent[]) => {
        setEvents(events);
      },
      'jsonp',
    );
  }, []);

  return (
    <>
      <Eventcalendar
        clickToCreate={ }
        dragToCreate={ }
        dragToMove={ }
        dragToResize={ }
        eventDelete={ }
        data={myEvents}
        view={myView}
        onEventClick={handleEventClick}
      />
      <Toast message={toastText} isOpen={isToastOpen} onClose={handleCloseToast} />
    </>
  );
};
export default App;
<div id="content"></div>
Show a full week on mobile with the Scheduler — weekly schedule with all-day and timed events, scrollable time grid, and fixed header.

Scheduler - Week View

Change demo

Render a full weeks worth of schedule on the screen. The header with days of the week remains planted at the top while the grid with the hours of the week and scheduled events is scrollable.

The current hour is displayed so that upcoming events can be spotted easily.

Interested in daily schedule?  Explore this example →

Scheduler - Responsive Day and Week Views

Change demo

The scheduler is fully responsive, it adapts to the available space and fills the screen to look good everywhere.

Use the responsive option to configure how the scheduler behaves on different sized screens. You can set it up as a daily schedule view on small screens and a weekly schedule on bigger screens.

The responsive option is equipped with five breakpoints - xsmall, small, medium, large, xlarge - and custom values can be added for a perfect fine-tune.

Change the viewport

Scheduler - Custom Column Widths

Change demo

Customize the width of scheduler columns using the .mbsc-schedule-col-width CSS class. This allows you to define fixed or dynamic column widths to fit your layout needs.

When using resources, the defined width is applied to resource columns. If no resources are present, it applies to day columns instead.

Interested in individually adjusting resource widths?  Discover how →

Scheduler - Print and PDF Export

Change demo

The scheduler includes print optimized styling through the print add-on. This needs to be added to the download package or installed separately from a dedicated NPM package.

Print styling is applied when someone prints the page that contains the scheduler. In addition to that, you can call the print method on the instance which grabs only the markup of the scheduler, places it onto a temporary page and calls the browsers printing function. This is especially useful when you want to add a button to only print the scheduler rather than the whole page.

Besides printing, PDF export is possible through the print dialog of the browser.

The print module is not available in the trial. You can try the live demo to see how it looks.

Scheduler - Work Week

Change demo

Customize the scheduler by not only disabling certain hours but hide them through setting the startTime and endTime properties of the view.schedule option. Quikcly set up a work calendar that goes from Monday through Friday with the startDay and endDay properties and renders the schedule from 8AM to 6PM.

You can easily add breaks - like a "Lunch break" - or disable times with the invalid option.

Scheduler - Appointment Booking Demo

Change demo

The scheduler can be set up for scheduling/unscheduling booked appointments. Simply set up a daily schedule view with multiple resources representing dentists or doctors. Next to the calendar you can render a list of unscheduled appointments.

Enabling advanced validation and combining that with the drag & drop between the calendar and external list on a resource to resource basis you got a pretty nice working base for appointment scheduling that can be further customized.

Scheduler - Doctors Availability

Change demo

You can tailor the scheduler to show availability per doctor using visual indicators in each column. Availability is marked with a green status track on the left side of each doctor's column, making open slots easy to spot and supporting quick scheduling decisions.

To create the visual indicator, we added extra resource columns with a narrow width, styled using a custom CSS class set via the cssClass property in the resource data. The availability track is shown using events placed on these columns, with their content hidden via renderSchedulerEvent option and resized responsively based on the narrow resource column width. Time ranges outside each doctor's working hours are disabled to reflect their actual schedule.

Scheduler - 24-Hour Rotating Crew Shift Rota

Change demo

The scheduler can be configured for industrial or service environments requiring 24/7 coverage, such as manufacturing lines or critical infrastructure maintenance. This setup uses three resources (Crew A, Crew B, Crew C) to demonstrate a cyclical, rotating roster, like the 3-Crew, 3-Shift Rota.

To visualize the continuous operation and manage shifts that span midnight, the scheduler view is configured with a custom, 24-hour cycle, starting at 06:00 and ending at 06:00 the following day. This is achieved using the custom day-offset feature added to the startTime (e.g., '20:00-1') and endTime (e.g., '08:00+1') properties under the view option, which initiates the view relative to the previous or next calendar day. Furthermore, to ensure compliance with 8-hour shift lengths and prevent invalid scheduling, the drag-and-drop functionality is constrained by setting the dragTimeStep to 8 hours, requiring all events to be moved only in 8-hour increments and anchoring the alignment with the dragTimeStepBase: 'viewStart' option. The drag-and-drop logic is implemented for automatic conflict resolution: when an event is dragged to a different time or resource column within the same day, it automatically updates and shifts any conflicting events (those sharing the same time slot or resource column) to maintain scheduling integrity and prevent overlaps.

Scheduler - Drop Assignee on Event

Change demo

Assigning people to meetings that are already booked across multiple rooms is a common scheduling challenge. Instead of dropping external items onto the calendar grid to create new events, the goal here is to drop them onto existing events, turning each meeting into an individual drop target where attendees can be assigned directly.

This is where the dropcontainer comes in. Each event rendered through the renderSchedulerEvent function is initialized as a drop container, turning every meeting card into a valid drop zone. The external list of team members is set up using the draggable component, so each person can be grabbed and dropped onto any event on the scheduler. The onItemDrop event handles the assignment, while onItemDragEnter and onItemDragLeave provide real-time visual feedback.

Beyond simple assignment, the demo includes practical validation. Before accepting a drop, it checks whether the person is already assigned to the target meeting and whether they have a time conflict with another meeting in the same slot. Assignments can also be removed by clicking on an attendee chip, with an undo option.

Looking for dropping external items onto the calendar grid instead?  Check out the external drag & drop example →

Scheduler - Custom Range View

Change demo

The scheduler comes with built-in support for day, week and month views. For those situations where a custom range makes more sense, it is possible to override the calendar navigation component with a range picker.

The calendar header can be easily customized and a two-way synchronization needs to be kept between the scheduler and range picker.

Scheduler - Limit Overlapping Events

Change demo

The scheduler renders all concurrent (overlapping) events by default, and the available horizontal space will be divided between them. When there are a lot of concurrent events, displaying all of them isn't always helpful.

A maximum number of concurrent events can be set by passing a number to the maxEventStack property of the view.scheduler option.

Alternatively maxEventStack: 'auto' can also be set, in this case the value will be determined automatically, based on the available horizontal space. It's poosible to also set a minimum event width, using the minEvenWidth property of the view.scheduler option. If not specified, it defaults to 50px;

Scheduler - Custom Date Range View

Change demo

The scheduler has three types: day, week and month. Use the size property of the configuration object to set the length of the range.

Multiples of days, weeks and months are supported. The reference date, controlled through the refDate option, is today by default, but it can be set to any date, like the first day of the month, or the first day of the year. The refDate serves as the start of the reference range. From that point on you can navigate forward and backward.

A couple of examples:

  • Rolling two weeks - use type: 'day' and size: 14
  • Rolling ten days - use type: 'day' and size: 10
  • Two weeks (starting with Sun/Mon) - use type: 'week' and size: 2
  • Quarter view, starting from January - use type: 'month' and size: 3 with refDate: '2021-01-01'
  • Rolling three months - use type: 'month' and size: 3
  • Year view - use type: 'month' and size: 12 with refDate: '2021-01-01'

Scheduler - Hide All-Day Section

Change demo

Hide the all-day events section of the scheduler by setting the allDay property under the view.scheduler option.

Scheduler - Color-Coded Time Blocks

Change demo

Color the background of entire days or time ranges with the colors option. You can specify backgrounds as exact dates, ranges or set up recurring rules. The recurring object works the same way as for the events. Optionally, you can specify a title as well, which will be displayed on the colored block.

Use the onPageLoading lifecycle event to color backgrounds runtime. You can learn about lifecycle events and places where to drop logic to customize the experience.

Want to use patterns as backgrounds and customize how the invalid cells look?  Learn how to do it →

Scheduler - Switch Between Calendar and Scheduler Views

Change demo
Switch Between Calendar and Scheduler Views
Get started with this example

Dynamically switch views within one instance. Use a UI control to let users do the switching or do it programmatically.

The example features a month view with events as labels, a weekly schedule view, a daily schedule and a weekly agenda. Use property binding and when the value of the property changes the settings propagate.

Scheduler - Visible hours and days

Change demo

Customize the visible days and hours along with the scale of the time grid through the scheduler object under the view option. You can control the days to display (eg. Weekdays), the visible time range (eg. 8AM to 6PM), set the time scale (eg. 30 minutes) and set the labels shown (eg. every 15 minutes).

  • Specify the first and last day - Use the startDay and endDay properties
  • Set the visible time range - Use the startTime and endTime properties
  • Shift the visible time window - Use the startTime and endTime properties to include ranges that extend into the previous or next day
  • Control the visibility of empty columns - Use the hideEmptyColumns property
  • Control the visibility of fully invalid columns - Use the hideInvalidColumns property
  • Control the granularity of the time grid - Use the timeCellStep and timeLabelStep properties
Building a work calendar?  Check out this example →

Scheduler - Timezone Support

Change demo

The event calendar works with local times by default, but ships with support for changing the timezone. The conversions and correct output relies on either of these three external libraries: luxon, moment-timezone and day.js. For installing and using these libraries check out this guide.

There are two angles regarding timezones:

  • dataTimezone - the calendar expects this format and returns this format. It is 'local' by default if the date-times don't contain any timezone information.

It can be set globally on the calendar using the dataTimezone option, or specifically for the event using the timezone property of the event data.

  • displayTimezone - the calendar displays the events in this timezone. The date-times will be converted from the dataTimezone and displayed accordingly. It is 'local' by default
Enable switching the timezone in the UI?  Learn how to dynamically change timezones →

Scheduler - Event Buffer

Change demo

Use the bufferBefore and bufferAfter to add buffer times that will be rendered before and after the event.

These areas can help you visualize delays or added minutes for tasks. Here are some examples:

  • Travel time for meetings, appointments, work orders
  • Check in and check out times around flights
  • Loading/unloading for bus/truck
  • Cleaning, inspection, maintenance work that happen on a recurring basis
Looking to customize event buffers?  Check out the templating capabilities →

Scheduler - Multiple Timezone Support

Change demo

If the context requires users being able to change the timezone on the fly, you can add a custom dropdown with the desired timezones to the event calendar header. This can be of course placed externally to the calendar as well, eg. setting page.

Set the timezone of the incoming data through the dataTimezone - eg. 'utc', and set the display timezone through the displayTimezone - eg. 'America/Los_Angeles'

Wanna show multiple timezone tracks?  Check out the next example →

Scheduler - Custom Event Order

Change demo

The rendering engine uses the following two concepts to determine how the events are rendered:

  1. Event data order
  2. Event layout

The data order is determined by the following logic:

  • All-day events are placed at the top
  • Non-all-day events follow, sorted by their start times
  • Events with the same start time are ordered alphabetically by their title

The event layout process determines the visual positioning and dimensions of events. This is a built-in functionality and cannot be altered externally. The layout algorithm processes the sorted event list and calculates each event's position and size. The algorithm follows these steps:

  1. The first event is placed in the first position of the event column
  2. If two or more events overlap in their start/end times, the later event is placed in the next event column, positioned after to the previous event
  3. If a subsequent event does not overlap with any already added events, it is placed back in the first event column
  4. This process continues until all events are positioned within their respective columns

The order property of the event data can be used to override the default ordering. The order property takes precedence over the default rules. If two events have the same order value, the default rules apply. For a more advanced order logic, the eventOrder option can be used which expects a function that compares two events and returns an order (-1 or 1).

Do you want to learn about the event ordering?  Learn more about it in the documentation →

Scheduler - Multi-Timezone

Change demo

When operating across multiple timezones, coordinating resources and getting people on the same page is a challenge. It helps if events can be seen across these timezones.

Use the timezones property of the view.scheduler option and set the timezone tracks with custom labels. The order of the tracks is determined by the order they are added to the array.

Scheduler - Event Search Sidebar

Change demo

Inline search can be easily implemented with the help of a separate agenda instance. This example is relying on a single API endpoint for getting the data onto the primary schedule view and also for getting the filtered data based on the search terms.

Events can be filtered in real time so using an agenda view for the search results is an easy choice. It provides all the necessary styling and advanced features that you might need to customize the experience.

Alternatively, search can be implemented in the header using a similar search box with an agenda listed in a popup instead of rendered inline.

Scheduler - External Date Navigation

Change demo

This example demonstrates how can the Scheduler navigated externally. Here we have a two-pane layout with a Datepicker on the left and a Scheduler on the right. Changing date on the Datepicker will trigger the date change on the Scheduler.

The Datepicker updates the selectedDate option of the Scheduler in its onChange event, while the Scheduler updates the datepicker value from its onSelectedDateChange event.

Scheduler - Custom Event Tooltip

Change demo

There are several approaches to showing a tooltip when hovering events.

The native tooltip

By default, the calendar shows the browser native tooltip when hovering over the event. This includes the times and title of the event, which does the job most of the times. For showing a custom text use the tooltip property of the data object. This tooltip is specific to every event. If you want to hide the native tooltip, you can set the showEventTooltip to false.

Fully custom tooltip

Setting the showEventTooltip to false gives room for a fully custom tooltip that can be implemented by using the onEventHoverIn and onEventHoverOut lifecycle events. With the help of the Mobiscroll popup you can show a custom tooltip that holds details, actions applicable to the event it is anchored to.

Showing a third party popup

There are cases when you are using a third party library, something like md-boostrap. For those cases, turn the browser native tooltip off with the showEventTooltip option and use the third-party tooltip accordingly. In case of md-boostrap, you can add the tooltip directive to the custom event template so that the library knows where and when to show the tooltip.

Scheduler - Custom Event Rendering

Change demo

Above the built in rendering mode you can either customize the full event or just the content of the event. If we break up the event into pieces there are six fields that we are interested in:

  • The event start and end time
  • Whether it is an allDay event or not
  • The event color
  • The event title
  • bufferBefore
  • bufferAfter

The scheduler takes care of positioning the event container and everything else is your responsibility. You will have to place and provide styling to all event fields. Beside the ones mentioned above you'll be able to render other custom fields, like description, location, participants ... and add buttons, custom interactions.

Pass a custom rendering function to the renderSchedulerEvent option. All original event fields along with computed fields like isMultiDay, lastDay can be reached inside the function.

The before/after buffers can help you visualise delays or added minutes for tasks. For example travel time for meetings/appointments, check in/check out for flights.

The buffers can be customized through the renderBufferBefore and renderBufferAfter options.

Scheduler - Custom Date Header

Change demo

Customize the date headers of the scheduler by adding relevant content, labels or completely change how they look. Use the renderSchedulerDay option for rendering a custom date header.

Scheduler - Custom Resource Headers

Change demo

Use the renderResource option for rendering a custom resource header. Customize how the resource headers look and what they show. Utilize properties passed in the resources array.

Interested in displaying resource information on hover?  Show details on hover →

Scheduler - Custom Cell Content Template

Change demo

Events appear over scheduler cells, which provide a great background layer for information. They can be disabled, styled with colored backgrounds, or used to present rich content.

Cell content in the scheduler can be customized using the renderCell option. The callback receives cell data such as the date, resource, and overlapping events in the cell. This lets you add custom content like icons or badges to cells based on their data. It's useful for showing holidays, availability, or statuses.

Cells can be hourly, 30 minute long, or however it is setup using the timeCellStep option.

Scheduler - Custom Header

Change demo

You can customize how the header of the scheduler looks and how the components are arranged. Besides that you can also add custom functionality, like a segmented control that lets people switch between scheduler and calendar.

Use the renderHeader option for passing a custom header layout. There are predefined components - shorthands if you will - that can be used to assemble the header:

  • Navigation component - <CalendarNav />. Use the .md-header-filter-controls CSS class for custom overrides.
  • Today button - <CalendarToday />. Use the .md-header-filter-today CSS class for custom overrides.
  • Previous month button - <CalendarPrev />. Use the .md-header-filter-prev CSS class for custom overrides.
  • Next month button - <CalendarNext />. Use the .md-header-filter-next CSS class for custom overrides.

For changing the order the controls are laid out, you only need to set up the renderHeader. This example sets a consistent order and layout across all themes and shows a custom control at the far right end.

Overriding the order for specific themes

For a custom order on a theme to theme basis, you will need to use a little CSS. Flex layout makes reordering easy. It's just a matter of setting the order in CSS. For material use the .mbsc-material, for windows the .mbsc-windows prefix and for iOS it is .mbsc-ios class. Eg.:

.mbsc-material .md-header-filter-prev { order: 1; }
            .mbsc-material .md-header-filter-next { order: 2; }
            .mbsc-material .md-header-filter-controls { order: 3; }
            .mbsc-material .md-header-filter-today { order: 4; }
Want to add a filter to the header?  Check out the next example →

Scheduler - Drag, Resize and Create Events

Change demo

Drag & drop is a core feature of the event calendar and it is composed of four sub-features:

  • Click to create events - double click to create events. This can be turned off or set to single click
  • Drag to create events - tap/click to start creating an event and drag to the desired length
  • Move events - grab an event and move it wherever needed
  • Resize events - change the length of an event, grab it from either end and resize it
  • Delete events - pressing the Delete or Backspace keys on the keyboard will delete the focused event

You have granular control over features through the clickToCreate, dragToCreate, dragToMove, dragToResize and eventDelete options, which are false by default.

Use the dragTimeStep option (defaults to 15 minutes) to set the snap resolution of all drag actions.

Events can be marked as fixed by setting their editable property to false. This turns delete, drag & drop move and resize off for the event. The mbsc-event-readonly CSS class will be added to the events. This means if you would like to add opacity, override the mouse cursor or apply any other CSS override, you can add it to this class.

Scheduler - Drag, Resize & Move Restrictions

Change demo

The drag & drop interactions can be fine-tuned depending on the requirements and situations. Maybe controlled by roles, event types, resources the move and resize can be turned on/off on an event basis, per resource or globally on the instance.

  • Events can be fixed in length (cannot be resized) - by setting dragToResize option to false the events cannot be resized.
  • Events can be fixed in time (cannot be moved) - by setting dragInTime option to false the events cannot be moved in time. Take in consideration that dragToMove must be set to true
  • Events can be fixed to resource (cannot be moved to another resource) - by setting dragBetweenResources option to false the events cannot be moved between resources. Take in consideration that dragToMove must be set to true

To control this on a resource an event basis, use the appropriate properties which have precedence over global calendar options.

Scheduler - Instance Event Transfer

Change demo

There are certain cases when moving the events between calendars can come in handy.

Dragging and dropping events between two scheduler instances can be enabled by turning on the externalDrag and externalDrop options.

Scheduler - Blocked Time Ranges

Change demo

Entire days and time ranges can be blocked out to manage event creation and editing more efficiently.

To disable specific times, ranges, days or recurring days and times you can pass an array to the invalid option. A couple of examples:

  • To disable weekends, use the recurring object - recurring: { repeat: 'weekly', weekDays: 'SA,SU' }
  • Lunch break between 12 PM and 1 PM with title - { start: "12:00", end: "13:00", title: 'Lunch break', recurring: { repeat: 'weekly', weekDays: 'MO,TU,WE,TH,FR' }

When dragging events onto disabled days or time-slots, they will automatically be denied and onEventCreateFailed / onEventUpdateFailed events will be triggered, from which custom logic can be executed to show a toast or maybe a modal for data correction. The built-in logic of how the calendar handles validation on user interaction can be controlled through the invalidateEvent option:

  • 'strict' - Strict being the default, no event overlap is allowed with invalid ranges.
  • 'start-end' - With start-end validation the calendar checks if the start or end of the event coincides with any invalid range. Other overlaps are allowed.

If you're interested in invalids for a given range (including recurring occurrences), you can use the getInvalids function.

Want to prevent double booking?  Learn how to manage event overlaps →

Scheduler - Prevent Double Booking

Change demo

Sometimes it is necessary to guarantee that events don't overlap - eg. when scheduling workorders, interacting with a work calendar. You can reject the updates or additions and let the user know about it.

The event overlap can be turned on/off on an event basis, per resource or globally on the instance.

  • On an event basis - by setting the overlap property to false the specified event cannot overlap.
  • Per resource - by setting the eventOverlap property to false the events in the specified resource cannot overlap.
  • Globally on the instance - by setting eventOverlap option to false overlap is disbled globally.

If set to false, the resource and the event settings have precedence over the global calendar eventOverlap option.

Give feedback to the user - optionally, a toast can be displayed to explain why an event cannot be dropped, moved or created. For this we can use the onEventCreateFailed and onEventUpdateFailed lifecycle events.

Looking to implement time off or block out ranges?  Learn how to add lunch breaks, working hours and disable weekends →

Scheduler - External Drag and Drop

Change demo
Dragging events on the Mobiscroll event calendar

Events can be scheduled by dragging and dropping an external item onto the scheduler with Mobiscroll draggable. In order for that to work you will need to have two things set up:

  • Enable the scheduler to receive external events by setting externalDrop to true.
  • Initialize the external events (containers) as draggable components.

Use the Draggable component to specify a skeleton event through its dragData option and reference the draggable container in the element option. The dragData accepts a full event definition that will be added to the event calendar on drop. If omitted, a default event will be created.

Working together with SortableJS and Dragula lists

Mobiscroll provides built-in support for two widely used reorderable drag-and-drop list libraries: SortableJS and Dragula. If you are already using any of these libraries to reorder list items, they can be seamlessly integrated with the scheduler. This integration enables a smooth workflow where items can be dragged from external lists and scheduled directly onto the calendar.

Events can be created and scheduled by dragging items from third-party lists into the event calendar. To enable this behavior you will need to:

  • Allow the scheduler to receive external drops by setting externalDrop.
  • Use the sortableJsDraggable or dragulaDraggable plugins to connect the third-party list with the scheduler.

The event data will be read from the dragged element's data-drag-data attribute, or the plugin's options expose an eventData function where the event definition (title, start, end, resource, etc.) can be specified.

You can then handle the calendars lifecycle events such as onEventCreate, onEventCreated or onEventCreateFailed to run custom logic (e.g. showing a toast) when a drop succeeds or fails.

Unscheduling events (or dragging them off a calendar)

Additionally events can be unscheduled by dragging them out from the scheduler and dropping them onto an external drop container. To activate this, you will need to:

  • Enable the scheduler to allow dragging events out by setting externalDrag to true.
  • Initialize the

dropcontainer.

Events can also be dropped on another event calendar with externalDrop enabled.

When an event is dropped into an external drop container or another calendar, it will be deleted from the original calendar and the onEventDelete will be fired.

You can also use the onEventDragLeave and onEventDragEnter, and the drop container's onItemDragEnter and onItemDragLeave events to provide visual feedback or running custom logic during drag.

Learn more from the external drag & drop documentation.

Unscheduling events to SortableJS and Dragula lists

Dropping events from the Eventcalendar to SortableJS and Dragula lists is also possible with the sortableJsDraggable and dragulaDraggable plugins. To enable this behavior you will need to set the following under the options configuration:

  • Allow the list to receive external drops by setting exteralDrop to true
  • Use the onExternalDrop callback to update the content of the third-party list. The function arguments return the afterElement - the list element before which the clone is dropped,

container - the list container, dragData - the dragged event data, position - the index where the clone is dropped on the list.

For details, and option lists see the externalDrop section in the documentation

Looking for external drag into a calendar?  Check out this example →

Scheduler - External Preset Task Scheduling

Change demo

Use external draggable events to create preset tasks that people can quickly copy and spawn events from. A great example is an auto repair shop where among others, mechanics have to perform the same predefined tasks.

Print a list of predefined tasks and initialize them as draggable elements. Enable externalDrop for the scheduler and set up the predefined event skeletons for the draggable component.

Whenever there is more information to be captured, like detailed task notes, customer information, the name of the technician... you can trigger a popup with the task form in the onEventCreate lifecycle event. For failed drops (trying to schedule a task during lunch breaks or weekends) the event-create-failed onEventCreateFailed event will be triggered.

Want to see how external presets look & feel for a calendar?  Check out this example →

Scheduler - Multi-Resource View

Change demo

The scheduler can handle multiple resources inside a single instance. Pass the resource list to the resources option with an id, name, color and eventCreation.

  • id - This is an id that can be referenced in the event data
  • name - The name of the resource that will be printed at the top of the respective column
  • color - The color controls the default event color of the resource. Event colors can be specific above this. If the color is omitted the underlying events will inherit the default calendar color
  • eventCreation - This controls if events can be created or dropped onto this resource

The resources in which the resources appear follows the order of the array passed to the component.

Events can be shared between resources and it is possible to move events between resources. The move is handled automatically however you can block it if moving an event from one resource to the other is prohibited. Learn about lifecycle event hooks.

Scheduler - Group by Resource or Date

Change demo

Resources show up in the header of the calendar as the primary group and below them are the days. This can be switched up through the groupBy option that expects 'resource' or 'day'.

Combined with the day and week-view you can help people quickly find what they are looking for. Learn how to add an integrated segmented control to the header.

Scheduler - Shared Events Across Resources

Change demo

Events can be shared among resources. This can easily be the same resource type, like people in a shared work calendar scenario or different resource types, like aircraft and instructor in a flight training scenario where you'll have to schedule an instructor and an aircraft for a class which is the event.

Shared events will render correctly in the appropriate resource columns with drag & drop, validation across invalid dates and times will work out of the box. All you need to do is to add both resourceIDs to the event.

Scheduler - Dynamic Resource Filtering

Change demo

Resources can be dynamically turned on and off. This will show or hide the resource and can be done runtime the same way as for any other calendar option.

Scheduler - Dynamic Resource Widths

Change demo

When resource content varies, fixed widths might not work well. To handle this, you can define a few preset width classes in CSS, and assign them conditionally using the cssClass property in the resource data based on the content.

This approach lets you adapt the layout dynamically and ensure each resource column has the right width for its content.

Scheduler - Resource Data Structure

Change demo

The resource data structure for the scheduler is straightforward with a couple of base properties that the component understands and uses to render the UI. Besides the base properties you can add any custom property, like title, job ...

  • id - This is an id that can be referenced in the event data
  • name - The name of the resource that will be printed at the top of the respective column
  • color - The color controls the default event color of the resource. Event colors can be specific above this. If the color is omitted the underlying events will inherit the default calendar color
  • eventCreation - This controls if events can be created or dropped onto this resource
  • eventDragBetweenResources - Specifies whether the events in the specified resource are movable across resources. If set to false has precedence over dragBetweenResources option of the calendar.
  • eventDragInTime - Specifies whether the events in the specified resource are movable in time. If set to false has precedence over dragInTime option of the calendar.
  • eventResize - Specifies whether the events in the specified resource are resizable. If set to false has precedence over dragToResize option of the calendar.
  • eventOverlap - Specifies whether the events in the specified resource are allowed to overlap. If set to false has precedence over eventOverlap option of the calendar.

Scheduler - Hide Resources

Change demo

The scheduler can automatically hide non-working resource columns using the hideInvalidColumns property of view option.

The calendar is set to a weekly view (Monday to Friday, 8:00–20:00) and displays multiple doctors as resources, each with unique working days. Recurring invalids are used to mark specific weekdays when a doctor is unavailable, while static invalids indicate individual days off. As a result, only the columns for resources who are working on a given day are shown, making the schedule cleaner and easier to read. This approach is ideal for managing staff with varying shifts and availability.

Scheduler - Event Data Structure

Change demo

The event data structure for the scheduler is straightforward with a couple of base properties that the component understands and uses to render the UI. Besides the base properties you can add any custom property, like location, description ...

  • id - A unique ID for the event. If not specified a unique id will be generated
  • title - Defines the event text. This can be plaintext or HTML
  • tooltip - Defines the text for the tooltip which appears on mouse hover. If not specified, it will show the title and the start/end times of the event.
  • color - Defines the event color
  • start - Sets the start date and time for the event. It can be a js date object, ISO date string or moment.js object. Learn about date formats
  • end - Sets the end date and time for the event. The same formats are supported as for start
  • allDay - Configures the event as a full-day event
  • recurring - Configures the recurring rules for the event. Learn about recurring events
  • recurringException - Represents the exceptions of a recurring event, when specific dates need to be skipped from the rule.
  • recurringExceptionRule - Represents the exception rule of a recurring event, when recurring dates need to be skipped from the rule.
  • resource - Links the event to one or more resources. Expects a list of IDs from the resources array
  • timezone - The timezone where the event takes place. If specified, it takes precedence over the calendar's specified dataTimezone.
  • dragBetweenResources - Specifies whether the event is movable across resources. If set to false has precedence over eventDragBetweenResources property in resources and the dragBetweenResources option of the calendar.
  • dragInTime - Specifies whether the event is movable in time. If set to false has precedence over eventDragInTime property in resources and the dragInTime option of the calendar.
  • resize - Specifies whether the event is resizable. If set to false has precedence over eventResize property in resources and the dragToResize option of the calendar.
  • overlap - Specifies whether overlap is allowed on the event. If set to false has precedence over eventOverlap property in resources and the eventOverlap option of the calendar.
  • editable - Denotes if the event is editable. If set false, the event cannot be dragged, resized or deleted even if globally enabled
  • cssClass - A custom css class for the event. Useful for quick styling adjustments of the event container.
  • bufferBefore - Defines a buffer time in minutes that will be rendered before the start of the event. This buffer area can help you visualise delays or added minutes for tasks.

For example travel time for meetings/appointments, check in before a flight.

  • bufferAfter - Defines a buffer time in minutes that will be rendered after the end of the event. This buffer area can help you visualise delays or added minutes for tasks.

For example travel time after meetings/appointments, check out after flights, inspection, cleaning after certain tasks.

  • order - Specifies the order of the event in the event array. Has precedence over the default ordering rules.

Scheduler - Date Input Formats

Change demo

Understanding how to work with dates inside the scheduler is essential. You can pass to the data, marked, colors and labels in four different formats. The scheduler can work with Javascript date objects, ISO strings and Moment.js objects.

Scheduler - Recurring Events

Change demo

Configure daily, weekly, monthly and yearly recurring events. On top of setting up recurrence, you can exclude specific and recurring days. This is especially useful in cases when a single occurrence of an event is deleted or is moved to a different time.

You can pass the recurrence rule in the recurring property of the event as an object or a string in RRULE format. Learn about the event data structure and where to place the recurring rules.

Use the configurator to experiment, build strings and objects that you can grab and use.

Interested in adding recurrence configuration to your UI?  Take a look at this add/edit dialog →

Scheduler - Inline Data

Change demo

What is a scheduler without any events in it? To populate it with events all you have to do is pass the event array to the data option.

In a real-world scenario you would probably load the events from a remote resource or event better, load them on demand. However the point of this example is to understand how easy it is to add events to the scheduler.

Do you want to learn about the event data sctructure?  See how the event object is built →

Scheduler - Load Events from Remote API

Change demo

The scheduler can be populated by passing an array to the data option, that you can construct either inline or by getting it from a remote API. The important thing to remember is that events need to be in a format that the scheduler understands.

Interested in load on demand?  Dynamically load events on month change →

Scheduler - Load Events on Demand

Change demo

The scheduler supports remote and local data sources. Besides that, events can be populated on initialization or loaded on demand.

Getting the events in real time as the user navigates improves load performance and always serves the most recent data.

Use the onPageLoading lifecycle event to load the data runtime. You can learn about lifecycle events and places where to drop logic to customize the experience.

Interested in loading events from Google Calendar?  Show events from Google Calendar →

Scheduler - Lazy Load Events on Scroll

Change demo

The scheduler view is virtualized which means that the markup is being generated and maintained on the fly. Navigating both vertically and horizontally through scrolling fires the onVirtualLoading lifecycle event which can be used to load the data on scroll rather than load everything on initial page rendering.

This dramatically improves performance in case of a large event count since not all data is loaded in memory from start.

Scheduler - Large Dataset Performance

Change demo

The scheduler supports virtual horizontal and vertical scrolling. The view virtualization makes it possible to work with many resources across long date ranges.

The following examples shows that navigating 20 resources across a whole month with 2000 events won't pose any problems for the browser neither on mobile or desktop.

View virtualization is always enabled and doesn't need to be turned on explicitly.

Scheduler - Google Calendar Integration

Change demo

The event calendar comes with third party calendar integration support through the integration plugin. This needs to be added to the download package or installed separately from a dedicated NPM package.

It includes everything you need to authenticate your users, get their Google calendars and provides functions for CRUD operations. It takes care of loading the events and converts them to the required format so that they can be displayed on the Mobiscroll calendar separately or mixed with other calendars and events.

Customizing the interaction, event workflows, whether the events are read-only is up to you. In this live demo, newly created events will land in the primary calendar of the authenticated user.

This example uses the integration plugin to connect to and load events from Google Calendar and it is not available in the trial. Give the live demo a try and see how it can be configured.

Scheduler - Outlook Calendar Integration

Change demo

The event calendar comes with third party calendar integration support through the integration plugin. This needs to be added to the download package or installed separately from a dedicated NPM package.

It includes everything you need to authenticate your users, get their Outlook calendars and provides functions for CRUD operations. It takes care of loading the events and converts them to the required format so that they can be displayed on the Mobiscroll calendar separately or mixed with other calendars and events.

Customizing the interaction, event workflows, whether the events are read-only is up to you. In this live demo, newly created events will land in the primary calendar of the authenticated user.

This example uses the integration plugin to connect to and load events from Outlook Calendars and it is not available in the trial. Give the live demo a try and see how it can be configured.

Scheduler - Google Calendar Integration

Change demo

Event data can be loaded from remote sources, like public google calendars. Through the integration plugin you can easily show events that are available in a public calendar. The integration plugin needs to be added to the download package or installed separately from a dedicated NPM package.

You will just need the CALENDAR_ID and an apiKey from google and you should be ready to roll.

Public calendars are read-only. If you are interested in syncing private google calendars with read/write/delete access, check out this example.

This example uses the integration plugin to connect to and load events from Google Calendar and it is not available in the trial. Give the live demo a try and see how it can be configured.

Scheduler - Add, Edit and Delete Events

Change demo
Create new events

Drag to create and click to create is enabled. Events can be created by dragging or with double clicks. As soon as the initial position is confirmed, a temporary event is created and a custom edit dialog is shown for refinement. On cancel the temporary event will be removed and on confirmation the event will stay in the calendar.

Edit existing events

Drag to resize and drag to move is enabled. Events can be reordered and resized. In addition to that, clicking on the event will open a custom dialog that enables editing the various properties.

Delete events

Delete can be implemented inside the edit dialog with a button. It's just a matter of removing it from the data object. If a dialog is not shown on click, focused events can be deleted with the backspace and delete keys.

Interested in adding recurrence configuration?  Check out this example →

Scheduler - Bulk Event Actions

Change demo

Multiple event selection can be turned on with the selectMultipleEvents option. Selecting multiple events can be done through user interaction with CTRL/SHIFT/CMD + click or programmatically eg. click of a button or 'select all' checkbox.

Bulk operations like delete, update can be applied the selected events. Things like deleting with the backspace or delete buttons work out of the box but custom actions can be also applied. The selection can be easily retrieved and updated with the getSelectedEvents and setSelectedEvents method.

Custom actions can be performed with external buttons or with context menu activated on right-click.

Scheduler - Recurring Event Add & Edit

Change demo

As seen in the previous example, an add/edit form can be created with custom and base event fields. While the CRUD example features delete with undo, this example shows off how to build a fully customizable recurrence editor right in the add/edit screen.

Above some common presets, like Daily, Weekly on X day, Monthly on Xth, Annually on the same day, Every Weekday a fully custom recurrence editor is implemented.

Copy & paste or delve into the code and understand how to generate recurrence objects or RRULES as seen in this live rule builder.

Scheduler - Prevent Past Event Creation

Change demo

Sometimes we don't want users to be able to create events in the past or to alter past events. This might be role based in some cases or applied in general to the calendar.

To disable past event creation and manipulation, a couple of things need to be handled:

  • Invalidate past dates & times - this takes care of validating event drop and event creation on past dates and times that are before the past hour
  • Mark past events as fixed - to do this, set the editable property of the event object to false for the events that should remain fixed
  • Handle past occurrences of recurring events - recurring events are loaded as a single event and the occurrences are generated by the scheduler.

Moving the past occurrences need to be handled in the onEventUpdate and onEventCreate lifecycle events

  • Give feedback to the user - optionally, a toast can be displayed to give feedback to the user why an event cannot be dropped, moved and created in the past. For this we can use the

onEventCreateFailed and onEventUpdateFailed lifecycle events

Scheduler - CSS Classes for Cell Colors and Blocked Times

Change demo
CSS Classes for Cell Colors and Blocked Times
Get started with this example

Besides customizing the background color of cells and setting up invalid/blocked out times you can customize how these blocks and disabled times look by passing a cssClass to the colors and invalid array elements.

The output could be a custom pattern, custom styling for the labels or anything that you'd like to render as the background. This a great way for adding special meaning to certain days and time ranges.

Scheduler - Resource Filtering in Header

Change demo

The header of the scheduler is a canvas and an opportunity for customization. You can add custom components and enable new interaction in context.

Such an example would be a custom filter block created with the help of a segmented control and placed between the standard UI components, which are:

  • Navigation component - <CalendarNav />. Use the .md-header-filter-controls CSS class for custom overrides.
  • Today button - <CalendarToday />. Use the .md-header-filter-today CSS class for custom overrides.
  • Previous month button - <CalendarPrev />. Use the .md-header-filter-prev CSS class for custom overrides.
  • Next month button - <CalendarNext />. Use the .md-header-filter-next CSS class for custom overrides.

For changing the order the controls are laid out, you only need to set up the renderHeader.

Overriding the order for specific themes

For a custom order on a theme to theme basis, you will need to use a little CSS. Flex layout makes reordering easy. It's just a matter of setting the order in CSS. For material use the .mbsc-material, for windows the .mbsc-windows prefix and for iOS it is .mbsc-ios class. Eg.:

.mbsc-material .mds-header-filter-prev { order: 1; }
            .mbsc-material .mds-header-filter-next { order: 2; }
            .mbsc-material .mds-header-filter { order: 3; }
            .mbsc-material .mds-header-filter-today { order: 4; }
Want to style and reorder the header?  Take a look at the previous example →

Scheduler - Themes — iOS, Material & Windows

Change demo

The look and feel of the scheduler can be deeply customized. There are four levels of customization:

  • Base themes: Choose between iOS, Material and Windows.
  • Light or dark: Every theme has a light and dark variant. Setting the themeVariant to 'auto' will switch based on system settings.
  • Custom themes: Use the theme builder to customize the colors and make it match your brand.
  • Custom CSS: If you need further customization, the sky is the limit with CSS overrides.

You can also see how every example looks by changing the theme from the header.

Scheduler - Resource Background Styling

Change demo

Easily highlight resources or columns by adding a simple background color or craft a more specific look with the cssClass property of the resources data.

The output could be a custom background to individual resources or columns and it can be used for multiple purposes. For example:

  • Different styling for certain columns, like thicker border acting as separator.
  • Resource selection, where the selected resource has a different background.
  • Setting different backgrounds for the resource titles and grid columns.
Interested in highlighting date ranges only?  Explore this example →

Scheduler - Cell Hover Summary Tooltip

Change demo

This demo demonstrates how to surface detailed cell summaries through tooltips when hovering over schedule cells.

Using onCellHoverIn and onCellHoverOut events, each tooltip dynamically displays the total number of events, invalid and colors in the hovered cell.

Scheduler - Gregorian, Jalali & Hijri

Change demo

The scheduler supports multiple calendar systems. You can control it with the calendarSystem setting, and it supports the following options:

  • Gregorian - it is included by default
  • Jalali - it is the default system of the Persian calendar and is included within the Farsi language pack
  • Hijri - it is included in the Arabic language pack
Interested in localization?  Explore this example →

Scheduler - Event Hooks

Change demo

The scheduler ships with different hooks for deep customization. Events are triggered through the lifecycle of the component where you can tie in custom functionality and code.

While users interact with the UI events like onEventClick, onInit, onSelectedDateChange ... will be triggered.

For a complete list of events go to the documentation  See available lifecycle events →

Scheduler - Localization

Change demo

The components are fully localized. In case of the scheduler this covers date and time format, button copy, rtl and more. You can see how each example shows up by clicking on the small flag icon or checking the examples below.

All settings can be manually overridden  See what options the localization impacts →

Looking for something you didn't see or have a sales question?
Ask us about it, we're here to help.

Get started with Mobiscroll for Angular

Give the components a try locally and see how they look in your project.

Get started with Mobiscroll for React

Give the components a try locally and see how they look in your project.

Get started with Mobiscroll for Javascript

Give the components a try in a starter app or see how they look in your project.

Get started with Mobiscroll for Vue

Give the components a try locally and see how they look in your project.

Get started with Mobiscroll for jQuery

Give the components a try in a starter app or see how they look in your project.

Already have an account?
Get started with Mobiscroll for Angular

Give the components a try locally and see how they look in your project.

Get started with Mobiscroll for React

Give the components a try locally and see how they look in your project.

Get started with Mobiscroll for Javascript

Give the components a try in a starter app or see how they look in your project.

Get started with Mobiscroll for jQuery

Give the components a try in a starter app or see how they look in your project.

Get started with Mobiscroll for Vue

Give the components a try locally and see how they look in your project.

Already have an account?
Simple two minute install guide for jQuery
Step 1.
Copy resources
Step 2.
Add references
Step 3.
Copy the code
Step 4.
Refresh browser
Copy the downloaded JS and CSS folder into your project

Extract the downloaded zip (download again) and grab the two folders. Make sure to place it where it can be reached from your html file.

Alternatively you can run the example using our demo app.

file-copy-arrows

Or you can just simply try and play with the examples right from the folder you just unpacked. You don't find the downloaded example? Download it again.

Include the mobiscroll CSS and JS resources in your files

Add this script before the closing </head> tag of your file. Make sure to have jQuery loaded before this.

Copy code <link href="css/mobiscroll.jquery.min.css" rel="stylesheet" />
<script src="js/mobiscroll.jquery.min.js"></script>

Make sure to have the CSS and JS files copied over as explained in Step 1.

Copy the code into your app

Grab the relevant parts and drop them into your JS, HTML and CSS files.

Copy JS
Copy HTML
Copy CSS
Take a look at what you've accomplished

Reload your application in your favorite browser

arrow-browser-reload@2x

And voilà, everything should be running smoothly.

If something is not running correctly or if there is trouble

Check out these common errors and solutions or reach out and let us help you.

Keep things running smoothly

We have sent an email with verification instructions to you. Please make sure to follow the steps and verify it's you.

In case you fail to verify the account, the trial will be interrupted.

If you have any trouble

Don't hesitate to let us know.

install-help-bck
Simple two minute install guide for Javascript
Step 1.
Copy resources
Step 2.
Add references
Step 3.
Copy the code
Step 4.
Refresh browser
Copy the downloaded JS and CSS folders into your project

Extract the downloaded zip (download again) and grab the two folders. Make sure to place it where it can be reached from your html file.

Alternatively you can run the example using our demo app.

file-copy-arrows

Or you can just simply try and play with the examples right from the folder you just unpacked. You don't find the downloaded example? Download it again.

Include the mobiscroll CSS and JS resources in your files

Add this script before the closing </head> tag of your file

Copy code <link href="css/mobiscroll.javascript.min.css" rel="stylesheet" />
<script src="js/mobiscroll.javascript.min.js"></script>

Make sure to have the CSS and JS files copied over as explained in Step 1.

Copy the code into your app

Grab the relevant parts and drop them into your JS, HTML and CSS files.

Copy JS
Copy HTML
Copy CSS
Take a look at what you've accomplished

Reload your application in your favorite browser

arrow-browser-reload@2x

And voilà, everything should be running smoothly.

If something is not running correctly or if there is trouble

Check out these common errors and solutions or reach out and let us help you.

Keep things running smoothly

We have sent an email with verification instructions to you. Please make sure to follow the steps and verify it's you.

In case you fail to verify the account, the trial will be interrupted.

If you have any trouble

Don't hesitate to let us know.

install-help-bck
Simple two minute install guide
Step 1.
Install the CLI
Step 2.
Install Mobiscroll
Step 3.
Copy the code
Step 4.
Run the app
Install the Mobiscroll CLI from npm

You will be able to configure Mobiscroll with ease in your app with the CLI

Copy command $ npm install -g @mobiscroll/cli
Install Mobiscroll in your React project

Run the following command in the root folder of your React project.

Don't have a project? Try it with our demo app.

Copy command $ mobiscroll config react

You will be prompted to log in with your mobiscroll account. Set your password here.

Working behind a proxy?

If you're working behind a proxy server, additional configuration might be needed. Please check the proxy configuration options in the documentation.

Using a CI/CD workflow?

The package will be installed from a private npm registry, which requires authentication. If your project uses a CI/CD workflow, read this guide on how to make it work.

Copy the code into your app

Grab the relevant parts and drop them into your JSX and CSS files.

Copy JSX
Copy TSX
Copy CSS
Take a look at what you've accomplished

Run $ npm start in the root folder of your app

Copy command $ npm start

And voilà, everything should be running smoothly.

If something is not running correctly or if there is trouble

Check out these common errors and solutions or reach out and let us help you.

Keep things running smoothly

We have sent an email with verification instructions to you. Please make sure to follow the steps and verify it's you.

In case you fail to verify the account, the trial will be interrupted.

If you have any trouble

Don't hesitate to let us know.

install-help-bck
Simple two minute install guide
Step 1.
Install the CLI
Step 2.
Install Mobiscroll
Step 3.
Copy the code
Step 4.
Run the app
Install the Mobiscroll CLI from npm

You will be able to configure Mobiscroll with ease in your app with the CLI

Copy command $ npm install -g @mobiscroll/cli
Install Mobiscroll in your Angular project

Run the following command in the root folder of your Angular project.

Don't have a project? Try it with our demo app.

Copy command $ mobiscroll config angular

You will be prompted to log in with your mobiscroll account. Set your password here.

Working behind a proxy?

If you're working behind a proxy server, additional configuration might be needed. Please check the proxy configuration options in the documentation.

Using a CI/CD workflow?

The package will be installed from a private npm registry, which requires authentication. If your project uses a CI/CD workflow, read this guide on how to make it work.

Copy the code into your app

Grab the relevant parts and drop them into your Component and Template files. For quick testing copy the css to into your project's style.css or style.scss.

Copy TS
Copy HTML
Copy CSS
Take a look at what you've accomplished

Run $ ng serve in the root folder of your app

Copy command $ ng serve

And voilà, everything should be running smoothly.

If something is not running correctly or if there is trouble

Check out these common errors and solutions or reach out and let us help you.

Keep things running smoothly

We have sent an email with verification instructions to you. Please make sure to follow the steps and verify it's you.

In case you fail to verify the account, the trial will be interrupted.

If you have any trouble

Don't hesitate to let us know.

install-help-bck
Simple two minute install guide
Step 1.
Install the CLI
Step 2.
Install Mobiscroll
Step 3.
Copy the code
Step 4.
Run the app
Install the Mobiscroll CLI from npm

You will be able to configure Mobiscroll with ease in your app with the CLI

Copy command $ npm install -g @mobiscroll/cli
Install Mobiscroll in your Vue project

Run the following command in the root folder of your Vue project.

Don't have a project? Try it with our demo app.

Copy command $ mobiscroll config vue

You will be prompted to log in with your mobiscroll account. Set your password here.

Working behind a proxy?

If you're working behind a proxy server, additional configuration might be needed. Please check the proxy configuration options in the documentation.

Using a CI/CD workflow?

The package will be installed from a private npm registry, which requires authentication. If your project uses a CI/CD workflow, read this guide on how to make it work.

Copy the code into your app

Grab the relevant parts and drop them into your Vue page.

Copy
Copy
Take a look at what you've accomplished

Run $ npm run dev in the root folder of your app

Copy command $ npm run dev

And voilà, everything should be running smoothly.

If something is not running correctly or if there is trouble

Check out these common errors and solutions or reach out and let us help you.

Keep things running smoothly

We have sent an email with verification instructions to you. Please make sure to follow the steps and verify it's you.

In case you fail to verify the account, the trial will be interrupted.

If you have any trouble

Don't hesitate to let us know.

install-help-bck
Customize & try this demo locally
Sign in or start your free trial

We have to set you up with a trial for this to run 👍

Demos
Scheduler Mobile Day View Daily View Week View on Mobile Week View Responsive Day and Week Views Custom Column Widths Print and PDF Export Work Week Appointment Booking Demo Doctors Availability 24-Hour Rotating Crew Shift Rota Drop Assignee on Event Custom Range View Limit Overlapping Events Custom Date Range View Hide All-Day Section Color-Coded Time Blocks Switch Between Calendar and Scheduler Views Visible hours and days Timezone Support Event Buffer Multiple Timezone Support Custom Event Order Multi-Timezone Event Search Sidebar External Date Navigation Custom Event Tooltip Custom Event Rendering Custom Date Header Custom Resource Headers Custom Cell Content Template Custom Header Drag, Resize and Create Events Drag, Resize & Move Restrictions Instance Event Transfer Blocked Time Ranges Prevent Double Booking External Drag and Drop External Preset Task Scheduling Multi-Resource View Group by Resource or Date Shared Events Across Resources Dynamic Resource Filtering Dynamic Resource Widths Resource Data Structure Hide Resources Event Data Structure Date Input Formats Recurring Events Inline Data Load Events from Remote API Load Events on Demand Lazy Load Events on Scroll Large Dataset Performance Google Calendar Integration Outlook Calendar Integration Google Calendar Integration Add, Edit and Delete Events Bulk Event Actions Recurring Event Add & Edit Prevent Past Event Creation CSS Classes for Cell Colors and Blocked Times Resource Filtering in Header Themes — iOS, Material & Windows Resource Background Styling Cell Hover Summary Tooltip Gregorian, Jalali & Hijri Event Hooks Localization
Theme Select
Material
Material Dark
iOS
iOS Dark
Windows
Windows Dark
Language Locale
See other demos and change options
Theme
Locale
See other demos

Updated on Sep 23, 2026

Advanced Angular scheduler with configurable daily & weekly time grid

Use it in responsive mobile & desktop web apps and Ionic Angular projects

Recurring events
Multi-day events
Popover with full event list
Drag & drop
Templating
Resource support
Customizable times
Drag & drop
Manage multiple resources
Daily, weekly or monthly timeline
Drag & drop
Customizable range
Scroll to date
Recurring events
Templating
Daily, weekly or monthly agenda

The scheduler features a time grid - vertically scrollable daily, weekly, monthly and custom views with built in resource support, templating and drag & drop.
The four views - scheduler, calendar, timeline, agenda - can be combined to create the perfect user experience on mobile, desktop and on everything in-between.

The capabilities like recurring events, all-day, multi-day events, responsiveness, multiple timezones are supported by all views.

As part of Event calendar and scheduler it can be picked up with the Scheduling & calendaring and Complete licenses.

Angular and Ionic Scheduler Scheduler for Angular and Ionic Framework

Scheduler - Mobile Day View

Change demo

View daily schedules with a fixed week view at the top and a scrollable schedule for the day. The week view is optional and can be turned off.

All-day events are fixed at the top below the header and calendar.

The dates can be quickly navigated by clicking on the month & year indicator.

Interested in weekly schedule?  Explore this example →
Copy code
View code on GitHub

Scheduler - Daily View

Change demo

Daily schedules can be displayed on large screens as well as small screens.

All-day events are fixed at the top below the header and calendar, while the schedule view is scrollable.

The dates can be quickly navigated by clicking on the month & year indicator.

Interested in weekly schedule?  Explore this example →
Copy code
View code on GitHub

Scheduler - Week View on Mobile

Change demo

A full week can be rendered on small screens if needed. The header with the days of the week fixed at the top while the schedule is scrollable.

The screen can easily become crowded so it might be a good idea to think in a responsive implementation - daily schedule on small screens and weekly schedule on bigger screens.

Interested in daily schedule?  Explore this example →
Copy code
View code on GitHub
import { CommonModule } from '@angular/common';
import { HttpClient } from '@angular/common/http';
import { Component, OnInit } from '@angular/core';
import { MbscCalendarEvent, MbscEventcalendarOptions, MbscModule, Notifications, setOptions  } from '@mobiscroll/angular';

setOptions({
  locale:  ,
  theme: ' ',
  themeVariant: ' ',
});

@Component({
  selector: 'app-root', 
  templateUrl: './app.component.html',
  providers: [Notifications],
  standalone: true,
  imports: [CommonModule, MbscModule],
})
export class AppComponent implements OnInit {
  constructor(
    private http: HttpClient,
    private notify: Notifications,
  ) {}

  myEvents: MbscCalendarEvent[] = [];

  eventSettings: MbscEventcalendarOptions = {
    clickToCreate:  ,
    dragToCreate:  ,
    dragToMove:  ,
    dragToResize:  ,
    eventDelete:  ,
    view: {
      scheduler: { type: 'week' },
    },
    onEventClick: (args) => {
      this.notify.toast({
        message: args.event.title,
      });
    },
  };

  ngOnInit(): void {
    this.http.jsonp<MbscCalendarEvent[]>('https://trial.mobiscroll.com/events/?vers=5', 'callback').subscribe((resp) => {
      this.myEvents = resp;
    });
  }
}
<mbsc-eventcalendar [data]="myEvents" [options]="eventSettings"></mbsc-eventcalendar>
Show a full week on mobile with the Scheduler — weekly schedule with all-day and timed events, scrollable time grid, and fixed header.

Scheduler - Week View

Change demo

Render a full weeks worth of schedule on the screen. The header with days of the week remains planted at the top while the grid with the hours of the week and scheduled events is scrollable.

The current hour is displayed so that upcoming events can be spotted easily.

Interested in daily schedule?  Explore this example →
Copy code
View code on GitHub

Scheduler - Responsive Day and Week Views

Change demo

The scheduler is fully responsive, it adapts to the available space and fills the screen to look good everywhere.

Use the responsive option to configure how the scheduler behaves on different sized screens. You can set it up as a daily schedule view on small screens and a weekly schedule on bigger screens.

The responsive option is equipped with five breakpoints - xsmall, small, medium, large, xlarge - and custom values can be added for a perfect fine-tune.

Change the viewport

Scheduler - Custom Column Widths

Change demo

Customize the width of scheduler columns using the .mbsc-schedule-col-width CSS class. This allows you to define fixed or dynamic column widths to fit your layout needs.

When using resources, the defined width is applied to resource columns. If no resources are present, it applies to day columns instead.

Interested in individually adjusting resource widths?  Discover how →

Scheduler - Print and PDF Export

Change demo

The scheduler includes print optimized styling through the print add-on. This needs to be added to the download package or installed separately from a dedicated NPM package.

Print styling is applied when someone prints the page that contains the scheduler. In addition to that, you can call the print method on the instance which grabs only the markup of the scheduler, places it onto a temporary page and calls the browsers printing function. This is especially useful when you want to add a button to only print the scheduler rather than the whole page.

Besides printing, PDF export is possible through the print dialog of the browser.

The print module is not available in the trial. You can try the live demo to see how it looks.

Scheduler - Work Week

Change demo

Customize the scheduler by not only disabling certain hours but hide them through setting the startTime and endTime properties of the view.schedule option. Quikcly set up a work calendar that goes from Monday through Friday with the startDay and endDay properties and renders the schedule from 8AM to 6PM.

You can easily add breaks - like a "Lunch break" - or disable times with the invalid option.

Copy code
View code on GitHub

Scheduler - Appointment Booking Demo

Change demo

The scheduler can be set up for scheduling/unscheduling booked appointments. Simply set up a daily schedule view with multiple resources representing dentists or doctors. Next to the calendar you can render a list of unscheduled appointments.

Enabling advanced validation and combining that with the drag & drop between the calendar and external list on a resource to resource basis you got a pretty nice working base for appointment scheduling that can be further customized.

Copy code
View code on GitHub

Scheduler - Doctors Availability

Change demo

You can tailor the scheduler to show availability per doctor using visual indicators in each column. Availability is marked with a green status track on the left side of each doctor's column, making open slots easy to spot and supporting quick scheduling decisions.

To create the visual indicator, we added extra resource columns with a narrow width, styled using a custom CSS class set via the cssClass property in the resource data. The availability track is shown using events placed on these columns, with their content hidden via schedulerEventTemplate option and resized responsively based on the narrow resource column width. Time ranges outside each doctor's working hours are disabled to reflect their actual schedule.

Copy code
View code on GitHub

Scheduler - 24-Hour Rotating Crew Shift Rota

Change demo

The scheduler can be configured for industrial or service environments requiring 24/7 coverage, such as manufacturing lines or critical infrastructure maintenance. This setup uses three resources (Crew A, Crew B, Crew C) to demonstrate a cyclical, rotating roster, like the 3-Crew, 3-Shift Rota.

To visualize the continuous operation and manage shifts that span midnight, the scheduler view is configured with a custom, 24-hour cycle, starting at 06:00 and ending at 06:00 the following day. This is achieved using the custom day-offset feature added to the startTime (e.g., '20:00-1') and endTime (e.g., '08:00+1') properties under the view option, which initiates the view relative to the previous or next calendar day. Furthermore, to ensure compliance with 8-hour shift lengths and prevent invalid scheduling, the drag-and-drop functionality is constrained by setting the dragTimeStep to 8 hours, requiring all events to be moved only in 8-hour increments and anchoring the alignment with the dragTimeStepBase: 'viewStart' option. The drag-and-drop logic is implemented for automatic conflict resolution: when an event is dragged to a different time or resource column within the same day, it automatically updates and shifts any conflicting events (those sharing the same time slot or resource column) to maintain scheduling integrity and prevent overlaps.

Copy code
View code on GitHub

Scheduler - Drop Assignee on Event

Change demo

Assigning people to meetings that are already booked across multiple rooms is a common scheduling challenge. Instead of dropping external items onto the calendar grid to create new events, the goal here is to drop them onto existing events, turning each meeting into an individual drop target where attendees can be assigned directly.

This is where the dropcontainer comes in. Each event rendered through the schedulerEventTemplate function is initialized as a drop container, turning every meeting card into a valid drop zone. The external list of team members is set up using the draggable component, so each person can be grabbed and dropped onto any event on the scheduler. The onItemDrop event handles the assignment, while onItemDragEnter and onItemDragLeave provide real-time visual feedback.

Beyond simple assignment, the demo includes practical validation. Before accepting a drop, it checks whether the person is already assigned to the target meeting and whether they have a time conflict with another meeting in the same slot. Assignments can also be removed by clicking on an attendee chip, with an undo option.

Looking for dropping external items onto the calendar grid instead?  Check out the external drag & drop example →
Copy code
View code on GitHub

Scheduler - Custom Range View

Change demo

The scheduler comes with built-in support for day, week and month views. For those situations where a custom range makes more sense, it is possible to override the calendar navigation component with a range picker.

The calendar header can be easily customized and a two-way synchronization needs to be kept between the scheduler and range picker.

Copy code
View code on GitHub

Scheduler - Limit Overlapping Events

Change demo

The scheduler renders all concurrent (overlapping) events by default, and the available horizontal space will be divided between them. When there are a lot of concurrent events, displaying all of them isn't always helpful.

A maximum number of concurrent events can be set by passing a number to the maxEventStack property of the view.scheduler option.

Alternatively maxEventStack: 'auto' can also be set, in this case the value will be determined automatically, based on the available horizontal space. It's poosible to also set a minimum event width, using the minEvenWidth property of the view.scheduler option. If not specified, it defaults to 50px;

Scheduler - Custom Date Range View

Change demo

The scheduler has three types: day, week and month. Use the size property of the configuration object to set the length of the range.

Multiples of days, weeks and months are supported. The reference date, controlled through the refDate option, is today by default, but it can be set to any date, like the first day of the month, or the first day of the year. The refDate serves as the start of the reference range. From that point on you can navigate forward and backward.

A couple of examples:

  • Rolling two weeks - use type: 'day' and size: 14
  • Rolling ten days - use type: 'day' and size: 10
  • Two weeks (starting with Sun/Mon) - use type: 'week' and size: 2
  • Quarter view, starting from January - use type: 'month' and size: 3 with refDate: '2021-01-01'
  • Rolling three months - use type: 'month' and size: 3
  • Year view - use type: 'month' and size: 12 with refDate: '2021-01-01'

Scheduler - Hide All-Day Section

Change demo

Hide the all-day events section of the scheduler by setting the allDay property under the view.scheduler option.

Scheduler - Color-Coded Time Blocks

Change demo

Color the background of entire days or time ranges with the colors option. You can specify backgrounds as exact dates, ranges or set up recurring rules. The recurring object works the same way as for the events. Optionally, you can specify a title as well, which will be displayed on the colored block.

Use the onPageLoading lifecycle event to color backgrounds runtime. You can learn about lifecycle events and places where to drop logic to customize the experience.

Want to use patterns as backgrounds and customize how the invalid cells look?  Learn how to do it →
Copy code
View code on GitHub

Scheduler - Switch Between Calendar and Scheduler Views

Change demo
Switch Between Calendar and Scheduler Views
Get started with this example View code on GitHub

Dynamically switch views within one instance. Use a UI control to let users do the switching or do it programmatically.

The example features a month view with events as labels, a weekly schedule view, a daily schedule and a weekly agenda. Use property binding and when the value of the property changes the settings propagate.

Copy code
View code on GitHub

Scheduler - Visible hours and days

Change demo

Customize the visible days and hours along with the scale of the time grid through the scheduler object under the view option. You can control the days to display (eg. Weekdays), the visible time range (eg. 8AM to 6PM), set the time scale (eg. 30 minutes) and set the labels shown (eg. every 15 minutes).

  • Specify the first and last day - Use the startDay and endDay properties
  • Set the visible time range - Use the startTime and endTime properties
  • Shift the visible time window - Use the startTime and endTime properties to include ranges that extend into the previous or next day
  • Control the visibility of empty columns - Use the hideEmptyColumns property
  • Control the visibility of fully invalid columns - Use the hideInvalidColumns property
  • Control the granularity of the time grid - Use the timeCellStep and timeLabelStep properties
Building a work calendar?  Check out this example →

Scheduler - Timezone Support

Change demo

The event calendar works with local times by default, but ships with support for changing the timezone. The conversions and correct output relies on either of these three external libraries: luxon, moment-timezone and day.js. For installing and using these libraries check out this guide.

There are two angles regarding timezones:

  • dataTimezone - the calendar expects this format and returns this format. It is 'local' by default if the date-times don't contain any timezone information.

It can be set globally on the calendar using the dataTimezone option, or specifically for the event using the timezone property of the event data.

  • displayTimezone - the calendar displays the events in this timezone. The date-times will be converted from the dataTimezone and displayed accordingly. It is 'local' by default
Enable switching the timezone in the UI?  Learn how to dynamically change timezones →

Scheduler - Event Buffer

Change demo

Use the bufferBefore and bufferAfter to add buffer times that will be rendered before and after the event.

These areas can help you visualize delays or added minutes for tasks. Here are some examples:

  • Travel time for meetings, appointments, work orders
  • Check in and check out times around flights
  • Loading/unloading for bus/truck
  • Cleaning, inspection, maintenance work that happen on a recurring basis
Looking to customize event buffers?  Check out the templating capabilities →

Scheduler - Multiple Timezone Support

Change demo

If the context requires users being able to change the timezone on the fly, you can add a custom dropdown with the desired timezones to the event calendar header. This can be of course placed externally to the calendar as well, eg. setting page.

Set the timezone of the incoming data through the dataTimezone - eg. 'utc', and set the display timezone through the displayTimezone - eg. 'America/Los_Angeles'

Wanna show multiple timezone tracks?  Check out the next example →
Copy code
View code on GitHub

Scheduler - Custom Event Order

Change demo

The rendering engine uses the following two concepts to determine how the events are rendered:

  1. Event data order
  2. Event layout

The data order is determined by the following logic:

  • All-day events are placed at the top
  • Non-all-day events follow, sorted by their start times
  • Events with the same start time are ordered alphabetically by their title

The event layout process determines the visual positioning and dimensions of events. This is a built-in functionality and cannot be altered externally. The layout algorithm processes the sorted event list and calculates each event's position and size. The algorithm follows these steps:

  1. The first event is placed in the first position of the event column
  2. If two or more events overlap in their start/end times, the later event is placed in the next event column, positioned after to the previous event
  3. If a subsequent event does not overlap with any already added events, it is placed back in the first event column
  4. This process continues until all events are positioned within their respective columns

The order property of the event data can be used to override the default ordering. The order property takes precedence over the default rules. If two events have the same order value, the default rules apply. For a more advanced order logic, the eventOrder option can be used which expects a function that compares two events and returns an order (-1 or 1).

Do you want to learn about the event ordering?  Learn more about it in the documentation →
Copy code
View code on GitHub

Scheduler - Multi-Timezone

Change demo

When operating across multiple timezones, coordinating resources and getting people on the same page is a challenge. It helps if events can be seen across these timezones.

Use the timezones property of the view.scheduler option and set the timezone tracks with custom labels. The order of the tracks is determined by the order they are added to the array.

Copy code
View code on GitHub

Scheduler - Event Search Sidebar

Change demo

Inline search can be easily implemented with the help of a separate agenda instance. This example is relying on a single API endpoint for getting the data onto the primary schedule view and also for getting the filtered data based on the search terms.

Events can be filtered in real time so using an agenda view for the search results is an easy choice. It provides all the necessary styling and advanced features that you might need to customize the experience.

Alternatively, search can be implemented in the header using a similar search box with an agenda listed in a popup instead of rendered inline.

Copy code
View code on GitHub

Scheduler - External Date Navigation

Change demo

This example demonstrates how can the Scheduler navigated externally. Here we have a two-pane layout with a Datepicker on the left and a Scheduler on the right. Changing date on the Datepicker will trigger the date change on the Scheduler.

The Datepicker and the Scheduler binds to the same selected value which makes sure that the displayed dates will be in sync in both of the components. The Datepicker uses the ngModel binding and the Scheduler its selectedDate option to update the displayed date on the view.

Copy code
View code on GitHub

Scheduler - Event Tooltip

Change demo

There are several approaches to showing a tooltip when hovering events.

The native tooltip

By default, the calendar shows the browser native tooltip when hovering over the event. This includes the times and title of the event, which does the job most of the times. For showing a custom text use the tooltip property of the data object. This tooltip is specific to every event. If you want to hide the native tooltip, you can set the showEventTooltip to false.

Fully custom tooltip

Setting the showEventTooltip to false gives room for a fully custom tooltip that can be implemented by using the onEventHoverIn and onEventHoverOut lifecycle events. With the help of the Mobiscroll popup you can show a custom tooltip that holds details, actions applicable to the event it is anchored to.

Showing a third party popup

There are cases when you are using a third party library, something like md-boostrap. For those cases, turn the browser native tooltip off with the showEventTooltip option and use the third-party tooltip accordingly. In case of md-boostrap, you can add the tooltip directive to the custom event template so that the library knows where and when to show the tooltip.

Copy code
View code on GitHub

Scheduler - Event Rendering

Change demo

Above the built in rendering mode you can either customize the full event or just the content of the event. If we break up the event into pieces there are six fields that we are interested in:

  • The event start and end time
  • Whether it is an allDay event or not
  • The event color
  • The event title
  • bufferBefore
  • bufferAfter

The scheduler takes care of positioning the event container and everything else is your responsibility. You will have to place and provide styling to all event fields. Beside the ones mentioned above you'll be able to render other custom fields, like description, location, participants ... and add buttons, custom interactions.

Pass the event template to the schedulerEventTemplate option. All original event fields along with computed fields like isMultiDay, lastDay will be available inside the template.

The before/after buffers can help you visualise delays or added minutes for tasks. For example travel time for meetings/appointments, check in/check out for flights.

Templating the buffers are handled through the bufferBeforeTemplate and bufferAfterTemplate options.

Copy code
View code on GitHub

Scheduler - Custom Date Header

Change demo

Customize the date headers of the scheduler by adding relevant content, labels or completely change how they look. Use the schedulerDayTemplate option for setting up a custom date header template.

Copy code
View code on GitHub

Scheduler - Resource Headers

Change demo

Use the resourceTemplate option for setting up a custom resource header. Customize how the resource headers look and what they show. Utilize properties passed in the resources array.

Interested in displaying resource information on hover?  Show details on hover →
Copy code
View code on GitHub

Scheduler - Cell Content Template

Change demo

Events appear over scheduler cells, which provide a great background layer for information. They can be disabled, styled with colored backgrounds, or used to present rich content.

Cell content in the scheduler can be customized using the cellTemplate option. The callback receives cell data such as the date, resource, and overlapping events in the cell. This lets you add custom content like icons or badges to cells based on their data. It's useful for showing holidays, availability, or statuses.

Cells can be hourly, 30 minute long, or however it is setup using the timeCellStep option.

Copy code
View code on GitHub

Scheduler - Custom Header

Change demo

You can customize how the header of the scheduler looks and how the components are arranged. Besides that you can also add custom functionality, like a segmented control that lets people switch between scheduler and calendar.

Use the headerTemplate option for passing a custom template. There are predefined components - shorthands if you will - that can be used to assemble the header:

  • Navigation component - <mbsc-calendar-nav></mbsc-calendar-nav>. Use the .md-header-filter-controls CSS class for custom overrides.
  • Today button - <mbsc-calendar-today></mbsc-calendar-today>. Use the .md-header-filter-today CSS class for custom overrides.
  • Previous month button - <mbsc-calendar-prev></mbsc-calendar-prev>. Use the .md-header-filter-prev CSS class for custom overrides.
  • Next month button - <mbsc-calendar-next></mbsc-calendar-next>. Use the .md-header-filter-next CSS class for custom overrides.

For changing the order the controls are laid out, you only need to set up the headerTemplate. This example sets a consistent order and layout across all themes and shows a custom control at the far right end.

Overriding the order for specific themes

For a custom order on a theme to theme basis, you will need to use a little CSS. Flex layout makes reordering easy. It's just a matter of setting the order in CSS. For material use the .mbsc-material, for windows the .mbsc-windows prefix and for iOS it is .mbsc-ios class. Eg.:

.mbsc-material .md-header-filter-prev { order: 1; }
            .mbsc-material .md-header-filter-next { order: 2; }
            .mbsc-material .md-header-filter-controls { order: 3; }
            .mbsc-material .md-header-filter-today { order: 4; }
Want to add a filter to the header?  Check out the next example →
Copy code
View code on GitHub

Scheduler - Drag, Resize and Create Events

Change demo

Drag & drop is a core feature of the event calendar and it is composed of four sub-features:

  • Click to create events - double click to create events. This can be turned off or set to single click
  • Drag to create events - tap/click to start creating an event and drag to the desired length
  • Move events - grab an event and move it wherever needed
  • Resize events - change the length of an event, grab it from either end and resize it
  • Delete events - pressing the Delete or Backspace keys on the keyboard will delete the focused event

You have granular control over features through the clickToCreate, dragToCreate, dragToMove, dragToResize and eventDelete options, which are false by default.

Use the dragTimeStep option (defaults to 15 minutes) to set the snap resolution of all drag actions.

Events can be marked as fixed by setting their editable property to false. This turns delete, drag & drop move and resize off for the event. The mbsc-event-readonly CSS class will be added to the events. This means if you would like to add opacity, override the mouse cursor or apply any other CSS override, you can add it to this class.

Scheduler - Drag, Resize & Move Restrictions

Change demo

The drag & drop interactions can be fine-tuned depending on the requirements and situations. Maybe controlled by roles, event types, resources the move and resize can be turned on/off on an event basis, per resource or globally on the instance.

  • Events can be fixed in length (cannot be resized) - by setting dragToResize option to false the events cannot be resized.
  • Events can be fixed in time (cannot be moved) - by setting dragInTime option to false the events cannot be moved in time. Take in consideration that dragToMove must be set to true
  • Events can be fixed to resource (cannot be moved to another resource) - by setting dragBetweenResources option to false the events cannot be moved between resources. Take in consideration that dragToMove must be set to true

To control this on a resource an event basis, use the appropriate properties which have precedence over global calendar options.

Scheduler - Instance Event Transfer

Change demo

There are certain cases when moving the events between calendars can come in handy.

Dragging and dropping events between two scheduler instances can be enabled by turning on the externalDrag and externalDrop options.

Copy code
View code on GitHub

Scheduler - Blocked Time Ranges

Change demo

Entire days and time ranges can be blocked out to manage event creation and editing more efficiently.

To disable specific times, ranges, days or recurring days and times you can pass an array to the invalid option. A couple of examples:

  • To disable weekends, use the recurring object - recurring: { repeat: 'weekly', weekDays: 'SA,SU' }
  • Lunch break between 12 PM and 1 PM with title - { start: "12:00", end: "13:00", title: 'Lunch break', recurring: { repeat: 'weekly', weekDays: 'MO,TU,WE,TH,FR' }

When dragging events onto disabled days or time-slots, they will automatically be denied and onEventCreateFailed / onEventUpdateFailed events will be triggered, from which custom logic can be executed to show a toast or maybe a modal for data correction. The built-in logic of how the calendar handles validation on user interaction can be controlled through the invalidateEvent option:

  • 'strict' - Strict being the default, no event overlap is allowed with invalid ranges.
  • 'start-end' - With start-end validation the calendar checks if the start or end of the event coincides with any invalid range. Other overlaps are allowed.

If you're interested in invalids for a given range (including recurring occurrences), you can use the getInvalids function.

Want to prevent double booking?  Learn how to manage event overlaps →

Scheduler - Prevent Double Booking

Change demo

Sometimes it is necessary to guarantee that events don't overlap - eg. when scheduling workorders, interacting with a work calendar. You can reject the updates or additions and let the user know about it.

The event overlap can be turned on/off on an event basis, per resource or globally on the instance.

  • On an event basis - by setting the overlap property to false the specified event cannot overlap.
  • Per resource - by setting the eventOverlap property to false the events in the specified resource cannot overlap.
  • Globally on the instance - by setting eventOverlap option to false overlap is disbled globally.

If set to false, the resource and the event settings have precedence over the global calendar eventOverlap option.

Give feedback to the user - optionally, a toast can be displayed to explain why an event cannot be dropped, moved or created. For this we can use the onEventCreateFailed and onEventUpdateFailed lifecycle events.

Looking to implement time off or block out ranges?  Learn how to add lunch breaks, working hours and disable weekends →

Scheduler - External Drag and Drop

Change demo
Dragging events on the Mobiscroll event calendar

Events can be scheduled by dragging and dropping an external item onto the scheduler with Mobiscroll draggable. In order for that to work you will need to have two things set up:

  • Enable the scheduler to receive external events by setting externalDrop to true.
  • Initialize the external events (containers) as draggable components.

Set up a container as draggable with the mbsc-draggable directive. Pass a skeleton event definition through the dragData option which will be added to the event calendar on drop. If omitted, a default event will be created.

Working together with SortableJS and Dragula lists

Mobiscroll provides built-in support for two widely used reorderable drag-and-drop list libraries: SortableJS and Dragula. If you are already using any of these libraries to reorder list items, they can be seamlessly integrated with the scheduler. This integration enables a smooth workflow where items can be dragged from external lists and scheduled directly onto the calendar.

Events can be created and scheduled by dragging items from third-party lists into the event calendar. To enable this behavior you will need to:

  • Allow the scheduler to receive external drops by setting externalDrop.
  • Use the sortableJsDraggable or dragulaDraggable plugins to connect the third-party list with the scheduler.

The event data will be read from the dragged element's data-drag-data attribute, or the plugin's options expose an eventData function where the event definition (title, start, end, resource, etc.) can be specified.

You can then handle the calendars lifecycle events such as onEventCreate, onEventCreated or onEventCreateFailed to run custom logic (e.g. showing a toast) when a drop succeeds or fails.

Unscheduling events (or dragging them off a calendar)

Additionally events can be unscheduled by dragging them out from the scheduler and dropping them onto an external drop container. To activate this, you will need to:

  • Enable the scheduler to allow dragging events out by setting externalDrag to true.
  • Initialize the

dropcontainer.

Events can also be dropped on another event calendar with externalDrop enabled.

When an event is dropped into an external drop container or another calendar, it will be deleted from the original calendar and the onEventDelete will be fired.

You can also use the onEventDragLeave and onEventDragEnter, and the drop container's onItemDragEnter and onItemDragLeave events to provide visual feedback or running custom logic during drag.

Learn more from the external drag & drop documentation.

Unscheduling events to SortableJS and Dragula lists

Dropping events from the Eventcalendar to SortableJS and Dragula lists is also possible with the sortableJsDraggable and dragulaDraggable plugins. To enable this behavior you will need to set the following under the options configuration:

  • Allow the list to receive external drops by setting exteralDrop to true
  • Use the onExternalDrop callback to update the content of the third-party list. The function arguments return the afterElement - the list element before which the clone is dropped,

container - the list container, dragData - the dragged event data, position - the index where the clone is dropped on the list.

For details, and option lists see the externalDrop section in the documentation

Looking for external drag into a calendar?  Check out this example →
Copy code
View code on GitHub

Scheduler - External Task Presets

Change demo

Use external draggable events to create preset tasks that people can quickly copy and spawn events from. A great example is an auto repair shop where among others, mechanics have to perform the same predefined tasks.

Print a list of predefined tasks and initialize them as draggable elements. Enable externalDrop for the scheduler and set up the predefined event skeletons for the draggable component.

Whenever there is more information to be captured, like detailed task notes, customer information, the name of the technician... you can trigger a popup with the task form in the onEventCreate lifecycle event. For failed drops (trying to schedule a task during lunch breaks or weekends) the event-create-failed onEventCreateFailed event will be triggered.

Want to see how external presets look & feel for a calendar?  Check out this example →
Copy code
View code on GitHub

Scheduler - Multi-Resource View

Change demo

The scheduler can handle multiple resources inside a single instance. Pass the resource list to the resources option with an id, name, color and eventCreation.

  • id - This is an id that can be referenced in the event data
  • name - The name of the resource that will be printed at the top of the respective column
  • color - The color controls the default event color of the resource. Event colors can be specific above this. If the color is omitted the underlying events will inherit the default calendar color
  • eventCreation - This controls if events can be created or dropped onto this resource

The resources in which the resources appear follows the order of the array passed to the component.

Events can be shared between resources and it is possible to move events between resources. The move is handled automatically however you can block it if moving an event from one resource to the other is prohibited. Learn about lifecycle event hooks.

Copy code
View code on GitHub

Scheduler - Group by Resource or Date

Change demo

Resources show up in the header of the calendar as the primary group and below them are the days. This can be switched up through the groupBy option that expects 'resource' or 'day'.

Combined with the day and week-view you can help people quickly find what they are looking for. Learn how to add an integrated segmented control to the header.

Scheduler - Shared Events Across Resources

Change demo

Events can be shared among resources. This can easily be the same resource type, like people in a shared work calendar scenario or different resource types, like aircraft and instructor in a flight training scenario where you'll have to schedule an instructor and an aircraft for a class which is the event.

Shared events will render correctly in the appropriate resource columns with drag & drop, validation across invalid dates and times will work out of the box. All you need to do is to add both resourceIDs to the event.

Copy code
View code on GitHub

Scheduler - Dynamic Resource Filtering

Change demo

Resources can be dynamically turned on and off. This will show or hide the resource and can be done runtime the same way as for any other calendar option.

Copy code
View code on GitHub

Scheduler - Dynamic Resource Widths

Change demo

When resource content varies, fixed widths might not work well. To handle this, you can define a few preset width classes in CSS, and assign them conditionally using the cssClass property in the resource data based on the content.

This approach lets you adapt the layout dynamically and ensure each resource column has the right width for its content.

Copy code
View code on GitHub

Scheduler - Resource Data Structure

Change demo

The resource data structure for the scheduler is straightforward with a couple of base properties that the component understands and uses to render the UI. Besides the base properties you can add any custom property, like title, job ...

  • id - This is an id that can be referenced in the event data
  • name - The name of the resource that will be printed at the top of the respective column
  • color - The color controls the default event color of the resource. Event colors can be specific above this. If the color is omitted the underlying events will inherit the default calendar color
  • eventCreation - This controls if events can be created or dropped onto this resource
  • eventDragBetweenResources - Specifies whether the events in the specified resource are movable across resources. If set to false has precedence over dragBetweenResources option of the calendar.
  • eventDragInTime - Specifies whether the events in the specified resource are movable in time. If set to false has precedence over dragInTime option of the calendar.
  • eventResize - Specifies whether the events in the specified resource are resizable. If set to false has precedence over dragToResize option of the calendar.
  • eventOverlap - Specifies whether the events in the specified resource are allowed to overlap. If set to false has precedence over eventOverlap option of the calendar.

Scheduler - Hide Resources

Change demo

The scheduler can automatically hide non-working resource columns using the hideInvalidColumns property of view option.

The calendar is set to a weekly view (Monday to Friday, 8:00–20:00) and displays multiple doctors as resources, each with unique working days. Recurring invalids are used to mark specific weekdays when a doctor is unavailable, while static invalids indicate individual days off. As a result, only the columns for resources who are working on a given day are shown, making the schedule cleaner and easier to read. This approach is ideal for managing staff with varying shifts and availability.

Copy code
View code on GitHub

Scheduler - Event Data Structure

Change demo

The event data structure for the scheduler is straightforward with a couple of base properties that the component understands and uses to render the UI. Besides the base properties you can add any custom property, like location, description ...

  • id - A unique ID for the event. If not specified a unique id will be generated
  • title - Defines the event text. This can be plaintext or HTML
  • tooltip - Defines the text for the tooltip which appears on mouse hover. If not specified, it will show the title and the start/end times of the event.
  • color - Defines the event color
  • start - Sets the start date and time for the event. It can be a js date object, ISO date string or moment.js object. Learn about date formats
  • end - Sets the end date and time for the event. The same formats are supported as for start
  • allDay - Configures the event as a full-day event
  • recurring - Configures the recurring rules for the event. Learn about recurring events
  • recurringException - Represents the exceptions of a recurring event, when specific dates need to be skipped from the rule.
  • recurringExceptionRule - Represents the exception rule of a recurring event, when recurring dates need to be skipped from the rule.
  • resource - Links the event to one or more resources. Expects a list of IDs from the resources array
  • timezone - The timezone where the event takes place. If specified, it takes precedence over the calendar's specified dataTimezone.
  • dragBetweenResources - Specifies whether the event is movable across resources. If set to false has precedence over eventDragBetweenResources property in resources and the dragBetweenResources option of the calendar.
  • dragInTime - Specifies whether the event is movable in time. If set to false has precedence over eventDragInTime property in resources and the dragInTime option of the calendar.
  • resize - Specifies whether the event is resizable. If set to false has precedence over eventResize property in resources and the dragToResize option of the calendar.
  • overlap - Specifies whether overlap is allowed on the event. If set to false has precedence over eventOverlap property in resources and the eventOverlap option of the calendar.
  • editable - Denotes if the event is editable. If set false, the event cannot be dragged, resized or deleted even if globally enabled
  • cssClass - A custom css class for the event. Useful for quick styling adjustments of the event container.
  • bufferBefore - Defines a buffer time in minutes that will be rendered before the start of the event. This buffer area can help you visualise delays or added minutes for tasks.

For example travel time for meetings/appointments, check in before a flight.

  • bufferAfter - Defines a buffer time in minutes that will be rendered after the end of the event. This buffer area can help you visualise delays or added minutes for tasks.

For example travel time after meetings/appointments, check out after flights, inspection, cleaning after certain tasks.

  • order - Specifies the order of the event in the event array. Has precedence over the default ordering rules.

Scheduler - Date Input Formats

Change demo

Understanding how to work with dates inside the scheduler is essential. You can pass to the data, marked, colors and labels in four different formats. The scheduler can work with Javascript date objects, ISO strings and Moment.js objects.

Scheduler - Recurring Events

Change demo

Configure daily, weekly, monthly and yearly recurring events. On top of setting up recurrence, you can exclude specific and recurring days. This is especially useful in cases when a single occurrence of an event is deleted or is moved to a different time.

You can pass the recurrence rule in the recurring property of the event as an object or a string in RRULE format. Learn about the event data structure and where to place the recurring rules.

Use the configurator to experiment, build strings and objects that you can grab and use.

Interested in adding recurrence configuration to your UI?  Take a look at this add/edit dialog →

Scheduler - Inline Data

Change demo

What is a scheduler without any events in it? To populate it with events all you have to do is pass the event array to the data option.

In a real-world scenario you would probably load the events from a remote resource or event better, load them on demand. However the point of this example is to understand how easy it is to add events to the scheduler.

Do you want to learn about the event data sctructure?  See how the event object is built →
Copy code
View code on GitHub

Scheduler - Load Events from Remote API

Change demo

The scheduler can be populated by passing an array to the data option, that you can construct either inline or by getting it from a remote API. The important thing to remember is that events need to be in a format that the scheduler understands.

Interested in load on demand?  Dynamically load events on month change →
Copy code
View code on GitHub

Scheduler - Load Events on Demand

Change demo

The scheduler supports remote and local data sources. Besides that, events can be populated on initialization or loaded on demand.

Getting the events in real time as the user navigates improves load performance and always serves the most recent data.

Use the onPageLoading lifecycle event to load the data runtime. You can learn about lifecycle events and places where to drop logic to customize the experience.

Interested in loading events from Google Calendar?  Show events from Google Calendar →
Copy code
View code on GitHub

Scheduler - Lazy Load Events on Scroll

Change demo

The scheduler view is virtualized which means that the markup is being generated and maintained on the fly. Navigating both vertically and horizontally through scrolling fires the onVirtualLoading lifecycle event which can be used to load the data on scroll rather than load everything on initial page rendering.

This dramatically improves performance in case of a large event count since not all data is loaded in memory from start.

Copy code
View code on GitHub

Scheduler - Large Dataset Performance

Change demo

The scheduler supports virtual horizontal and vertical scrolling. The view virtualization makes it possible to work with many resources across long date ranges.

The following examples shows that navigating 20 resources across a whole month with 2000 events won't pose any problems for the browser neither on mobile or desktop.

View virtualization is always enabled and doesn't need to be turned on explicitly.

Copy code
View code on GitHub

Scheduler - Google Calendar Integration

Change demo

The event calendar comes with third party calendar integration support through the integration plugin. This needs to be added to the download package or installed separately from a dedicated NPM package.

It includes everything you need to authenticate your users, get their Google calendars and provides functions for CRUD operations. It takes care of loading the events and converts them to the required format so that they can be displayed on the Mobiscroll calendar separately or mixed with other calendars and events.

Customizing the interaction, event workflows, whether the events are read-only is up to you. In this live demo, newly created events will land in the primary calendar of the authenticated user.

This example uses the integration plugin to connect to and load events from Google Calendar and it is not available in the trial. Give the live demo a try and see how it can be configured.
Copy code
View code on GitHub

Scheduler - Outlook Calendar Integration

Change demo

The event calendar comes with third party calendar integration support through the integration plugin. This needs to be added to the download package or installed separately from a dedicated NPM package.

It includes everything you need to authenticate your users, get their Outlook calendars and provides functions for CRUD operations. It takes care of loading the events and converts them to the required format so that they can be displayed on the Mobiscroll calendar separately or mixed with other calendars and events.

Customizing the interaction, event workflows, whether the events are read-only is up to you. In this live demo, newly created events will land in the primary calendar of the authenticated user.

This example uses the integration plugin to connect to and load events from Outlook Calendars and it is not available in the trial. Give the live demo a try and see how it can be configured.
Copy code
View code on GitHub

Scheduler - Google Calendar Integration

Change demo

Event data can be loaded from remote sources, like public google calendars. Through the integration plugin you can easily show events that are available in a public calendar. The integration plugin needs to be added to the download package or installed separately from a dedicated NPM package.

You will just need the CALENDAR_ID and an apiKey from google and you should be ready to roll.

Public calendars are read-only. If you are interested in syncing private google calendars with read/write/delete access, check out this example.

This example uses the integration plugin to connect to and load events from Google Calendar and it is not available in the trial. Give the live demo a try and see how it can be configured.
Copy code
View code on GitHub

Scheduler - Add, Edit and Delete Events

Change demo
Create new events

Drag to create and click to create is enabled. Events can be created by dragging or with double clicks. As soon as the initial position is confirmed, a temporary event is created and a custom edit dialog is shown for refinement. On cancel the temporary event will be removed and on confirmation the event will stay in the calendar.

Edit existing events

Drag to resize and drag to move is enabled. Events can be reordered and resized. In addition to that, clicking on the event will open a custom dialog that enables editing the various properties.

Delete events

Delete can be implemented inside the edit dialog with a button. It's just a matter of removing it from the data object. If a dialog is not shown on click, focused events can be deleted with the backspace and delete keys.

Interested in adding recurrence configuration?  Check out this example →
Copy code
View code on GitHub

Scheduler - Bulk Event Actions

Change demo

Multiple event selection can be turned on with the selectMultipleEvents option. Selecting multiple events can be done through user interaction with CTRL/SHIFT/CMD + click or programmatically eg. click of a button or 'select all' checkbox.

Bulk operations like delete, update can be applied the selected events. Things like deleting with the backspace or delete buttons work out of the box but custom actions can be also applied. The selection can be easily retrieved and updated with the getSelectedEvents and setSelectedEvents method.

Custom actions can be performed with external buttons or with context menu activated on right-click.

Copy code
View code on GitHub

Scheduler - Recurring Event Add & Edit

Change demo

As seen in the previous example, an add/edit form can be created with custom and base event fields. While the CRUD example features delete with undo, this example shows off how to build a fully customizable recurrence editor right in the add/edit screen.

Above some common presets, like Daily, Weekly on X day, Monthly on Xth, Annually on the same day, Every Weekday a fully custom recurrence editor is implemented.

Copy & paste or delve into the code and understand how to generate recurrence objects or RRULES as seen in this live rule builder.

Copy code
View code on GitHub

Scheduler - Prevent Past Event Creation

Change demo

Sometimes we don't want users to be able to create events in the past or to alter past events. This might be role based in some cases or applied in general to the calendar.

To disable past event creation and manipulation, a couple of things need to be handled:

  • Invalidate past dates & times - this takes care of validating event drop and event creation on past dates and times that are before the past hour
  • Mark past events as fixed - to do this, set the editable property of the event object to false for the events that should remain fixed
  • Handle past occurrences of recurring events - recurring events are loaded as a single event and the occurrences are generated by the scheduler.

Moving the past occurrences need to be handled in the onEventUpdate and onEventCreate lifecycle events

  • Give feedback to the user - optionally, a toast can be displayed to give feedback to the user why an event cannot be dropped, moved and created in the past. For this we can use the

onEventCreateFailed and onEventUpdateFailed lifecycle events

Copy code
View code on GitHub

Scheduler - CSS Classes for Cell Colors and Blocked Times

Change demo
CSS Classes for Cell Colors and Blocked Times
Get started with this example View code on GitHub

Besides customizing the background color of cells and setting up invalid/blocked out times you can customize how these blocks and disabled times look by passing a cssClass to the colors and invalid array elements.

The output could be a custom pattern, custom styling for the labels or anything that you'd like to render as the background. This a great way for adding special meaning to certain days and time ranges.

Copy code
View code on GitHub

Scheduler - Resource Filtering in Header

Change demo

The header of the scheduler is a canvas and an opportunity for customization. You can add custom components and enable new interaction in context.

Such an example would be a custom filter block created with the help of a segmented control and placed between the standard UI components, which are:

  • Navigation component - <mbsc-calendar-nav></mbsc-calendar-nav>. Use the .md-header-filter-controls CSS class for custom overrides.
  • Today button - <mbsc-calendar-today></mbsc-calendar-today>. Use the .md-header-filter-today CSS class for custom overrides.
  • Previous month button - <mbsc-calendar-prev></mbsc-calendar-prev>. Use the .md-header-filter-prev CSS class for custom overrides.
  • Next month button - <mbsc-calendar-next></mbsc-calendar-next>. Use the .md-header-filter-next CSS class for custom overrides.

For changing the order the controls are laid out, you only need to set up the headerTemplate.

Overriding the order for specific themes

For a custom order on a theme to theme basis, you will need to use a little CSS. Flex layout makes reordering easy. It's just a matter of setting the order in CSS. For material use the .mbsc-material, for windows the .mbsc-windows prefix and for iOS it is .mbsc-ios class. Eg.:

.mbsc-material .mds-header-filter-prev { order: 1; }
            .mbsc-material .mds-header-filter-next { order: 2; }
            .mbsc-material .mds-header-filter { order: 3; }
            .mbsc-material .mds-header-filter-today { order: 4; }
Want to style and reorder the header?  Take a look at the previous example →
Copy code
View code on GitHub

Scheduler - Themes — iOS, Material & Windows

Change demo

The look and feel of the scheduler can be deeply customized. There are four levels of customization:

  • Base themes: Choose between iOS, Material and Windows.
  • Light or dark: Every theme has a light and dark variant. Setting the themeVariant to 'auto' will switch based on system settings.
  • Custom themes: Use the theme builder to customize the colors and make it match your brand.
  • Custom CSS: If you need further customization, the sky is the limit with CSS overrides.

You can also see how every example looks by changing the theme from the header.

Scheduler - Resource Background Styling

Change demo

Easily highlight resources or columns by adding a simple background color or craft a more specific look with the cssClass property of the resources data.

The output could be a custom background to individual resources or columns and it can be used for multiple purposes. For example:

  • Different styling for certain columns, like thicker border acting as separator.
  • Resource selection, where the selected resource has a different background.
  • Setting different backgrounds for the resource titles and grid columns.
Interested in highlighting date ranges only?  Explore this example →
Copy code
View code on GitHub

Scheduler - Cell Hover Summary Tooltip

Change demo

This demo demonstrates how to surface detailed cell summaries through tooltips when hovering over schedule cells.

Using onCellHoverIn and onCellHoverOut events, each tooltip dynamically displays the total number of events, invalid and colors in the hovered cell.

Copy code
View code on GitHub

Scheduler - Gregorian, Jalali & Hijri

Change demo

The scheduler supports multiple calendar systems. You can control it with the calendarSystem setting, and it supports the following options:

  • Gregorian - it is included by default
  • Jalali - it is the default system of the Persian calendar and is included within the Farsi language pack
  • Hijri - it is included in the Arabic language pack
Interested in localization?  Explore this example →

Scheduler - Event Hooks

Change demo

The scheduler ships with different hooks for deep customization. Events are triggered through the lifecycle of the component where you can tie in custom functionality and code.

While users interact with the UI events like onEventClick, onInit, onSelectedDateChange ... will be triggered.

For a complete list of events go to the documentation  See available lifecycle events →

Scheduler - Localization

Change demo

The components are fully localized. In case of the scheduler this covers date and time format, button copy, rtl and more. You can see how each example shows up by clicking on the small flag icon or checking the examples below.

All settings can be manually overridden  See what options the localization impacts →
Copy code
View code on GitHub

Looking for something you didn't see or have a sales question?
Ask us about it, we're here to help.

Get started with Mobiscroll for Angular

Give the components a try locally and see how they look in your project.

Get started with Mobiscroll for React

Give the components a try locally and see how they look in your project.

Get started with Mobiscroll for Javascript

Give the components a try in a starter app or see how they look in your project.

Get started with Mobiscroll for Vue

Give the components a try locally and see how they look in your project.

Get started with Mobiscroll for jQuery

Give the components a try in a starter app or see how they look in your project.

Already have an account?
Get started with Mobiscroll for Angular

Give the components a try locally and see how they look in your project.

Get started with Mobiscroll for React

Give the components a try locally and see how they look in your project.

Get started with Mobiscroll for Javascript

Give the components a try in a starter app or see how they look in your project.

Get started with Mobiscroll for jQuery

Give the components a try in a starter app or see how they look in your project.

Get started with Mobiscroll for Vue

Give the components a try locally and see how they look in your project.

Already have an account?
Simple two minute install guide for jQuery
Step 1.
Copy resources
Step 2.
Add references
Step 3.
Copy the code
Step 4.
Refresh browser
Copy the downloaded JS and CSS folder into your project

Extract the downloaded zip (download again) and grab the two folders. Make sure to place it where it can be reached from your html file.

Alternatively you can run the example using our demo app.

file-copy-arrows

Or you can just simply try and play with the examples right from the folder you just unpacked. You don't find the downloaded example? Download it again.

Include the mobiscroll CSS and JS resources in your files

Add this script before the closing </head> tag of your file. Make sure to have jQuery loaded before this.

Copy code <link href="css/mobiscroll.jquery.min.css" rel="stylesheet" />
<script src="js/mobiscroll.jquery.min.js"></script>

Make sure to have the CSS and JS files copied over as explained in Step 1.

Copy the code into your app

Grab the relevant parts and drop them into your JS, HTML and CSS files.

Copy JS
Copy HTML
Copy CSS
Take a look at what you've accomplished

Reload your application in your favorite browser

arrow-browser-reload@2x

And voilà, everything should be running smoothly.

If something is not running correctly or if there is trouble

Check out these common errors and solutions or reach out and let us help you.

Keep things running smoothly

We have sent an email with verification instructions to you. Please make sure to follow the steps and verify it's you.

In case you fail to verify the account, the trial will be interrupted.

If you have any trouble

Don't hesitate to let us know.

install-help-bck
Simple two minute install guide for Javascript
Step 1.
Copy resources
Step 2.
Add references
Step 3.
Copy the code
Step 4.
Refresh browser
Copy the downloaded JS and CSS folders into your project

Extract the downloaded zip (download again) and grab the two folders. Make sure to place it where it can be reached from your html file.

Alternatively you can run the example using our demo app.

file-copy-arrows

Or you can just simply try and play with the examples right from the folder you just unpacked. You don't find the downloaded example? Download it again.

Include the mobiscroll CSS and JS resources in your files

Add this script before the closing </head> tag of your file

Copy code <link href="css/mobiscroll.javascript.min.css" rel="stylesheet" />
<script src="js/mobiscroll.javascript.min.js"></script>

Make sure to have the CSS and JS files copied over as explained in Step 1.

Copy the code into your app

Grab the relevant parts and drop them into your JS, HTML and CSS files.

Copy JS
Copy HTML
Copy CSS
Take a look at what you've accomplished

Reload your application in your favorite browser

arrow-browser-reload@2x

And voilà, everything should be running smoothly.

If something is not running correctly or if there is trouble

Check out these common errors and solutions or reach out and let us help you.

Keep things running smoothly

We have sent an email with verification instructions to you. Please make sure to follow the steps and verify it's you.

In case you fail to verify the account, the trial will be interrupted.

If you have any trouble

Don't hesitate to let us know.

install-help-bck
Simple two minute install guide
Step 1.
Install the CLI
Step 2.
Install Mobiscroll
Step 3.
Copy the code
Step 4.
Run the app
Install the Mobiscroll CLI from npm

You will be able to configure Mobiscroll with ease in your app with the CLI

Copy command $ npm install -g @mobiscroll/cli
Install Mobiscroll in your React project

Run the following command in the root folder of your React project.

Don't have a project? Try it with our demo app.

Copy command $ mobiscroll config react

You will be prompted to log in with your mobiscroll account. Set your password here.

Working behind a proxy?

If you're working behind a proxy server, additional configuration might be needed. Please check the proxy configuration options in the documentation.

Using a CI/CD workflow?

The package will be installed from a private npm registry, which requires authentication. If your project uses a CI/CD workflow, read this guide on how to make it work.

Copy the code into your app

Grab the relevant parts and drop them into your JSX and CSS files.

Copy JSX
Copy TSX
Copy CSS
Take a look at what you've accomplished

Run $ npm start in the root folder of your app

Copy command $ npm start

And voilà, everything should be running smoothly.

If something is not running correctly or if there is trouble

Check out these common errors and solutions or reach out and let us help you.

Keep things running smoothly

We have sent an email with verification instructions to you. Please make sure to follow the steps and verify it's you.

In case you fail to verify the account, the trial will be interrupted.

If you have any trouble

Don't hesitate to let us know.

install-help-bck
Simple two minute install guide
Step 1.
Install the CLI
Step 2.
Install Mobiscroll
Step 3.
Copy the code
Step 4.
Run the app
Install the Mobiscroll CLI from npm

You will be able to configure Mobiscroll with ease in your app with the CLI

Copy command $ npm install -g @mobiscroll/cli
Install Mobiscroll in your Angular project

Run the following command in the root folder of your Angular project.

Don't have a project? Try it with our demo app.

Copy command $ mobiscroll config angular

You will be prompted to log in with your mobiscroll account. Set your password here.

Working behind a proxy?

If you're working behind a proxy server, additional configuration might be needed. Please check the proxy configuration options in the documentation.

Using a CI/CD workflow?

The package will be installed from a private npm registry, which requires authentication. If your project uses a CI/CD workflow, read this guide on how to make it work.

Copy the code into your app

Grab the relevant parts and drop them into your Component and Template files. For quick testing copy the css to into your project's style.css or style.scss.

Copy TS
Copy HTML
Copy CSS
Take a look at what you've accomplished

Run $ ng serve in the root folder of your app

Copy command $ ng serve

And voilà, everything should be running smoothly.

If something is not running correctly or if there is trouble

Check out these common errors and solutions or reach out and let us help you.

Keep things running smoothly

We have sent an email with verification instructions to you. Please make sure to follow the steps and verify it's you.

In case you fail to verify the account, the trial will be interrupted.

If you have any trouble

Don't hesitate to let us know.

install-help-bck
Simple two minute install guide
Step 1.
Install the CLI
Step 2.
Install Mobiscroll
Step 3.
Copy the code
Step 4.
Run the app
Install the Mobiscroll CLI from npm

You will be able to configure Mobiscroll with ease in your app with the CLI

Copy command $ npm install -g @mobiscroll/cli
Install Mobiscroll in your Vue project

Run the following command in the root folder of your Vue project.

Don't have a project? Try it with our demo app.

Copy command $ mobiscroll config vue

You will be prompted to log in with your mobiscroll account. Set your password here.

Working behind a proxy?

If you're working behind a proxy server, additional configuration might be needed. Please check the proxy configuration options in the documentation.

Using a CI/CD workflow?

The package will be installed from a private npm registry, which requires authentication. If your project uses a CI/CD workflow, read this guide on how to make it work.

Copy the code into your app

Grab the relevant parts and drop them into your Vue page.

Copy
Copy
Take a look at what you've accomplished

Run $ npm run dev in the root folder of your app

Copy command $ npm run dev

And voilà, everything should be running smoothly.

If something is not running correctly or if there is trouble

Check out these common errors and solutions or reach out and let us help you.

Keep things running smoothly

We have sent an email with verification instructions to you. Please make sure to follow the steps and verify it's you.

In case you fail to verify the account, the trial will be interrupted.

If you have any trouble

Don't hesitate to let us know.

install-help-bck
Customize & try this demo locally
Sign in or start your free trial

We have to set you up with a trial for this to run 👍

Demos
Scheduler Mobile Day View Daily View Week View on Mobile Week View Responsive Day and Week Views Custom Column Widths Print and PDF Export Work Week Appointment Booking Demo Doctors Availability 24-Hour Rotating Crew Shift Rota Drop Assignee on Event Custom Range View Limit Overlapping Events Custom Date Range View Hide All-Day Section Color-Coded Time Blocks Switch Between Calendar and Scheduler Views Visible hours and days Timezone Support Event Buffer Multiple Timezone Support Custom Event Order Multi-Timezone Event Search Sidebar External Date Navigation Event Tooltip Event Rendering Custom Date Header Resource Headers Cell Content Template Custom Header Drag, Resize and Create Events Drag, Resize & Move Restrictions Instance Event Transfer Blocked Time Ranges Prevent Double Booking External Drag and Drop External Task Presets Multi-Resource View Group by Resource or Date Shared Events Across Resources Dynamic Resource Filtering Dynamic Resource Widths Resource Data Structure Hide Resources Event Data Structure Date Input Formats Recurring Events Inline Data Load Events from Remote API Load Events on Demand Lazy Load Events on Scroll Large Dataset Performance Google Calendar Integration Outlook Calendar Integration Google Calendar Integration Add, Edit and Delete Events Bulk Event Actions Recurring Event Add & Edit Prevent Past Event Creation CSS Classes for Cell Colors and Blocked Times Resource Filtering in Header Themes — iOS, Material & Windows Resource Background Styling Cell Hover Summary Tooltip Gregorian, Jalali & Hijri Event Hooks Localization
Theme Select
Material
Material Dark
iOS
iOS Dark
Windows
Windows Dark
Language Locale
See other demos and change options
Theme
Locale
See other demos